using System;

namespace Godot
{
    /// <summary>
    /// Limits the frequencies in a range around the [member cutoff_hz] and allows frequencies outside of this range to pass.
    /// </summary>
    public class AudioEffectBandLimitFilter : AudioEffectFilter
    {
        private const string nativeName = "AudioEffectBandLimitFilter";

        public AudioEffectBandLimitFilter() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_AudioEffectBandLimitFilter_Ctor(this);
        }

        internal AudioEffectBandLimitFilter(bool memoryOwn) : base(memoryOwn) {}
    }
}
