using System;

namespace Godot
{
    /// <summary>
    /// Frequency bands :
    /// Band 1 : 31 Hz
    /// Band 2 : 62 Hz
    /// Band 3 : 125 Hz
    /// Band 4 : 250 Hz
    /// Band 5 : 500 Hz
    /// Band 6 : 1000 Hz
    /// Band 7 : 2000 Hz
    /// Band 8 : 4000 Hz
    /// Band 9 : 8000 Hz
    /// Band 10 : 16000 Hz
    /// See also [AudioEffectEQ], [AudioEffectEQ6], [AudioEffectEQ21].
    /// </summary>
    public class AudioEffectEQ10 : AudioEffectEQ
    {
        private const string nativeName = "AudioEffectEQ10";

        public AudioEffectEQ10() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_AudioEffectEQ10_Ctor(this);
        }

        internal AudioEffectEQ10(bool memoryOwn) : base(memoryOwn) {}
    }
}
