using System;

namespace Godot
{
    /// <summary>
    /// Frequency bands :
    /// Band 1 : 32 Hz
    /// Band 2 : 100 Hz
    /// Band 3 : 320 Hz
    /// Band 4 : 1000 Hz
    /// Band 5 : 3200 Hz
    /// Band 6 : 10000 Hz
    /// See also [AudioEffectEQ], [AudioEffectEQ10], [AudioEffectEQ21].
    /// </summary>
    public class AudioEffectEQ6 : AudioEffectEQ
    {
        private const string nativeName = "AudioEffectEQ6";

        public AudioEffectEQ6() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_AudioEffectEQ6_Ctor(this);
        }

        internal AudioEffectEQ6(bool memoryOwn) : base(memoryOwn) {}
    }
}
