using System;

namespace Godot
{
    /// <summary>
    /// Attenuates frequencies in a narrow band around the [member cutoff_hz] and cuts frequencies outside of this range.
    /// </summary>
    public class AudioEffectNotchFilter : AudioEffectFilter
    {
        private const string nativeName = "AudioEffectNotchFilter";

        public AudioEffectNotchFilter() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_AudioEffectNotchFilter_Ctor(this);
        }

        internal AudioEffectNotchFilter(bool memoryOwn) : base(memoryOwn) {}
    }
}
