using System;

namespace Godot
{
    public class AudioEffectStereoEnhance : AudioEffect
    {
        /// <summary>
        /// </summary>
        public float PanPullout
        {
            get
            {
                return GetPanPullout();
            }
            set
            {
                SetPanPullout(value);
            }
        }

        /// <summary>
        /// </summary>
        public float TimePulloutMs
        {
            get
            {
                return GetTimePullout();
            }
            set
            {
                SetTimePullout(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Surround
        {
            get
            {
                return GetSurround();
            }
            set
            {
                SetSurround(value);
            }
        }


        private const string nativeName = "AudioEffectStereoEnhance";

        public AudioEffectStereoEnhance() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_AudioEffectStereoEnhance_Ctor(this);
        }

        internal AudioEffectStereoEnhance(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_pan_pullout");

        [GodotMethod("set_pan_pullout")]
        public void SetPanPullout(float amount)
        {
            NativeCalls.godot_icall_1_10(method_bind_0, Object.GetPtr(this), amount);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_pan_pullout");

        [GodotMethod("get_pan_pullout")]
        public float GetPanPullout()
        {
            return NativeCalls.godot_icall_0_9(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_time_pullout");

        [GodotMethod("set_time_pullout")]
        public void SetTimePullout(float amount)
        {
            NativeCalls.godot_icall_1_10(method_bind_2, Object.GetPtr(this), amount);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_time_pullout");

        [GodotMethod("get_time_pullout")]
        public float GetTimePullout()
        {
            return NativeCalls.godot_icall_0_9(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_surround");

        [GodotMethod("set_surround")]
        public void SetSurround(float amount)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), amount);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_surround");

        [GodotMethod("get_surround")]
        public float GetSurround()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }
    }
}
