using System;

namespace Godot
{
    /// <summary>
    /// OGG Vorbis audio stream driver.
    /// </summary>
    public class AudioStreamOGGVorbis : AudioStream
    {
        public byte[] Data
        {
            get
            {
                return _GetData();
            }
            set
            {
                _SetData(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Loop
        {
            get
            {
                return HasLoop();
            }
            set
            {
                SetLoop(value);
            }
        }

        /// <summary>
        /// </summary>
        public float LoopOffset
        {
            get
            {
                return GetLoopOffset();
            }
            set
            {
                SetLoopOffset(value);
            }
        }


        private const string nativeName = "AudioStreamOGGVorbis";

        public AudioStreamOGGVorbis() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_AudioStreamOGGVorbis_Ctor(this);
        }

        internal AudioStreamOGGVorbis(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_set_data");

        internal void _SetData(byte[] data)
        {
            NativeCalls.godot_icall_1_131(method_bind_0, Object.GetPtr(this), data);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_get_data");

        internal byte[] _GetData()
        {
            return NativeCalls.godot_icall_0_132(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_loop");

        [GodotMethod("set_loop")]
        public void SetLoop(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_2, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "has_loop");

        [GodotMethod("has_loop")]
        public bool HasLoop()
        {
            return NativeCalls.godot_icall_0_3(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_loop_offset");

        [GodotMethod("set_loop_offset")]
        public void SetLoopOffset(float seconds)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), seconds);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_loop_offset");

        [GodotMethod("get_loop_offset")]
        public float GetLoopOffset()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }
    }
}
