using System;

namespace Godot
{
    public class BakedLightmap : VisualInstance
    {
        public enum BakeQualityEnum
        {
            Low = 0,
            Medium = 1,
            High = 2
        }

        public enum BakeError
        {
            Ok = 0,
            NoSavePath = 1,
            NoMeshes = 2,
            CantCreateImage = 3,
            UserAborted = 4
        }

        public enum BakeModeEnum
        {
            ConeTrace = 0,
            RayTrace = 1
        }


        /// <summary>
        /// </summary>
        public float BakeCellSize
        {
            get
            {
                return GetBakeCellSize();
            }
            set
            {
                SetBakeCellSize(value);
            }
        }

        /// <summary>
        /// </summary>
        public BakedLightmap.BakeQualityEnum BakeQuality
        {
            get
            {
                return GetBakeQuality();
            }
            set
            {
                SetBakeQuality(value);
            }
        }

        /// <summary>
        /// </summary>
        public BakedLightmap.BakeModeEnum BakeMode
        {
            get
            {
                return GetBakeMode();
            }
            set
            {
                SetBakeMode(value);
            }
        }

        /// <summary>
        /// </summary>
        public float BakePropagation
        {
            get
            {
                return GetPropagation();
            }
            set
            {
                SetPropagation(value);
            }
        }

        /// <summary>
        /// </summary>
        public float BakeEnergy
        {
            get
            {
                return GetEnergy();
            }
            set
            {
                SetEnergy(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool BakeHdr
        {
            get
            {
                return IsHdr();
            }
            set
            {
                SetHdr(value);
            }
        }

        /// <summary>
        /// </summary>
        public Vector3 BakeExtents
        {
            get
            {
                return GetExtents();
            }
            set
            {
                SetExtents(value);
            }
        }

        /// <summary>
        /// </summary>
        public float CaptureCellSize
        {
            get
            {
                return GetCaptureCellSize();
            }
            set
            {
                SetCaptureCellSize(value);
            }
        }

        /// <summary>
        /// </summary>
        public string ImagePath
        {
            get
            {
                return GetImagePath();
            }
            set
            {
                SetImagePath(value);
            }
        }

        /// <summary>
        /// </summary>
        public BakedLightmapData LightData
        {
            get
            {
                return GetLightData();
            }
            set
            {
                SetLightData(value);
            }
        }


        private const string nativeName = "BakedLightmap";

        public BakedLightmap() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_BakedLightmap_Ctor(this);
        }

        internal BakedLightmap(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_light_data");

        [GodotMethod("set_light_data")]
        public void SetLightData(BakedLightmapData data)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(data));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_light_data");

        [GodotMethod("get_light_data")]
        public BakedLightmapData GetLightData()
        {
            return NativeCalls.godot_icall_0_148(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_bake_cell_size");

        [GodotMethod("set_bake_cell_size")]
        public void SetBakeCellSize(float bakeCellSize)
        {
            NativeCalls.godot_icall_1_10(method_bind_2, Object.GetPtr(this), bakeCellSize);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_bake_cell_size");

        [GodotMethod("get_bake_cell_size")]
        public float GetBakeCellSize()
        {
            return NativeCalls.godot_icall_0_9(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_capture_cell_size");

        [GodotMethod("set_capture_cell_size")]
        public void SetCaptureCellSize(float captureCellSize)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), captureCellSize);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_capture_cell_size");

        [GodotMethod("get_capture_cell_size")]
        public float GetCaptureCellSize()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_bake_quality");

        [GodotMethod("set_bake_quality")]
        public void SetBakeQuality(BakedLightmap.BakeQualityEnum bakeQuality)
        {
            NativeCalls.godot_icall_1_149(method_bind_6, Object.GetPtr(this), bakeQuality);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_bake_quality");

        [GodotMethod("get_bake_quality")]
        public BakedLightmap.BakeQualityEnum GetBakeQuality()
        {
            return NativeCalls.godot_icall_0_150(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_bake_mode");

        [GodotMethod("set_bake_mode")]
        public void SetBakeMode(BakedLightmap.BakeModeEnum bakeMode)
        {
            NativeCalls.godot_icall_1_151(method_bind_8, Object.GetPtr(this), bakeMode);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_bake_mode");

        [GodotMethod("get_bake_mode")]
        public BakedLightmap.BakeModeEnum GetBakeMode()
        {
            return NativeCalls.godot_icall_0_152(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_extents");

        [GodotMethod("set_extents")]
        public void SetExtents(Vector3 extents)
        {
            NativeCalls.godot_icall_1_104(method_bind_10, Object.GetPtr(this), ref extents);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_extents");

        [GodotMethod("get_extents")]
        public Vector3 GetExtents()
        {
            object ret = NativeCalls.godot_icall_0_4(method_bind_11, Object.GetPtr(this));
            return (Vector3)ret;
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_propagation");

        [GodotMethod("set_propagation")]
        public void SetPropagation(float propagation)
        {
            NativeCalls.godot_icall_1_10(method_bind_12, Object.GetPtr(this), propagation);
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_propagation");

        [GodotMethod("get_propagation")]
        public float GetPropagation()
        {
            return NativeCalls.godot_icall_0_9(method_bind_13, Object.GetPtr(this));
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_energy");

        [GodotMethod("set_energy")]
        public void SetEnergy(float energy)
        {
            NativeCalls.godot_icall_1_10(method_bind_14, Object.GetPtr(this), energy);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_energy");

        [GodotMethod("get_energy")]
        public float GetEnergy()
        {
            return NativeCalls.godot_icall_0_9(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_hdr");

        [GodotMethod("set_hdr")]
        public void SetHdr(bool hdr)
        {
            NativeCalls.godot_icall_1_11(method_bind_16, Object.GetPtr(this), hdr);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_hdr");

        [GodotMethod("is_hdr")]
        public bool IsHdr()
        {
            return NativeCalls.godot_icall_0_3(method_bind_17, Object.GetPtr(this));
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_image_path");

        [GodotMethod("set_image_path")]
        public void SetImagePath(string imagePath)
        {
            NativeCalls.godot_icall_1_43(method_bind_18, Object.GetPtr(this), imagePath);
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_image_path");

        [GodotMethod("get_image_path")]
        public string GetImagePath()
        {
            return NativeCalls.godot_icall_0_2(method_bind_19, Object.GetPtr(this));
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "bake");

        /// <summary>
        /// </summary>
        [GodotMethod("bake")]
        public BakedLightmap.BakeError Bake(Node fromNode = null, bool createVisualDebug = false)
        {
            return NativeCalls.godot_icall_2_153(method_bind_20, Object.GetPtr(this), Object.GetPtr(fromNode), createVisualDebug);
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "debug_bake");

        /// <summary>
        /// </summary>
        [GodotMethod("debug_bake")]
        public void DebugBake()
        {
            NativeCalls.godot_icall_0_12(method_bind_21, Object.GetPtr(this));
        }
    }
}
