using System;

namespace Godot
{
    public class BakedLightmapData : Resource
    {
        /// <summary>
        /// </summary>
        public AABB Bounds
        {
            get
            {
                return GetBounds();
            }
            set
            {
                SetBounds(value);
            }
        }

        /// <summary>
        /// </summary>
        public Transform CellSpaceTransform
        {
            get
            {
                return GetCellSpaceTransform();
            }
            set
            {
                SetCellSpaceTransform(value);
            }
        }

        /// <summary>
        /// </summary>
        public int CellSubdiv
        {
            get
            {
                return GetCellSubdiv();
            }
            set
            {
                SetCellSubdiv(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Energy
        {
            get
            {
                return GetEnergy();
            }
            set
            {
                SetEnergy(value);
            }
        }

        /// <summary>
        /// </summary>
        public byte[] Octree
        {
            get
            {
                return GetOctree();
            }
            set
            {
                SetOctree(value);
            }
        }

        public object[] UserData
        {
            get
            {
                return _GetUserData();
            }
            set
            {
                _SetUserData(value);
            }
        }


        private const string nativeName = "BakedLightmapData";

        public BakedLightmapData() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_BakedLightmapData_Ctor(this);
        }

        internal BakedLightmapData(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_set_user_data");

        internal void _SetUserData(object[] data)
        {
            NativeCalls.godot_icall_1_154(method_bind_0, Object.GetPtr(this), data);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_get_user_data");

        internal object[] _GetUserData()
        {
            return NativeCalls.godot_icall_0_21(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_bounds");

        [GodotMethod("set_bounds")]
        public void SetBounds(AABB bounds)
        {
            NativeCalls.godot_icall_1_117(method_bind_2, Object.GetPtr(this), ref bounds);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_bounds");

        [GodotMethod("get_bounds")]
        public AABB GetBounds()
        {
            object ret = NativeCalls.godot_icall_0_118(method_bind_3, Object.GetPtr(this));
            return (AABB)ret;
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_cell_space_transform");

        [GodotMethod("set_cell_space_transform")]
        public void SetCellSpaceTransform(Transform xform)
        {
            NativeCalls.godot_icall_1_155(method_bind_4, Object.GetPtr(this), ref xform);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_cell_space_transform");

        [GodotMethod("get_cell_space_transform")]
        public Transform GetCellSpaceTransform()
        {
            object ret = NativeCalls.godot_icall_0_18(method_bind_5, Object.GetPtr(this));
            return (Transform)ret;
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_cell_subdiv");

        [GodotMethod("set_cell_subdiv")]
        public void SetCellSubdiv(int cellSubdiv)
        {
            NativeCalls.godot_icall_1_0(method_bind_6, Object.GetPtr(this), cellSubdiv);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_cell_subdiv");

        [GodotMethod("get_cell_subdiv")]
        public int GetCellSubdiv()
        {
            return NativeCalls.godot_icall_0_1(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_octree");

        [GodotMethod("set_octree")]
        public void SetOctree(byte[] octree)
        {
            NativeCalls.godot_icall_1_131(method_bind_8, Object.GetPtr(this), octree);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_octree");

        [GodotMethod("get_octree")]
        public byte[] GetOctree()
        {
            return NativeCalls.godot_icall_0_132(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_energy");

        [GodotMethod("set_energy")]
        public void SetEnergy(float energy)
        {
            NativeCalls.godot_icall_1_10(method_bind_10, Object.GetPtr(this), energy);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_energy");

        [GodotMethod("get_energy")]
        public float GetEnergy()
        {
            return NativeCalls.godot_icall_0_9(method_bind_11, Object.GetPtr(this));
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "add_user");

        /// <summary>
        /// </summary>
        [GodotMethod("add_user")]
        public void AddUser(NodePath path, Texture lightmap, int instance)
        {
            NativeCalls.godot_icall_3_156(method_bind_12, Object.GetPtr(this), NodePath.GetPtr(path), Object.GetPtr(lightmap), instance);
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_user_count");

        /// <summary>
        /// </summary>
        [GodotMethod("get_user_count")]
        public int GetUserCount()
        {
            return NativeCalls.godot_icall_0_1(method_bind_13, Object.GetPtr(this));
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_user_path");

        /// <summary>
        /// </summary>
        [GodotMethod("get_user_path")]
        public NodePath GetUserPath(int userIdx)
        {
            IntPtr ret = NativeCalls.godot_icall_1_48(method_bind_14, Object.GetPtr(this), userIdx);
            return new NodePath(ret);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_user_lightmap");

        /// <summary>
        /// </summary>
        [GodotMethod("get_user_lightmap")]
        public Texture GetUserLightmap(int userIdx)
        {
            return NativeCalls.godot_icall_1_157(method_bind_15, Object.GetPtr(this), userIdx);
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "clear_users");

        /// <summary>
        /// </summary>
        [GodotMethod("clear_users")]
        public void ClearUsers()
        {
            NativeCalls.godot_icall_0_12(method_bind_16, Object.GetPtr(this));
        }
    }
}
