using System;

namespace Godot
{
    /// <summary>
    /// 3D box shape that can be a child of a [PhysicsBody] or [Area].
    /// </summary>
    public class BoxShape : Shape
    {
        /// <summary>
        /// The shape's half extents.
        /// </summary>
        public Vector3 Extents
        {
            get
            {
                return GetExtents();
            }
            set
            {
                SetExtents(value);
            }
        }


        private const string nativeName = "BoxShape";

        public BoxShape() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_BoxShape_Ctor(this);
        }

        internal BoxShape(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_extents");

        [GodotMethod("set_extents")]
        public void SetExtents(Vector3 extents)
        {
            NativeCalls.godot_icall_1_104(method_bind_0, Object.GetPtr(this), ref extents);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_extents");

        [GodotMethod("get_extents")]
        public Vector3 GetExtents()
        {
            object ret = NativeCalls.godot_icall_0_4(method_bind_1, Object.GetPtr(this));
            return (Vector3)ret;
        }
    }
}
