using System;

namespace Godot
{
    /// <summary>
    /// [code]CanvasModulate[/code] tints the canvas elements using its assigned [code]color[/code].
    /// </summary>
    public class CanvasModulate : Node2D
    {
        /// <summary>
        /// The tint color to apply.
        /// </summary>
        public Color Color
        {
            get
            {
                return GetColor();
            }
            set
            {
                SetColor(value);
            }
        }


        private const string nativeName = "CanvasModulate";

        public CanvasModulate() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_CanvasModulate_Ctor(this);
        }

        internal CanvasModulate(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_color");

        [GodotMethod("set_color")]
        public void SetColor(Color color)
        {
            NativeCalls.godot_icall_1_202(method_bind_0, Object.GetPtr(this), ref color);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_color");

        [GodotMethod("get_color")]
        public Color GetColor()
        {
            object ret = NativeCalls.godot_icall_0_203(method_bind_1, Object.GetPtr(this));
            return (Color)ret;
        }
    }
}
