using System;

namespace Godot
{
    /// <summary>
    /// Dialog for confirmation of actions. This dialog inherits from [AcceptDialog], but has by default an OK and Cancel button (in host OS order).
    /// </summary>
    public class ConfirmationDialog : AcceptDialog
    {
        private const string nativeName = "ConfirmationDialog";

        public ConfirmationDialog() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ConfirmationDialog_Ctor(this);
        }

        internal ConfirmationDialog(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_cancel");

        /// <summary>
        /// Return the cancel button.
        /// </summary>
        [GodotMethod("get_cancel")]
        public Button GetCancel()
        {
            return NativeCalls.godot_icall_0_38(method_bind_0, Object.GetPtr(this));
        }
    }
}
