using System;

namespace Godot
{
    public class GDNative : Reference
    {
        /// <summary>
        /// </summary>
        public GDNativeLibrary Library
        {
            get
            {
                return GetLibrary();
            }
            set
            {
                SetLibrary(value);
            }
        }


        private const string nativeName = "GDNative";

        public GDNative() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_GDNative_Ctor(this);
        }

        internal GDNative(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_library");

        [GodotMethod("set_library")]
        public void SetLibrary(GDNativeLibrary library)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(library));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_library");

        [GodotMethod("get_library")]
        public GDNativeLibrary GetLibrary()
        {
            return NativeCalls.godot_icall_0_366(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "initialize");

        /// <summary>
        /// </summary>
        [GodotMethod("initialize")]
        public bool Initialize()
        {
            return NativeCalls.godot_icall_0_3(method_bind_2, Object.GetPtr(this));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "terminate");

        /// <summary>
        /// </summary>
        [GodotMethod("terminate")]
        public bool Terminate()
        {
            return NativeCalls.godot_icall_0_3(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "call_native");

        /// <summary>
        /// </summary>
        [GodotMethod("call_native")]
        public object CallNative(string callingType, string procedureName, object[] arguments)
        {
            return NativeCalls.godot_icall_3_367(method_bind_4, Object.GetPtr(this), callingType, procedureName, arguments);
        }
    }
}
