using System;

namespace Godot
{
    public class GDNativeLibrary : Resource
    {
        /// <summary>
        /// </summary>
        public bool LoadOnce
        {
            get
            {
                return ShouldLoadOnce();
            }
            set
            {
                SetLoadOnce(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Singleton
        {
            get
            {
                return IsSingleton();
            }
            set
            {
                SetSingleton(value);
            }
        }

        /// <summary>
        /// </summary>
        public string SymbolPrefix
        {
            get
            {
                return GetSymbolPrefix();
            }
            set
            {
                SetSymbolPrefix(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Reloadable
        {
            get
            {
                return IsReloadable();
            }
            set
            {
                SetReloadable(value);
            }
        }


        private const string nativeName = "GDNativeLibrary";

        public GDNativeLibrary() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_GDNativeLibrary_Ctor(this);
        }

        internal GDNativeLibrary(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_config_file");

        /// <summary>
        /// </summary>
        [GodotMethod("get_config_file")]
        public ConfigFile GetConfigFile()
        {
            return NativeCalls.godot_icall_0_368(method_bind_0, Object.GetPtr(this));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_current_library_path");

        /// <summary>
        /// </summary>
        [GodotMethod("get_current_library_path")]
        public string GetCurrentLibraryPath()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_current_dependencies");

        /// <summary>
        /// </summary>
        [GodotMethod("get_current_dependencies")]
        public string[] GetCurrentDependencies()
        {
            return NativeCalls.godot_icall_0_72(method_bind_2, Object.GetPtr(this));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "should_load_once");

        [GodotMethod("should_load_once")]
        public bool ShouldLoadOnce()
        {
            return NativeCalls.godot_icall_0_3(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_singleton");

        [GodotMethod("is_singleton")]
        public bool IsSingleton()
        {
            return NativeCalls.godot_icall_0_3(method_bind_4, Object.GetPtr(this));
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_symbol_prefix");

        [GodotMethod("get_symbol_prefix")]
        public string GetSymbolPrefix()
        {
            return NativeCalls.godot_icall_0_2(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_reloadable");

        [GodotMethod("is_reloadable")]
        public bool IsReloadable()
        {
            return NativeCalls.godot_icall_0_3(method_bind_6, Object.GetPtr(this));
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_load_once");

        [GodotMethod("set_load_once")]
        public void SetLoadOnce(bool loadOnce)
        {
            NativeCalls.godot_icall_1_11(method_bind_7, Object.GetPtr(this), loadOnce);
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_singleton");

        [GodotMethod("set_singleton")]
        public void SetSingleton(bool singleton)
        {
            NativeCalls.godot_icall_1_11(method_bind_8, Object.GetPtr(this), singleton);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_symbol_prefix");

        [GodotMethod("set_symbol_prefix")]
        public void SetSymbolPrefix(string symbolPrefix)
        {
            NativeCalls.godot_icall_1_43(method_bind_9, Object.GetPtr(this), symbolPrefix);
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_reloadable");

        [GodotMethod("set_reloadable")]
        public void SetReloadable(bool reloadable)
        {
            NativeCalls.godot_icall_1_11(method_bind_10, Object.GetPtr(this), reloadable);
        }
    }
}
