using System;

namespace Godot
{
    public class GIProbe : VisualInstance
    {
        public enum SubdivEnum
        {
            Subdiv64 = 0,
            Subdiv128 = 1,
            Subdiv256 = 2,
            Subdiv512 = 3,
            Max = 4
        }


        /// <summary>
        /// </summary>
        public GIProbe.SubdivEnum Subdiv
        {
            get
            {
                return GetSubdiv();
            }
            set
            {
                SetSubdiv(value);
            }
        }

        /// <summary>
        /// </summary>
        public Vector3 Extents
        {
            get
            {
                return GetExtents();
            }
            set
            {
                SetExtents(value);
            }
        }

        /// <summary>
        /// </summary>
        public int DynamicRange
        {
            get
            {
                return GetDynamicRange();
            }
            set
            {
                SetDynamicRange(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Energy
        {
            get
            {
                return GetEnergy();
            }
            set
            {
                SetEnergy(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Propagation
        {
            get
            {
                return GetPropagation();
            }
            set
            {
                SetPropagation(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Bias
        {
            get
            {
                return GetBias();
            }
            set
            {
                SetBias(value);
            }
        }

        /// <summary>
        /// </summary>
        public float NormalBias
        {
            get
            {
                return GetNormalBias();
            }
            set
            {
                SetNormalBias(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Interior
        {
            get
            {
                return IsInterior();
            }
            set
            {
                SetInterior(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Compress
        {
            get
            {
                return IsCompressed();
            }
            set
            {
                SetCompress(value);
            }
        }

        /// <summary>
        /// </summary>
        public GIProbeData Data
        {
            get
            {
                return GetProbeData();
            }
            set
            {
                SetProbeData(value);
            }
        }


        private const string nativeName = "GIProbe";

        public GIProbe() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_GIProbe_Ctor(this);
        }

        internal GIProbe(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_probe_data");

        [GodotMethod("set_probe_data")]
        public void SetProbeData(GIProbeData data)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(data));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_probe_data");

        [GodotMethod("get_probe_data")]
        public GIProbeData GetProbeData()
        {
            return NativeCalls.godot_icall_0_371(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_subdiv");

        [GodotMethod("set_subdiv")]
        public void SetSubdiv(GIProbe.SubdivEnum subdiv)
        {
            NativeCalls.godot_icall_1_372(method_bind_2, Object.GetPtr(this), subdiv);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_subdiv");

        [GodotMethod("get_subdiv")]
        public GIProbe.SubdivEnum GetSubdiv()
        {
            return NativeCalls.godot_icall_0_373(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_extents");

        [GodotMethod("set_extents")]
        public void SetExtents(Vector3 extents)
        {
            NativeCalls.godot_icall_1_104(method_bind_4, Object.GetPtr(this), ref extents);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_extents");

        [GodotMethod("get_extents")]
        public Vector3 GetExtents()
        {
            object ret = NativeCalls.godot_icall_0_4(method_bind_5, Object.GetPtr(this));
            return (Vector3)ret;
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_dynamic_range");

        [GodotMethod("set_dynamic_range")]
        public void SetDynamicRange(int max)
        {
            NativeCalls.godot_icall_1_0(method_bind_6, Object.GetPtr(this), max);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_dynamic_range");

        [GodotMethod("get_dynamic_range")]
        public int GetDynamicRange()
        {
            return NativeCalls.godot_icall_0_1(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_energy");

        [GodotMethod("set_energy")]
        public void SetEnergy(float max)
        {
            NativeCalls.godot_icall_1_10(method_bind_8, Object.GetPtr(this), max);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_energy");

        [GodotMethod("get_energy")]
        public float GetEnergy()
        {
            return NativeCalls.godot_icall_0_9(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_bias");

        [GodotMethod("set_bias")]
        public void SetBias(float max)
        {
            NativeCalls.godot_icall_1_10(method_bind_10, Object.GetPtr(this), max);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_bias");

        [GodotMethod("get_bias")]
        public float GetBias()
        {
            return NativeCalls.godot_icall_0_9(method_bind_11, Object.GetPtr(this));
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_normal_bias");

        [GodotMethod("set_normal_bias")]
        public void SetNormalBias(float max)
        {
            NativeCalls.godot_icall_1_10(method_bind_12, Object.GetPtr(this), max);
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_normal_bias");

        [GodotMethod("get_normal_bias")]
        public float GetNormalBias()
        {
            return NativeCalls.godot_icall_0_9(method_bind_13, Object.GetPtr(this));
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_propagation");

        [GodotMethod("set_propagation")]
        public void SetPropagation(float max)
        {
            NativeCalls.godot_icall_1_10(method_bind_14, Object.GetPtr(this), max);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_propagation");

        [GodotMethod("get_propagation")]
        public float GetPropagation()
        {
            return NativeCalls.godot_icall_0_9(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_interior");

        [GodotMethod("set_interior")]
        public void SetInterior(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_16, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_interior");

        [GodotMethod("is_interior")]
        public bool IsInterior()
        {
            return NativeCalls.godot_icall_0_3(method_bind_17, Object.GetPtr(this));
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_compress");

        [GodotMethod("set_compress")]
        public void SetCompress(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_18, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_compressed");

        [GodotMethod("is_compressed")]
        public bool IsCompressed()
        {
            return NativeCalls.godot_icall_0_3(method_bind_19, Object.GetPtr(this));
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "bake");

        /// <summary>
        /// </summary>
        [GodotMethod("bake")]
        public void Bake(Node fromNode = null, bool createVisualDebug = false)
        {
            NativeCalls.godot_icall_2_374(method_bind_20, Object.GetPtr(this), Object.GetPtr(fromNode), createVisualDebug);
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "debug_bake");

        /// <summary>
        /// </summary>
        [GodotMethod("debug_bake")]
        public void DebugBake()
        {
            NativeCalls.godot_icall_0_12(method_bind_21, Object.GetPtr(this));
        }
    }
}
