using System;

namespace Godot
{
    public class GIProbeData : Resource
    {
        /// <summary>
        /// </summary>
        public AABB Bounds
        {
            get
            {
                return GetBounds();
            }
            set
            {
                SetBounds(value);
            }
        }

        /// <summary>
        /// </summary>
        public float CellSize
        {
            get
            {
                return GetCellSize();
            }
            set
            {
                SetCellSize(value);
            }
        }

        /// <summary>
        /// </summary>
        public Transform ToCellXform
        {
            get
            {
                return GetToCellXform();
            }
            set
            {
                SetToCellXform(value);
            }
        }

        /// <summary>
        /// </summary>
        public int[] DynamicData
        {
            get
            {
                return GetDynamicData();
            }
            set
            {
                SetDynamicData(value);
            }
        }

        /// <summary>
        /// </summary>
        public int DynamicRange
        {
            get
            {
                return GetDynamicRange();
            }
            set
            {
                SetDynamicRange(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Energy
        {
            get
            {
                return GetEnergy();
            }
            set
            {
                SetEnergy(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Bias
        {
            get
            {
                return GetBias();
            }
            set
            {
                SetBias(value);
            }
        }

        /// <summary>
        /// </summary>
        public float NormalBias
        {
            get
            {
                return GetNormalBias();
            }
            set
            {
                SetNormalBias(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Propagation
        {
            get
            {
                return GetPropagation();
            }
            set
            {
                SetPropagation(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Interior
        {
            get
            {
                return IsInterior();
            }
            set
            {
                SetInterior(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Compress
        {
            get
            {
                return IsCompressed();
            }
            set
            {
                SetCompress(value);
            }
        }


        private const string nativeName = "GIProbeData";

        public GIProbeData() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_GIProbeData_Ctor(this);
        }

        internal GIProbeData(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_bounds");

        [GodotMethod("set_bounds")]
        public void SetBounds(AABB bounds)
        {
            NativeCalls.godot_icall_1_117(method_bind_0, Object.GetPtr(this), ref bounds);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_bounds");

        [GodotMethod("get_bounds")]
        public AABB GetBounds()
        {
            object ret = NativeCalls.godot_icall_0_118(method_bind_1, Object.GetPtr(this));
            return (AABB)ret;
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_cell_size");

        [GodotMethod("set_cell_size")]
        public void SetCellSize(float cellSize)
        {
            NativeCalls.godot_icall_1_10(method_bind_2, Object.GetPtr(this), cellSize);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_cell_size");

        [GodotMethod("get_cell_size")]
        public float GetCellSize()
        {
            return NativeCalls.godot_icall_0_9(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_to_cell_xform");

        [GodotMethod("set_to_cell_xform")]
        public void SetToCellXform(Transform toCellXform)
        {
            NativeCalls.godot_icall_1_155(method_bind_4, Object.GetPtr(this), ref toCellXform);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_to_cell_xform");

        [GodotMethod("get_to_cell_xform")]
        public Transform GetToCellXform()
        {
            object ret = NativeCalls.godot_icall_0_18(method_bind_5, Object.GetPtr(this));
            return (Transform)ret;
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_dynamic_data");

        [GodotMethod("set_dynamic_data")]
        public void SetDynamicData(int[] dynamicData)
        {
            NativeCalls.godot_icall_1_174(method_bind_6, Object.GetPtr(this), dynamicData);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_dynamic_data");

        [GodotMethod("get_dynamic_data")]
        public int[] GetDynamicData()
        {
            return NativeCalls.godot_icall_0_175(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_dynamic_range");

        [GodotMethod("set_dynamic_range")]
        public void SetDynamicRange(int dynamicRange)
        {
            NativeCalls.godot_icall_1_0(method_bind_8, Object.GetPtr(this), dynamicRange);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_dynamic_range");

        [GodotMethod("get_dynamic_range")]
        public int GetDynamicRange()
        {
            return NativeCalls.godot_icall_0_1(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_energy");

        [GodotMethod("set_energy")]
        public void SetEnergy(float energy)
        {
            NativeCalls.godot_icall_1_10(method_bind_10, Object.GetPtr(this), energy);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_energy");

        [GodotMethod("get_energy")]
        public float GetEnergy()
        {
            return NativeCalls.godot_icall_0_9(method_bind_11, Object.GetPtr(this));
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_bias");

        [GodotMethod("set_bias")]
        public void SetBias(float bias)
        {
            NativeCalls.godot_icall_1_10(method_bind_12, Object.GetPtr(this), bias);
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_bias");

        [GodotMethod("get_bias")]
        public float GetBias()
        {
            return NativeCalls.godot_icall_0_9(method_bind_13, Object.GetPtr(this));
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_normal_bias");

        [GodotMethod("set_normal_bias")]
        public void SetNormalBias(float bias)
        {
            NativeCalls.godot_icall_1_10(method_bind_14, Object.GetPtr(this), bias);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_normal_bias");

        [GodotMethod("get_normal_bias")]
        public float GetNormalBias()
        {
            return NativeCalls.godot_icall_0_9(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_propagation");

        [GodotMethod("set_propagation")]
        public void SetPropagation(float propagation)
        {
            NativeCalls.godot_icall_1_10(method_bind_16, Object.GetPtr(this), propagation);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_propagation");

        [GodotMethod("get_propagation")]
        public float GetPropagation()
        {
            return NativeCalls.godot_icall_0_9(method_bind_17, Object.GetPtr(this));
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_interior");

        [GodotMethod("set_interior")]
        public void SetInterior(bool interior)
        {
            NativeCalls.godot_icall_1_11(method_bind_18, Object.GetPtr(this), interior);
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_interior");

        [GodotMethod("is_interior")]
        public bool IsInterior()
        {
            return NativeCalls.godot_icall_0_3(method_bind_19, Object.GetPtr(this));
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_compress");

        [GodotMethod("set_compress")]
        public void SetCompress(bool compress)
        {
            NativeCalls.godot_icall_1_11(method_bind_20, Object.GetPtr(this), compress);
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_compressed");

        [GodotMethod("is_compressed")]
        public bool IsCompressed()
        {
            return NativeCalls.godot_icall_0_3(method_bind_21, Object.GetPtr(this));
        }
    }
}
