using System;

namespace Godot
{
    public static class GodotSharp
    {
        private const string nativeName = "_GodotSharp";
        internal static IntPtr ptr = NativeCalls.godot_icall__GodotSharp_get_singleton();

        private static IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "attach_thread");

        /// <summary>
        /// Attaches the current thread to the mono runtime.
        /// </summary>
        [GodotMethod("attach_thread")]
        public static void AttachThread()
        {
            NativeCalls.godot_icall_0_12(method_bind_0, ptr);
        }

        private static IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "detach_thread");

        /// <summary>
        /// Detaches the current thread from the mono runtime.
        /// </summary>
        [GodotMethod("detach_thread")]
        public static void DetachThread()
        {
            NativeCalls.godot_icall_0_12(method_bind_1, ptr);
        }

        private static IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_finalizing_domain");

        /// <summary>
        /// Returns whether the scripts domain is being finalized.
        /// </summary>
        [GodotMethod("is_finalizing_domain")]
        public static bool IsFinalizingDomain()
        {
            return NativeCalls.godot_icall_0_3(method_bind_2, ptr);
        }

        private static IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_domain_loaded");

        /// <summary>
        /// Returns whether the scripts domain is loaded.
        /// </summary>
        [GodotMethod("is_domain_loaded")]
        public static bool IsDomainLoaded()
        {
            return NativeCalls.godot_icall_0_3(method_bind_3, ptr);
        }
    }
}
