using System;

namespace Godot
{
    /// <summary>
    /// Contains mouse click informations. See [method Node._input].
    /// </summary>
    public class InputEventMouseButton : InputEventMouse
    {
        /// <summary>
        /// TO TALK in PR, reduz said : i think it's used for apple touch but i don't remember what it does
        /// </summary>
        public float Factor
        {
            get
            {
                return GetFactor();
            }
            set
            {
                SetFactor(value);
            }
        }

        /// <summary>
        /// Mouse button identifier, one of the BUTTON_* or BUTTON_WHEEL_* constants in [@GlobalScope].
        /// </summary>
        public int ButtonIndex
        {
            get
            {
                return GetButtonIndex();
            }
            set
            {
                SetButtonIndex(value);
            }
        }

        /// <summary>
        /// If [code]true[/code] the mouse button's state is pressed. If [code]false[/code] the mouse button's state is released.
        /// </summary>
        public bool Pressed
        {
            get
            {
                return IsPressed();
            }
            set
            {
                SetPressed(value);
            }
        }

        /// <summary>
        /// If [code]true[/code] the mouse button's state is a double-click. If [code]false[/code] the mouse button's state is released.
        /// </summary>
        public bool Doubleclick
        {
            get
            {
                return IsDoubleclick();
            }
            set
            {
                SetDoubleclick(value);
            }
        }


        private const string nativeName = "InputEventMouseButton";

        public InputEventMouseButton() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_InputEventMouseButton_Ctor(this);
        }

        internal InputEventMouseButton(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_factor");

        [GodotMethod("set_factor")]
        public void SetFactor(float factor)
        {
            NativeCalls.godot_icall_1_10(method_bind_0, Object.GetPtr(this), factor);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_factor");

        [GodotMethod("get_factor")]
        public float GetFactor()
        {
            return NativeCalls.godot_icall_0_9(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_button_index");

        [GodotMethod("set_button_index")]
        public void SetButtonIndex(int buttonIndex)
        {
            NativeCalls.godot_icall_1_0(method_bind_2, Object.GetPtr(this), buttonIndex);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_button_index");

        [GodotMethod("get_button_index")]
        public int GetButtonIndex()
        {
            return NativeCalls.godot_icall_0_1(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_pressed");

        [GodotMethod("set_pressed")]
        public void SetPressed(bool pressed)
        {
            NativeCalls.godot_icall_1_11(method_bind_4, Object.GetPtr(this), pressed);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_doubleclick");

        [GodotMethod("set_doubleclick")]
        public void SetDoubleclick(bool doubleclick)
        {
            NativeCalls.godot_icall_1_11(method_bind_5, Object.GetPtr(this), doubleclick);
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_doubleclick");

        [GodotMethod("is_doubleclick")]
        public bool IsDoubleclick()
        {
            return NativeCalls.godot_icall_0_3(method_bind_6, Object.GetPtr(this));
        }
    }
}
