using System;

namespace Godot
{
    public class InterpolatedCamera : Camera
    {
        /// <summary>
        /// </summary>
        public NodePath Target
        {
            get
            {
                return GetTargetPath();
            }
            set
            {
                SetTargetPath(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Speed
        {
            get
            {
                return GetSpeed();
            }
            set
            {
                SetSpeed(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Enabled
        {
            get
            {
                return IsInterpolationEnabled();
            }
            set
            {
                SetInterpolationEnabled(value);
            }
        }


        private const string nativeName = "InterpolatedCamera";

        public InterpolatedCamera() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_InterpolatedCamera_Ctor(this);
        }

        internal InterpolatedCamera(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_target_path");

        [GodotMethod("set_target_path")]
        public void SetTargetPath(NodePath targetPath)
        {
            NativeCalls.godot_icall_1_78(method_bind_0, Object.GetPtr(this), NodePath.GetPtr(targetPath));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_target_path");

        [GodotMethod("get_target_path")]
        public NodePath GetTargetPath()
        {
            IntPtr ret = NativeCalls.godot_icall_0_79(method_bind_1, Object.GetPtr(this));
            return new NodePath(ret);
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_target");

        /// <summary>
        /// </summary>
        [GodotMethod("set_target")]
        public void SetTarget(Object target)
        {
            NativeCalls.godot_icall_1_42(method_bind_2, Object.GetPtr(this), Object.GetPtr(target));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_speed");

        [GodotMethod("set_speed")]
        public void SetSpeed(float speed)
        {
            NativeCalls.godot_icall_1_10(method_bind_3, Object.GetPtr(this), speed);
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_speed");

        [GodotMethod("get_speed")]
        public float GetSpeed()
        {
            return NativeCalls.godot_icall_0_9(method_bind_4, Object.GetPtr(this));
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_interpolation_enabled");

        [GodotMethod("set_interpolation_enabled")]
        public void SetInterpolationEnabled(bool targetPath)
        {
            NativeCalls.godot_icall_1_11(method_bind_5, Object.GetPtr(this), targetPath);
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_interpolation_enabled");

        [GodotMethod("is_interpolation_enabled")]
        public bool IsInterpolationEnabled()
        {
            return NativeCalls.godot_icall_0_3(method_bind_6, Object.GetPtr(this));
        }
    }
}
