using System;

namespace Godot
{
    /// <summary>
    /// Helper class for parsing JSON data. For usage example, see [JSONParseResult].
    /// </summary>
    public static class JSON
    {
        private const string nativeName = "_JSON";
        internal static IntPtr ptr = NativeCalls.godot_icall__JSON_get_singleton();

        private static IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "print");

        /// <summary>
        /// Converts a Variant var to JSON text and returns the result. Useful for serializing data to store or send over the network.
        /// </summary>
        [GodotMethod("print")]
        public static string Print(object value, string indent = "", bool sortKeys = false)
        {
            return NativeCalls.godot_icall_3_1060(method_bind_0, ptr, value, indent, sortKeys);
        }

        private static IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "parse");

        /// <summary>
        /// Parses a JSON encoded string and returns a [JSONParseResult] containing the result.
        /// </summary>
        [GodotMethod("parse")]
        public static JSONParseResult Parse(string json)
        {
            return NativeCalls.godot_icall_1_1061(method_bind_1, ptr, json);
        }
    }
}
