using System;

namespace Godot
{
    /// <summary>
    /// The JavaScript singleton is implemented only in HTML5 export. It's used to access the browser's JavaScript context. This allows interaction with embedding pages or calling third-party JavaScript APIs.
    /// </summary>
    public static class JavaScript
    {
        private const string nativeName = "JavaScript";
        internal static IntPtr ptr = NativeCalls.godot_icall_JavaScript_get_singleton();

        private static IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "eval");

        /// <summary>
        /// Execute the string [code]code[/code] as JavaScript code within the browser window. This is a call to the actual global JavaScript function [code]eval()[/code].
        /// If [code]use_global_execution_context[/code] is [code]true[/code], the code will be evaluated in the global execution context. Otherwise, it is evaluated in the execution context of a function within the engine's runtime environment.
        /// </summary>
        [GodotMethod("eval")]
        public static object Eval(string code, bool useGlobalExecutionContext = false)
        {
            return NativeCalls.godot_icall_2_464(method_bind_0, ptr, code, useGlobalExecutionContext);
        }
    }
}
