using System;

namespace Godot
{
    public class Listener : Spatial
    {
        private const string nativeName = "Listener";

        public Listener() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_Listener_Ctor(this);
        }

        internal Listener(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "make_current");

        /// <summary>
        /// </summary>
        [GodotMethod("make_current")]
        public void MakeCurrent()
        {
            NativeCalls.godot_icall_0_12(method_bind_0, Object.GetPtr(this));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "clear_current");

        /// <summary>
        /// </summary>
        [GodotMethod("clear_current")]
        public void ClearCurrent()
        {
            NativeCalls.godot_icall_0_12(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_current");

        /// <summary>
        /// </summary>
        [GodotMethod("is_current")]
        public bool IsCurrent()
        {
            return NativeCalls.godot_icall_0_3(method_bind_2, Object.GetPtr(this));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_listener_transform");

        /// <summary>
        /// </summary>
        [GodotMethod("get_listener_transform")]
        public Transform GetListenerTransform()
        {
            object ret = NativeCalls.godot_icall_0_18(method_bind_3, Object.GetPtr(this));
            return (Transform)ret;
        }
    }
}
