using System;

namespace Godot
{
    public class MeshDataTool : Reference
    {
        private const string nativeName = "MeshDataTool";

        public MeshDataTool() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_MeshDataTool_Ctor(this);
        }

        internal MeshDataTool(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "clear");

        /// <summary>
        /// </summary>
        [GodotMethod("clear")]
        public void Clear()
        {
            NativeCalls.godot_icall_0_12(method_bind_0, Object.GetPtr(this));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "create_from_surface");

        /// <summary>
        /// </summary>
        [GodotMethod("create_from_surface")]
        public Error CreateFromSurface(ArrayMesh mesh, int surface)
        {
            return NativeCalls.godot_icall_2_504(method_bind_1, Object.GetPtr(this), Object.GetPtr(mesh), surface);
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "commit_to_surface");

        /// <summary>
        /// </summary>
        [GodotMethod("commit_to_surface")]
        public Error CommitToSurface(ArrayMesh mesh)
        {
            return NativeCalls.godot_icall_1_505(method_bind_2, Object.GetPtr(this), Object.GetPtr(mesh));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_format");

        /// <summary>
        /// </summary>
        [GodotMethod("get_format")]
        public int GetFormat()
        {
            return NativeCalls.godot_icall_0_1(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_count");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_count")]
        public int GetVertexCount()
        {
            return NativeCalls.godot_icall_0_1(method_bind_4, Object.GetPtr(this));
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_edge_count");

        /// <summary>
        /// </summary>
        [GodotMethod("get_edge_count")]
        public int GetEdgeCount()
        {
            return NativeCalls.godot_icall_0_1(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_face_count");

        /// <summary>
        /// </summary>
        [GodotMethod("get_face_count")]
        public int GetFaceCount()
        {
            return NativeCalls.godot_icall_0_1(method_bind_6, Object.GetPtr(this));
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex")]
        public void SetVertex(int idx, Vector3 vertex)
        {
            NativeCalls.godot_icall_2_27(method_bind_7, Object.GetPtr(this), idx, ref vertex);
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex")]
        public Vector3 GetVertex(int idx)
        {
            object ret = NativeCalls.godot_icall_1_26(method_bind_8, Object.GetPtr(this), idx);
            return (Vector3)ret;
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex_normal");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex_normal")]
        public void SetVertexNormal(int idx, Vector3 normal)
        {
            NativeCalls.godot_icall_2_27(method_bind_9, Object.GetPtr(this), idx, ref normal);
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_normal");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_normal")]
        public Vector3 GetVertexNormal(int idx)
        {
            object ret = NativeCalls.godot_icall_1_26(method_bind_10, Object.GetPtr(this), idx);
            return (Vector3)ret;
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex_tangent");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex_tangent")]
        public void SetVertexTangent(int idx, Plane tangent)
        {
            NativeCalls.godot_icall_2_506(method_bind_11, Object.GetPtr(this), idx, ref tangent);
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_tangent");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_tangent")]
        public Plane GetVertexTangent(int idx)
        {
            object ret = NativeCalls.godot_icall_1_507(method_bind_12, Object.GetPtr(this), idx);
            return (Plane)ret;
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex_uv");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex_uv")]
        public void SetVertexUv(int idx, Vector2 uv)
        {
            NativeCalls.godot_icall_2_288(method_bind_13, Object.GetPtr(this), idx, ref uv);
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_uv");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_uv")]
        public Vector2 GetVertexUv(int idx)
        {
            object ret = NativeCalls.godot_icall_1_282(method_bind_14, Object.GetPtr(this), idx);
            return (Vector2)ret;
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex_uv2");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex_uv2")]
        public void SetVertexUv2(int idx, Vector2 uv2)
        {
            NativeCalls.godot_icall_2_288(method_bind_15, Object.GetPtr(this), idx, ref uv2);
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_uv2");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_uv2")]
        public Vector2 GetVertexUv2(int idx)
        {
            object ret = NativeCalls.godot_icall_1_282(method_bind_16, Object.GetPtr(this), idx);
            return (Vector2)ret;
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex_color");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex_color")]
        public void SetVertexColor(int idx, Color color)
        {
            NativeCalls.godot_icall_2_384(method_bind_17, Object.GetPtr(this), idx, ref color);
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_color");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_color")]
        public Color GetVertexColor(int idx)
        {
            object ret = NativeCalls.godot_icall_1_385(method_bind_18, Object.GetPtr(this), idx);
            return (Color)ret;
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex_bones");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex_bones")]
        public void SetVertexBones(int idx, int[] bones)
        {
            NativeCalls.godot_icall_2_508(method_bind_19, Object.GetPtr(this), idx, bones);
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_bones");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_bones")]
        public int[] GetVertexBones(int idx)
        {
            return NativeCalls.godot_icall_1_30(method_bind_20, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex_weights");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex_weights")]
        public void SetVertexWeights(int idx, float[] weights)
        {
            NativeCalls.godot_icall_2_509(method_bind_21, Object.GetPtr(this), idx, weights);
        }

        private IntPtr method_bind_22 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_weights");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_weights")]
        public float[] GetVertexWeights(int idx)
        {
            return NativeCalls.godot_icall_1_510(method_bind_22, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_23 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertex_meta");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertex_meta")]
        public void SetVertexMeta(int idx, object meta)
        {
            NativeCalls.godot_icall_2_453(method_bind_23, Object.GetPtr(this), idx, meta);
        }

        private IntPtr method_bind_24 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_meta");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_meta")]
        public object GetVertexMeta(int idx)
        {
            return NativeCalls.godot_icall_1_454(method_bind_24, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_25 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_edges");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_edges")]
        public int[] GetVertexEdges(int idx)
        {
            return NativeCalls.godot_icall_1_30(method_bind_25, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_26 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertex_faces");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertex_faces")]
        public int[] GetVertexFaces(int idx)
        {
            return NativeCalls.godot_icall_1_30(method_bind_26, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_27 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_edge_vertex");

        /// <summary>
        /// </summary>
        [GodotMethod("get_edge_vertex")]
        public int GetEdgeVertex(int idx, int vertex)
        {
            return NativeCalls.godot_icall_2_171(method_bind_27, Object.GetPtr(this), idx, vertex);
        }

        private IntPtr method_bind_28 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_edge_faces");

        /// <summary>
        /// </summary>
        [GodotMethod("get_edge_faces")]
        public int[] GetEdgeFaces(int idx)
        {
            return NativeCalls.godot_icall_1_30(method_bind_28, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_29 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_edge_meta");

        /// <summary>
        /// </summary>
        [GodotMethod("set_edge_meta")]
        public void SetEdgeMeta(int idx, object meta)
        {
            NativeCalls.godot_icall_2_453(method_bind_29, Object.GetPtr(this), idx, meta);
        }

        private IntPtr method_bind_30 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_edge_meta");

        /// <summary>
        /// </summary>
        [GodotMethod("get_edge_meta")]
        public object GetEdgeMeta(int idx)
        {
            return NativeCalls.godot_icall_1_454(method_bind_30, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_31 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_face_vertex");

        /// <summary>
        /// </summary>
        [GodotMethod("get_face_vertex")]
        public int GetFaceVertex(int idx, int vertex)
        {
            return NativeCalls.godot_icall_2_171(method_bind_31, Object.GetPtr(this), idx, vertex);
        }

        private IntPtr method_bind_32 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_face_edge");

        /// <summary>
        /// </summary>
        [GodotMethod("get_face_edge")]
        public int GetFaceEdge(int idx, int edge)
        {
            return NativeCalls.godot_icall_2_171(method_bind_32, Object.GetPtr(this), idx, edge);
        }

        private IntPtr method_bind_33 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_face_meta");

        /// <summary>
        /// </summary>
        [GodotMethod("set_face_meta")]
        public void SetFaceMeta(int idx, object meta)
        {
            NativeCalls.godot_icall_2_453(method_bind_33, Object.GetPtr(this), idx, meta);
        }

        private IntPtr method_bind_34 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_face_meta");

        /// <summary>
        /// </summary>
        [GodotMethod("get_face_meta")]
        public object GetFaceMeta(int idx)
        {
            return NativeCalls.godot_icall_1_454(method_bind_34, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_35 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_face_normal");

        /// <summary>
        /// </summary>
        [GodotMethod("get_face_normal")]
        public Vector3 GetFaceNormal(int idx)
        {
            object ret = NativeCalls.godot_icall_1_26(method_bind_35, Object.GetPtr(this), idx);
            return (Vector3)ret;
        }

        private IntPtr method_bind_36 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_material");

        /// <summary>
        /// </summary>
        [GodotMethod("set_material")]
        public void SetMaterial(Material material)
        {
            NativeCalls.godot_icall_1_24(method_bind_36, Object.GetPtr(this), Object.GetPtr(material));
        }

        private IntPtr method_bind_37 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_material");

        /// <summary>
        /// </summary>
        [GodotMethod("get_material")]
        public Material GetMaterial()
        {
            return NativeCalls.godot_icall_0_222(method_bind_37, Object.GetPtr(this));
        }
    }
}
