using System;

namespace Godot
{
    /// <summary>
    /// MultiMeshInstance is a [Node] that takes a [MultiMesh] resource and adds it to the current scenario by creating an instance of it (yes, this is an instance of instances).
    /// </summary>
    public class MultiMeshInstance : GeometryInstance
    {
        /// <summary>
        /// </summary>
        public MultiMesh Multimesh
        {
            get
            {
                return GetMultimesh();
            }
            set
            {
                SetMultimesh(value);
            }
        }


        private const string nativeName = "MultiMeshInstance";

        public MultiMeshInstance() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_MultiMeshInstance_Ctor(this);
        }

        internal MultiMeshInstance(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_multimesh");

        [GodotMethod("set_multimesh")]
        public void SetMultimesh(MultiMesh multimesh)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(multimesh));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_multimesh");

        [GodotMethod("get_multimesh")]
        public MultiMesh GetMultimesh()
        {
            return NativeCalls.godot_icall_0_519(method_bind_1, Object.GetPtr(this));
        }
    }
}
