using System;

namespace Godot
{
    public class NativeScript : Script
    {
        /// <summary>
        /// </summary>
        public string ClassName
        {
            get
            {
                return GetClassName();
            }
            set
            {
                SetClassName(value);
            }
        }

        /// <summary>
        /// </summary>
        public GDNativeLibrary Library
        {
            get
            {
                return GetLibrary();
            }
            set
            {
                SetLibrary(value);
            }
        }


        private const string nativeName = "NativeScript";

        public NativeScript() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_NativeScript_Ctor(this);
        }

        internal NativeScript(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_class_name");

        [GodotMethod("set_class_name")]
        public void SetClassName(string className)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), className);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_class_name");

        [GodotMethod("get_class_name")]
        public string GetClassName()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_library");

        [GodotMethod("set_library")]
        public void SetLibrary(GDNativeLibrary library)
        {
            NativeCalls.godot_icall_1_24(method_bind_2, Object.GetPtr(this), Object.GetPtr(library));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_library");

        [GodotMethod("get_library")]
        public GDNativeLibrary GetLibrary()
        {
            return NativeCalls.godot_icall_0_366(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "new");

        /// <summary>
        /// </summary>
        [GodotMethod("new")]
        public Object New(params object[] @args)
        {
            return NativeCalls.godot_icall_1_182(method_bind_4, Object.GetPtr(this), @args);
        }
    }
}
