using System;

namespace Godot
{
    public class Navigation2D : Node2D
    {
        private const string nativeName = "Navigation2D";

        public Navigation2D() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_Navigation2D_Ctor(this);
        }

        internal Navigation2D(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "navpoly_add");

        /// <summary>
        /// </summary>
        [GodotMethod("navpoly_add")]
        public int NavpolyAdd(NavigationPolygon mesh, Transform2D xform, Object owner = null)
        {
            return NativeCalls.godot_icall_3_524(method_bind_0, Object.GetPtr(this), Object.GetPtr(mesh), ref xform, Object.GetPtr(owner));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "navpoly_set_transform");

        /// <summary>
        /// </summary>
        [GodotMethod("navpoly_set_transform")]
        public void NavpolySetTransform(int id, Transform2D xform)
        {
            NativeCalls.godot_icall_2_234(method_bind_1, Object.GetPtr(this), id, ref xform);
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "navpoly_remove");

        /// <summary>
        /// </summary>
        [GodotMethod("navpoly_remove")]
        public void NavpolyRemove(int id)
        {
            NativeCalls.godot_icall_1_0(method_bind_2, Object.GetPtr(this), id);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_simple_path");

        /// <summary>
        /// </summary>
        [GodotMethod("get_simple_path")]
        public Vector2[] GetSimplePath(Vector2 start, Vector2 end, bool optimize = true)
        {
            return NativeCalls.godot_icall_3_525(method_bind_3, Object.GetPtr(this), ref start, ref end, optimize);
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_closest_point");

        /// <summary>
        /// </summary>
        [GodotMethod("get_closest_point")]
        public Vector2 GetClosestPoint(Vector2 toPoint)
        {
            object ret = NativeCalls.godot_icall_1_223(method_bind_4, Object.GetPtr(this), ref toPoint);
            return (Vector2)ret;
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_closest_point_owner");

        /// <summary>
        /// </summary>
        [GodotMethod("get_closest_point_owner")]
        public Object GetClosestPointOwner(Vector2 toPoint)
        {
            return NativeCalls.godot_icall_1_526(method_bind_5, Object.GetPtr(this), ref toPoint);
        }
    }
}
