using System;

namespace Godot
{
    public class NavigationMesh : Resource
    {
        public const int SamplePartitionWatershed = 0;
        public const int SamplePartitionMonotone = 1;
        public const int SamplePartitionLayers = 2;

        public Vector3[] Vertices
        {
            get
            {
                return GetVertices();
            }
            set
            {
                SetVertices(value);
            }
        }

        public object[] Polygons
        {
            get
            {
                return _GetPolygons();
            }
            set
            {
                _SetPolygons(value);
            }
        }

        /// <summary>
        /// </summary>
        public int SamplePartitionType__samplePartitionType
        {
            get
            {
                return GetSamplePartitionType();
            }
            set
            {
                SetSamplePartitionType(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Cell__size
        {
            get
            {
                return GetCellSize();
            }
            set
            {
                SetCellSize(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Cell__height
        {
            get
            {
                return GetCellHeight();
            }
            set
            {
                SetCellHeight(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Agent__height
        {
            get
            {
                return GetAgentHeight();
            }
            set
            {
                SetAgentHeight(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Agent__radius
        {
            get
            {
                return GetAgentRadius();
            }
            set
            {
                SetAgentRadius(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Agent__maxClimb
        {
            get
            {
                return GetAgentMaxClimb();
            }
            set
            {
                SetAgentMaxClimb(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Agent__maxSlope
        {
            get
            {
                return GetAgentMaxSlope();
            }
            set
            {
                SetAgentMaxSlope(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Region__minSize
        {
            get
            {
                return GetRegionMinSize();
            }
            set
            {
                SetRegionMinSize(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Region__mergeSize
        {
            get
            {
                return GetRegionMergeSize();
            }
            set
            {
                SetRegionMergeSize(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Edge__maxLength
        {
            get
            {
                return GetEdgeMaxLength();
            }
            set
            {
                SetEdgeMaxLength(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Edge__maxError
        {
            get
            {
                return GetEdgeMaxError();
            }
            set
            {
                SetEdgeMaxError(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Polygon__vertsPerPoly
        {
            get
            {
                return GetVertsPerPoly();
            }
            set
            {
                SetVertsPerPoly(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Detail__sampleDistance
        {
            get
            {
                return GetDetailSampleDistance();
            }
            set
            {
                SetDetailSampleDistance(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Detail__sampleMaxError
        {
            get
            {
                return GetDetailSampleMaxError();
            }
            set
            {
                SetDetailSampleMaxError(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Filter__lowHangingObstacles
        {
            get
            {
                return GetFilterLowHangingObstacles();
            }
            set
            {
                SetFilterLowHangingObstacles(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Filter__ledgeSpans
        {
            get
            {
                return GetFilterLedgeSpans();
            }
            set
            {
                SetFilterLedgeSpans(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Filter__filterWalkableLowHeightSpans
        {
            get
            {
                return GetFilterWalkableLowHeightSpans();
            }
            set
            {
                SetFilterWalkableLowHeightSpans(value);
            }
        }


        private const string nativeName = "NavigationMesh";

        public NavigationMesh() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_NavigationMesh_Ctor(this);
        }

        internal NavigationMesh(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sample_partition_type");

        [GodotMethod("set_sample_partition_type")]
        public void SetSamplePartitionType(int samplePartitionType)
        {
            NativeCalls.godot_icall_1_0(method_bind_0, Object.GetPtr(this), samplePartitionType);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sample_partition_type");

        [GodotMethod("get_sample_partition_type")]
        public int GetSamplePartitionType()
        {
            return NativeCalls.godot_icall_0_1(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_cell_size");

        [GodotMethod("set_cell_size")]
        public void SetCellSize(float cellSize)
        {
            NativeCalls.godot_icall_1_10(method_bind_2, Object.GetPtr(this), cellSize);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_cell_size");

        [GodotMethod("get_cell_size")]
        public float GetCellSize()
        {
            return NativeCalls.godot_icall_0_9(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_cell_height");

        [GodotMethod("set_cell_height")]
        public void SetCellHeight(float cellHeight)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), cellHeight);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_cell_height");

        [GodotMethod("get_cell_height")]
        public float GetCellHeight()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_agent_height");

        [GodotMethod("set_agent_height")]
        public void SetAgentHeight(float agentHeight)
        {
            NativeCalls.godot_icall_1_10(method_bind_6, Object.GetPtr(this), agentHeight);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_agent_height");

        [GodotMethod("get_agent_height")]
        public float GetAgentHeight()
        {
            return NativeCalls.godot_icall_0_9(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_agent_radius");

        [GodotMethod("set_agent_radius")]
        public void SetAgentRadius(float agentRadius)
        {
            NativeCalls.godot_icall_1_10(method_bind_8, Object.GetPtr(this), agentRadius);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_agent_radius");

        [GodotMethod("get_agent_radius")]
        public float GetAgentRadius()
        {
            return NativeCalls.godot_icall_0_9(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_agent_max_climb");

        [GodotMethod("set_agent_max_climb")]
        public void SetAgentMaxClimb(float agentMaxClimb)
        {
            NativeCalls.godot_icall_1_10(method_bind_10, Object.GetPtr(this), agentMaxClimb);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_agent_max_climb");

        [GodotMethod("get_agent_max_climb")]
        public float GetAgentMaxClimb()
        {
            return NativeCalls.godot_icall_0_9(method_bind_11, Object.GetPtr(this));
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_agent_max_slope");

        [GodotMethod("set_agent_max_slope")]
        public void SetAgentMaxSlope(float agentMaxSlope)
        {
            NativeCalls.godot_icall_1_10(method_bind_12, Object.GetPtr(this), agentMaxSlope);
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_agent_max_slope");

        [GodotMethod("get_agent_max_slope")]
        public float GetAgentMaxSlope()
        {
            return NativeCalls.godot_icall_0_9(method_bind_13, Object.GetPtr(this));
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_region_min_size");

        [GodotMethod("set_region_min_size")]
        public void SetRegionMinSize(float regionMinSize)
        {
            NativeCalls.godot_icall_1_10(method_bind_14, Object.GetPtr(this), regionMinSize);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_region_min_size");

        [GodotMethod("get_region_min_size")]
        public float GetRegionMinSize()
        {
            return NativeCalls.godot_icall_0_9(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_region_merge_size");

        [GodotMethod("set_region_merge_size")]
        public void SetRegionMergeSize(float regionMergeSize)
        {
            NativeCalls.godot_icall_1_10(method_bind_16, Object.GetPtr(this), regionMergeSize);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_region_merge_size");

        [GodotMethod("get_region_merge_size")]
        public float GetRegionMergeSize()
        {
            return NativeCalls.godot_icall_0_9(method_bind_17, Object.GetPtr(this));
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_edge_max_length");

        [GodotMethod("set_edge_max_length")]
        public void SetEdgeMaxLength(float edgeMaxLength)
        {
            NativeCalls.godot_icall_1_10(method_bind_18, Object.GetPtr(this), edgeMaxLength);
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_edge_max_length");

        [GodotMethod("get_edge_max_length")]
        public float GetEdgeMaxLength()
        {
            return NativeCalls.godot_icall_0_9(method_bind_19, Object.GetPtr(this));
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_edge_max_error");

        [GodotMethod("set_edge_max_error")]
        public void SetEdgeMaxError(float edgeMaxError)
        {
            NativeCalls.godot_icall_1_10(method_bind_20, Object.GetPtr(this), edgeMaxError);
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_edge_max_error");

        [GodotMethod("get_edge_max_error")]
        public float GetEdgeMaxError()
        {
            return NativeCalls.godot_icall_0_9(method_bind_21, Object.GetPtr(this));
        }

        private IntPtr method_bind_22 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_verts_per_poly");

        [GodotMethod("set_verts_per_poly")]
        public void SetVertsPerPoly(float vertsPerPoly)
        {
            NativeCalls.godot_icall_1_10(method_bind_22, Object.GetPtr(this), vertsPerPoly);
        }

        private IntPtr method_bind_23 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_verts_per_poly");

        [GodotMethod("get_verts_per_poly")]
        public float GetVertsPerPoly()
        {
            return NativeCalls.godot_icall_0_9(method_bind_23, Object.GetPtr(this));
        }

        private IntPtr method_bind_24 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_detail_sample_distance");

        [GodotMethod("set_detail_sample_distance")]
        public void SetDetailSampleDistance(float detailSampleDist)
        {
            NativeCalls.godot_icall_1_10(method_bind_24, Object.GetPtr(this), detailSampleDist);
        }

        private IntPtr method_bind_25 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_detail_sample_distance");

        [GodotMethod("get_detail_sample_distance")]
        public float GetDetailSampleDistance()
        {
            return NativeCalls.godot_icall_0_9(method_bind_25, Object.GetPtr(this));
        }

        private IntPtr method_bind_26 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_detail_sample_max_error");

        [GodotMethod("set_detail_sample_max_error")]
        public void SetDetailSampleMaxError(float detailSampleMaxError)
        {
            NativeCalls.godot_icall_1_10(method_bind_26, Object.GetPtr(this), detailSampleMaxError);
        }

        private IntPtr method_bind_27 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_detail_sample_max_error");

        [GodotMethod("get_detail_sample_max_error")]
        public float GetDetailSampleMaxError()
        {
            return NativeCalls.godot_icall_0_9(method_bind_27, Object.GetPtr(this));
        }

        private IntPtr method_bind_28 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_filter_low_hanging_obstacles");

        [GodotMethod("set_filter_low_hanging_obstacles")]
        public void SetFilterLowHangingObstacles(bool filterLowHangingObstacles)
        {
            NativeCalls.godot_icall_1_11(method_bind_28, Object.GetPtr(this), filterLowHangingObstacles);
        }

        private IntPtr method_bind_29 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_filter_low_hanging_obstacles");

        [GodotMethod("get_filter_low_hanging_obstacles")]
        public bool GetFilterLowHangingObstacles()
        {
            return NativeCalls.godot_icall_0_3(method_bind_29, Object.GetPtr(this));
        }

        private IntPtr method_bind_30 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_filter_ledge_spans");

        [GodotMethod("set_filter_ledge_spans")]
        public void SetFilterLedgeSpans(bool filterLedgeSpans)
        {
            NativeCalls.godot_icall_1_11(method_bind_30, Object.GetPtr(this), filterLedgeSpans);
        }

        private IntPtr method_bind_31 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_filter_ledge_spans");

        [GodotMethod("get_filter_ledge_spans")]
        public bool GetFilterLedgeSpans()
        {
            return NativeCalls.godot_icall_0_3(method_bind_31, Object.GetPtr(this));
        }

        private IntPtr method_bind_32 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_filter_walkable_low_height_spans");

        [GodotMethod("set_filter_walkable_low_height_spans")]
        public void SetFilterWalkableLowHeightSpans(bool filterWalkableLowHeightSpans)
        {
            NativeCalls.godot_icall_1_11(method_bind_32, Object.GetPtr(this), filterWalkableLowHeightSpans);
        }

        private IntPtr method_bind_33 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_filter_walkable_low_height_spans");

        [GodotMethod("get_filter_walkable_low_height_spans")]
        public bool GetFilterWalkableLowHeightSpans()
        {
            return NativeCalls.godot_icall_0_3(method_bind_33, Object.GetPtr(this));
        }

        private IntPtr method_bind_34 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertices");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertices")]
        public void SetVertices(Vector3[] vertices)
        {
            NativeCalls.godot_icall_1_245(method_bind_34, Object.GetPtr(this), vertices);
        }

        private IntPtr method_bind_35 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertices");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertices")]
        public Vector3[] GetVertices()
        {
            return NativeCalls.godot_icall_0_246(method_bind_35, Object.GetPtr(this));
        }

        private IntPtr method_bind_36 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "add_polygon");

        /// <summary>
        /// </summary>
        [GodotMethod("add_polygon")]
        public void AddPolygon(int[] polygon)
        {
            NativeCalls.godot_icall_1_174(method_bind_36, Object.GetPtr(this), polygon);
        }

        private IntPtr method_bind_37 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_polygon_count");

        /// <summary>
        /// </summary>
        [GodotMethod("get_polygon_count")]
        public int GetPolygonCount()
        {
            return NativeCalls.godot_icall_0_1(method_bind_37, Object.GetPtr(this));
        }

        private IntPtr method_bind_38 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_polygon");

        /// <summary>
        /// </summary>
        [GodotMethod("get_polygon")]
        public int[] GetPolygon(int idx)
        {
            return NativeCalls.godot_icall_1_30(method_bind_38, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_39 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "clear_polygons");

        /// <summary>
        /// </summary>
        [GodotMethod("clear_polygons")]
        public void ClearPolygons()
        {
            NativeCalls.godot_icall_0_12(method_bind_39, Object.GetPtr(this));
        }

        private IntPtr method_bind_40 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "create_from_mesh");

        /// <summary>
        /// </summary>
        [GodotMethod("create_from_mesh")]
        public void CreateFromMesh(Mesh mesh)
        {
            NativeCalls.godot_icall_1_24(method_bind_40, Object.GetPtr(this), Object.GetPtr(mesh));
        }

        private IntPtr method_bind_41 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_set_polygons");

        internal void _SetPolygons(object[] polygons)
        {
            NativeCalls.godot_icall_1_154(method_bind_41, Object.GetPtr(this), polygons);
        }

        private IntPtr method_bind_42 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_get_polygons");

        internal object[] _GetPolygons()
        {
            return NativeCalls.godot_icall_0_21(method_bind_42, Object.GetPtr(this));
        }
    }
}
