using System;

namespace Godot
{
    public class NavigationMeshInstance : Spatial
    {
        /// <summary>
        /// </summary>
        public NavigationMesh Navmesh
        {
            get
            {
                return GetNavigationMesh();
            }
            set
            {
                SetNavigationMesh(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Enabled
        {
            get
            {
                return IsEnabled();
            }
            set
            {
                SetEnabled(value);
            }
        }


        private const string nativeName = "NavigationMeshInstance";

        public NavigationMeshInstance() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_NavigationMeshInstance_Ctor(this);
        }

        internal NavigationMeshInstance(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_navigation_mesh");

        [GodotMethod("set_navigation_mesh")]
        public void SetNavigationMesh(NavigationMesh navmesh)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(navmesh));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_navigation_mesh");

        [GodotMethod("get_navigation_mesh")]
        public NavigationMesh GetNavigationMesh()
        {
            return NativeCalls.godot_icall_0_527(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_enabled");

        [GodotMethod("set_enabled")]
        public void SetEnabled(bool enabled)
        {
            NativeCalls.godot_icall_1_11(method_bind_2, Object.GetPtr(this), enabled);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_enabled");

        [GodotMethod("is_enabled")]
        public bool IsEnabled()
        {
            return NativeCalls.godot_icall_0_3(method_bind_3, Object.GetPtr(this));
        }
    }
}
