using System;

namespace Godot
{
    public class NavigationPolygon : Resource
    {
        public Vector2[] Vertices
        {
            get
            {
                return GetVertices();
            }
            set
            {
                SetVertices(value);
            }
        }

        public object[] Polygons
        {
            get
            {
                return _GetPolygons();
            }
            set
            {
                _SetPolygons(value);
            }
        }

        public object[] Outlines
        {
            get
            {
                return _GetOutlines();
            }
            set
            {
                _SetOutlines(value);
            }
        }

        private const string nativeName = "NavigationPolygon";

        public NavigationPolygon() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_NavigationPolygon_Ctor(this);
        }

        internal NavigationPolygon(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertices");

        /// <summary>
        /// </summary>
        [GodotMethod("set_vertices")]
        public void SetVertices(Vector2[] vertices)
        {
            NativeCalls.godot_icall_1_237(method_bind_0, Object.GetPtr(this), vertices);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_vertices");

        /// <summary>
        /// </summary>
        [GodotMethod("get_vertices")]
        public Vector2[] GetVertices()
        {
            return NativeCalls.godot_icall_0_238(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "add_polygon");

        /// <summary>
        /// </summary>
        [GodotMethod("add_polygon")]
        public void AddPolygon(int[] polygon)
        {
            NativeCalls.godot_icall_1_174(method_bind_2, Object.GetPtr(this), polygon);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_polygon_count");

        /// <summary>
        /// </summary>
        [GodotMethod("get_polygon_count")]
        public int GetPolygonCount()
        {
            return NativeCalls.godot_icall_0_1(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_polygon");

        /// <summary>
        /// </summary>
        [GodotMethod("get_polygon")]
        public int[] GetPolygon(int idx)
        {
            return NativeCalls.godot_icall_1_30(method_bind_4, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "clear_polygons");

        /// <summary>
        /// </summary>
        [GodotMethod("clear_polygons")]
        public void ClearPolygons()
        {
            NativeCalls.godot_icall_0_12(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "add_outline");

        /// <summary>
        /// </summary>
        [GodotMethod("add_outline")]
        public void AddOutline(Vector2[] outline)
        {
            NativeCalls.godot_icall_1_237(method_bind_6, Object.GetPtr(this), outline);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "add_outline_at_index");

        /// <summary>
        /// </summary>
        [GodotMethod("add_outline_at_index")]
        public void AddOutlineAtIndex(Vector2[] outline, int index)
        {
            NativeCalls.godot_icall_2_528(method_bind_7, Object.GetPtr(this), outline, index);
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_outline_count");

        /// <summary>
        /// </summary>
        [GodotMethod("get_outline_count")]
        public int GetOutlineCount()
        {
            return NativeCalls.godot_icall_0_1(method_bind_8, Object.GetPtr(this));
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_outline");

        /// <summary>
        /// </summary>
        [GodotMethod("set_outline")]
        public void SetOutline(int idx, Vector2[] outline)
        {
            NativeCalls.godot_icall_2_529(method_bind_9, Object.GetPtr(this), idx, outline);
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_outline");

        /// <summary>
        /// </summary>
        [GodotMethod("get_outline")]
        public Vector2[] GetOutline(int idx)
        {
            return NativeCalls.godot_icall_1_530(method_bind_10, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "remove_outline");

        /// <summary>
        /// </summary>
        [GodotMethod("remove_outline")]
        public void RemoveOutline(int idx)
        {
            NativeCalls.godot_icall_1_0(method_bind_11, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "clear_outlines");

        /// <summary>
        /// </summary>
        [GodotMethod("clear_outlines")]
        public void ClearOutlines()
        {
            NativeCalls.godot_icall_0_12(method_bind_12, Object.GetPtr(this));
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "make_polygons_from_outlines");

        /// <summary>
        /// </summary>
        [GodotMethod("make_polygons_from_outlines")]
        public void MakePolygonsFromOutlines()
        {
            NativeCalls.godot_icall_0_12(method_bind_13, Object.GetPtr(this));
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_set_polygons");

        internal void _SetPolygons(object[] polygons)
        {
            NativeCalls.godot_icall_1_154(method_bind_14, Object.GetPtr(this), polygons);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_get_polygons");

        internal object[] _GetPolygons()
        {
            return NativeCalls.godot_icall_0_21(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_set_outlines");

        internal void _SetOutlines(object[] outlines)
        {
            NativeCalls.godot_icall_1_154(method_bind_16, Object.GetPtr(this), outlines);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_get_outlines");

        internal object[] _GetOutlines()
        {
            return NativeCalls.godot_icall_0_21(method_bind_17, Object.GetPtr(this));
        }
    }
}
