using System;

namespace Godot
{
    public class NavigationPolygonInstance : Node2D
    {
        /// <summary>
        /// </summary>
        public NavigationPolygon Navpoly
        {
            get
            {
                return GetNavigationPolygon();
            }
            set
            {
                SetNavigationPolygon(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Enabled
        {
            get
            {
                return IsEnabled();
            }
            set
            {
                SetEnabled(value);
            }
        }


        private const string nativeName = "NavigationPolygonInstance";

        public NavigationPolygonInstance() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_NavigationPolygonInstance_Ctor(this);
        }

        internal NavigationPolygonInstance(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_navigation_polygon");

        [GodotMethod("set_navigation_polygon")]
        public void SetNavigationPolygon(NavigationPolygon navpoly)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(navpoly));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_navigation_polygon");

        [GodotMethod("get_navigation_polygon")]
        public NavigationPolygon GetNavigationPolygon()
        {
            return NativeCalls.godot_icall_0_531(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_enabled");

        [GodotMethod("set_enabled")]
        public void SetEnabled(bool enabled)
        {
            NativeCalls.godot_icall_1_11(method_bind_2, Object.GetPtr(this), enabled);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_enabled");

        [GodotMethod("is_enabled")]
        public bool IsEnabled()
        {
            return NativeCalls.godot_icall_0_3(method_bind_3, Object.GetPtr(this));
        }
    }
}
