using System;

namespace Godot
{
    /// <summary>
    /// Optimized translation. Uses real-time compressed translations, which results in very small dictionaries.
    /// </summary>
    public class PHashTranslation : Translation
    {
        private const string nativeName = "PHashTranslation";

        public PHashTranslation() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_PHashTranslation_Ctor(this);
        }

        internal PHashTranslation(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "generate");

        /// <summary>
        /// </summary>
        [GodotMethod("generate")]
        public void Generate(Translation from)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(from));
        }
    }
}
