using System;

namespace Godot
{
    public class PanoramaSky : Sky
    {
        /// <summary>
        /// </summary>
        public Texture Panorama
        {
            get
            {
                return GetPanorama();
            }
            set
            {
                SetPanorama(value);
            }
        }


        private const string nativeName = "PanoramaSky";

        public PanoramaSky() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_PanoramaSky_Ctor(this);
        }

        internal PanoramaSky(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_panorama");

        [GodotMethod("set_panorama")]
        public void SetPanorama(Texture texture)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(texture));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_panorama");

        [GodotMethod("get_panorama")]
        public Texture GetPanorama()
        {
            return NativeCalls.godot_icall_0_119(method_bind_1, Object.GetPtr(this));
        }
    }
}
