using System;

namespace Godot
{
    /// <summary>
    /// This class is a container/Node-ification of a [Curve3D], so it can have [Spatial] properties and [Node] info.
    /// </summary>
    public class Path : Spatial
    {
        /// <summary>
        /// </summary>
        public Curve3D Curve
        {
            get
            {
                return GetCurve();
            }
            set
            {
                SetCurve(value);
            }
        }


        private const string nativeName = "Path";

        public Path() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_Path_Ctor(this);
        }

        internal Path(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_curve");

        [GodotMethod("set_curve")]
        public void SetCurve(Curve3D curve)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(curve));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_curve");

        [GodotMethod("get_curve")]
        public Curve3D GetCurve()
        {
            return NativeCalls.godot_icall_0_596(method_bind_1, Object.GetPtr(this));
        }
    }
}
