using System;

namespace Godot
{
    /// <summary>
    /// Can have [PathFollow2D] child-nodes moving along the [Curve2D]. See [PathFollow2D] for more information on this usage.
    /// </summary>
    public class Path2D : Node2D
    {
        /// <summary>
        /// A [Curve2D] describing the path.
        /// </summary>
        public Curve2D Curve
        {
            get
            {
                return GetCurve();
            }
            set
            {
                SetCurve(value);
            }
        }


        private const string nativeName = "Path2D";

        public Path2D() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_Path2D_Ctor(this);
        }

        internal Path2D(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_curve");

        [GodotMethod("set_curve")]
        public void SetCurve(Curve2D curve)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(curve));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_curve");

        [GodotMethod("get_curve")]
        public Curve2D GetCurve()
        {
            return NativeCalls.godot_icall_0_597(method_bind_1, Object.GetPtr(this));
        }
    }
}
