using System;

namespace Godot
{
    public class Physics2DTestMotionResult : Reference
    {
        /// <summary>
        /// </summary>
        public Vector2 Motion
        {
            get
            {
                return GetMotion();
            }
        }

        /// <summary>
        /// </summary>
        public Vector2 MotionRemainder
        {
            get
            {
                return GetMotionRemainder();
            }
        }

        /// <summary>
        /// </summary>
        public Vector2 CollisionPoint
        {
            get
            {
                return GetCollisionPoint();
            }
        }

        /// <summary>
        /// </summary>
        public Vector2 CollisionNormal
        {
            get
            {
                return GetCollisionNormal();
            }
        }

        /// <summary>
        /// </summary>
        public Vector2 ColliderVelocity
        {
            get
            {
                return GetColliderVelocity();
            }
        }

        /// <summary>
        /// </summary>
        public int ColliderId
        {
            get
            {
                return GetColliderId();
            }
        }

        /// <summary>
        /// </summary>
        public RID ColliderRid
        {
            get
            {
                return GetColliderRid();
            }
        }

        /// <summary>
        /// </summary>
        public Object Collider
        {
            get
            {
                return GetCollider();
            }
        }

        /// <summary>
        /// </summary>
        public int ColliderShape
        {
            get
            {
                return GetColliderShape();
            }
        }


        private const string nativeName = "Physics2DTestMotionResult";

        public Physics2DTestMotionResult() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_Physics2DTestMotionResult_Ctor(this);
        }

        internal Physics2DTestMotionResult(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_motion");

        [GodotMethod("get_motion")]
        public Vector2 GetMotion()
        {
            object ret = NativeCalls.godot_icall_0_14(method_bind_0, Object.GetPtr(this));
            return (Vector2)ret;
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_motion_remainder");

        [GodotMethod("get_motion_remainder")]
        public Vector2 GetMotionRemainder()
        {
            object ret = NativeCalls.godot_icall_0_14(method_bind_1, Object.GetPtr(this));
            return (Vector2)ret;
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_collision_point");

        [GodotMethod("get_collision_point")]
        public Vector2 GetCollisionPoint()
        {
            object ret = NativeCalls.godot_icall_0_14(method_bind_2, Object.GetPtr(this));
            return (Vector2)ret;
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_collision_normal");

        [GodotMethod("get_collision_normal")]
        public Vector2 GetCollisionNormal()
        {
            object ret = NativeCalls.godot_icall_0_14(method_bind_3, Object.GetPtr(this));
            return (Vector2)ret;
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_collider_velocity");

        [GodotMethod("get_collider_velocity")]
        public Vector2 GetColliderVelocity()
        {
            object ret = NativeCalls.godot_icall_0_14(method_bind_4, Object.GetPtr(this));
            return (Vector2)ret;
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_collider_id");

        [GodotMethod("get_collider_id")]
        public int GetColliderId()
        {
            return NativeCalls.godot_icall_0_1(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_collider_rid");

        [GodotMethod("get_collider_rid")]
        public RID GetColliderRid()
        {
            IntPtr ret = NativeCalls.godot_icall_0_201(method_bind_6, Object.GetPtr(this));
            return new RID(ret);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_collider");

        [GodotMethod("get_collider")]
        public Object GetCollider()
        {
            return NativeCalls.godot_icall_0_475(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_collider_shape");

        [GodotMethod("get_collider_shape")]
        public int GetColliderShape()
        {
            return NativeCalls.godot_icall_0_1(method_bind_8, Object.GetPtr(this));
        }
    }
}
