using System;

namespace Godot
{
    public class PhysicsShapeQueryParameters : Reference
    {
        /// <summary>
        /// </summary>
        public int CollisionMask
        {
            get
            {
                return GetCollisionMask();
            }
            set
            {
                SetCollisionMask(value);
            }
        }

        /// <summary>
        /// </summary>
        public object[] Exclude
        {
            get
            {
                return GetExclude();
            }
            set
            {
                SetExclude(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Margin
        {
            get
            {
                return GetMargin();
            }
            set
            {
                SetMargin(value);
            }
        }

        /// <summary>
        /// </summary>
        public RID ShapeRid
        {
            get
            {
                return GetShapeRid();
            }
            set
            {
                SetShapeRid(value);
            }
        }

        /// <summary>
        /// </summary>
        public Transform Transform
        {
            get
            {
                return GetTransform();
            }
            set
            {
                SetTransform(value);
            }
        }


        private const string nativeName = "PhysicsShapeQueryParameters";

        public PhysicsShapeQueryParameters() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_PhysicsShapeQueryParameters_Ctor(this);
        }

        internal PhysicsShapeQueryParameters(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_shape");

        /// <summary>
        /// </summary>
        [GodotMethod("set_shape")]
        public void SetShape(Resource shape)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(shape));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_shape_rid");

        [GodotMethod("set_shape_rid")]
        public void SetShapeRid(RID shape)
        {
            NativeCalls.godot_icall_1_627(method_bind_1, Object.GetPtr(this), RID.GetPtr(shape));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_shape_rid");

        [GodotMethod("get_shape_rid")]
        public RID GetShapeRid()
        {
            IntPtr ret = NativeCalls.godot_icall_0_201(method_bind_2, Object.GetPtr(this));
            return new RID(ret);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_transform");

        [GodotMethod("set_transform")]
        public void SetTransform(Transform transform)
        {
            NativeCalls.godot_icall_1_155(method_bind_3, Object.GetPtr(this), ref transform);
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_transform");

        [GodotMethod("get_transform")]
        public Transform GetTransform()
        {
            object ret = NativeCalls.godot_icall_0_18(method_bind_4, Object.GetPtr(this));
            return (Transform)ret;
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_margin");

        [GodotMethod("set_margin")]
        public void SetMargin(float margin)
        {
            NativeCalls.godot_icall_1_10(method_bind_5, Object.GetPtr(this), margin);
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_margin");

        [GodotMethod("get_margin")]
        public float GetMargin()
        {
            return NativeCalls.godot_icall_0_9(method_bind_6, Object.GetPtr(this));
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_collision_mask");

        [GodotMethod("set_collision_mask")]
        public void SetCollisionMask(int collisionMask)
        {
            NativeCalls.godot_icall_1_0(method_bind_7, Object.GetPtr(this), collisionMask);
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_collision_mask");

        [GodotMethod("get_collision_mask")]
        public int GetCollisionMask()
        {
            return NativeCalls.godot_icall_0_1(method_bind_8, Object.GetPtr(this));
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_exclude");

        [GodotMethod("set_exclude")]
        public void SetExclude(object[] exclude)
        {
            NativeCalls.godot_icall_1_154(method_bind_9, Object.GetPtr(this), exclude);
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_exclude");

        [GodotMethod("get_exclude")]
        public object[] GetExclude()
        {
            return NativeCalls.godot_icall_0_21(method_bind_10, Object.GetPtr(this));
        }
    }
}
