using System;

namespace Godot
{
    public class PlaneShape : Shape
    {
        /// <summary>
        /// </summary>
        public Plane Plane
        {
            get
            {
                return GetPlane();
            }
            set
            {
                SetPlane(value);
            }
        }


        private const string nativeName = "PlaneShape";

        public PlaneShape() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_PlaneShape_Ctor(this);
        }

        internal PlaneShape(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_plane");

        [GodotMethod("set_plane")]
        public void SetPlane(Plane plane)
        {
            NativeCalls.godot_icall_1_436(method_bind_0, Object.GetPtr(this), ref plane);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_plane");

        [GodotMethod("get_plane")]
        public Plane GetPlane()
        {
            object ret = NativeCalls.godot_icall_0_5(method_bind_1, Object.GetPtr(this));
            return (Plane)ret;
        }
    }
}
