using System;
using System.Collections.Generic;

namespace Godot
{
    public class PolygonPathFinder : Resource
    {
        public Dictionary<object, object> Data
        {
            get
            {
                return _GetData();
            }
            set
            {
                _SetData(value);
            }
        }

        private const string nativeName = "PolygonPathFinder";

        public PolygonPathFinder() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_PolygonPathFinder_Ctor(this);
        }

        internal PolygonPathFinder(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "setup");

        /// <summary>
        /// </summary>
        [GodotMethod("setup")]
        public void Setup(Vector2[] points, int[] connections)
        {
            NativeCalls.godot_icall_2_710(method_bind_0, Object.GetPtr(this), points, connections);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "find_path");

        /// <summary>
        /// </summary>
        [GodotMethod("find_path")]
        public Vector2[] FindPath(Vector2 from, Vector2 to)
        {
            return NativeCalls.godot_icall_2_711(method_bind_1, Object.GetPtr(this), ref from, ref to);
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_intersections");

        /// <summary>
        /// </summary>
        [GodotMethod("get_intersections")]
        public Vector2[] GetIntersections(Vector2 from, Vector2 to)
        {
            return NativeCalls.godot_icall_2_711(method_bind_2, Object.GetPtr(this), ref from, ref to);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_closest_point");

        /// <summary>
        /// </summary>
        [GodotMethod("get_closest_point")]
        public Vector2 GetClosestPoint(Vector2 point)
        {
            object ret = NativeCalls.godot_icall_1_223(method_bind_3, Object.GetPtr(this), ref point);
            return (Vector2)ret;
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_point_inside");

        /// <summary>
        /// </summary>
        [GodotMethod("is_point_inside")]
        public bool IsPointInside(Vector2 point)
        {
            return NativeCalls.godot_icall_1_166(method_bind_4, Object.GetPtr(this), ref point);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_point_penalty");

        /// <summary>
        /// </summary>
        [GodotMethod("set_point_penalty")]
        public void SetPointPenalty(int idx, float penalty)
        {
            NativeCalls.godot_icall_2_28(method_bind_5, Object.GetPtr(this), idx, penalty);
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_point_penalty");

        /// <summary>
        /// </summary>
        [GodotMethod("get_point_penalty")]
        public float GetPointPenalty(int idx)
        {
            return NativeCalls.godot_icall_1_7(method_bind_6, Object.GetPtr(this), idx);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_bounds");

        /// <summary>
        /// </summary>
        [GodotMethod("get_bounds")]
        public Rect2 GetBounds()
        {
            object ret = NativeCalls.godot_icall_0_121(method_bind_7, Object.GetPtr(this));
            return (Rect2)ret;
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_set_data");

        internal void _SetData(Dictionary<object, object> arg0)
        {
            NativeCalls.godot_icall_1_168(method_bind_8, Object.GetPtr(this), arg0);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_get_data");

        internal Dictionary<object, object> _GetData()
        {
            return NativeCalls.godot_icall_0_169(method_bind_9, Object.GetPtr(this));
        }
    }
}
