using System;

namespace Godot
{
    public class ProceduralSky : Sky
    {
        public enum TextureSizeEnum
        {
            Size256 = 0,
            Size512 = 1,
            Size1024 = 2,
            Size2048 = 3,
            Size4096 = 4,
            Max = 5
        }


        /// <summary>
        /// </summary>
        public Color SkyTopColor
        {
            get
            {
                return GetSkyTopColor();
            }
            set
            {
                SetSkyTopColor(value);
            }
        }

        /// <summary>
        /// </summary>
        public Color SkyHorizonColor
        {
            get
            {
                return GetSkyHorizonColor();
            }
            set
            {
                SetSkyHorizonColor(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SkyCurve
        {
            get
            {
                return GetSkyCurve();
            }
            set
            {
                SetSkyCurve(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SkyEnergy
        {
            get
            {
                return GetSkyEnergy();
            }
            set
            {
                SetSkyEnergy(value);
            }
        }

        /// <summary>
        /// </summary>
        public Color GroundBottomColor
        {
            get
            {
                return GetGroundBottomColor();
            }
            set
            {
                SetGroundBottomColor(value);
            }
        }

        /// <summary>
        /// </summary>
        public Color GroundHorizonColor
        {
            get
            {
                return GetGroundHorizonColor();
            }
            set
            {
                SetGroundHorizonColor(value);
            }
        }

        /// <summary>
        /// </summary>
        public float GroundCurve
        {
            get
            {
                return GetGroundCurve();
            }
            set
            {
                SetGroundCurve(value);
            }
        }

        /// <summary>
        /// </summary>
        public float GroundEnergy
        {
            get
            {
                return GetGroundEnergy();
            }
            set
            {
                SetGroundEnergy(value);
            }
        }

        /// <summary>
        /// </summary>
        public Color SunColor
        {
            get
            {
                return GetSunColor();
            }
            set
            {
                SetSunColor(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SunLatitude
        {
            get
            {
                return GetSunLatitude();
            }
            set
            {
                SetSunLatitude(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SunLongitude
        {
            get
            {
                return GetSunLongitude();
            }
            set
            {
                SetSunLongitude(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SunAngleMin
        {
            get
            {
                return GetSunAngleMin();
            }
            set
            {
                SetSunAngleMin(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SunAngleMax
        {
            get
            {
                return GetSunAngleMax();
            }
            set
            {
                SetSunAngleMax(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SunCurve
        {
            get
            {
                return GetSunCurve();
            }
            set
            {
                SetSunCurve(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SunEnergy
        {
            get
            {
                return GetSunEnergy();
            }
            set
            {
                SetSunEnergy(value);
            }
        }

        /// <summary>
        /// </summary>
        public ProceduralSky.TextureSizeEnum TextureSize
        {
            get
            {
                return GetTextureSize();
            }
            set
            {
                SetTextureSize(value);
            }
        }


        private const string nativeName = "ProceduralSky";

        public ProceduralSky() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ProceduralSky_Ctor(this);
        }

        internal ProceduralSky(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sky_top_color");

        [GodotMethod("set_sky_top_color")]
        public void SetSkyTopColor(Color color)
        {
            NativeCalls.godot_icall_1_202(method_bind_0, Object.GetPtr(this), ref color);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sky_top_color");

        [GodotMethod("get_sky_top_color")]
        public Color GetSkyTopColor()
        {
            object ret = NativeCalls.godot_icall_0_203(method_bind_1, Object.GetPtr(this));
            return (Color)ret;
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sky_horizon_color");

        [GodotMethod("set_sky_horizon_color")]
        public void SetSkyHorizonColor(Color color)
        {
            NativeCalls.godot_icall_1_202(method_bind_2, Object.GetPtr(this), ref color);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sky_horizon_color");

        [GodotMethod("get_sky_horizon_color")]
        public Color GetSkyHorizonColor()
        {
            object ret = NativeCalls.godot_icall_0_203(method_bind_3, Object.GetPtr(this));
            return (Color)ret;
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sky_curve");

        [GodotMethod("set_sky_curve")]
        public void SetSkyCurve(float curve)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), curve);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sky_curve");

        [GodotMethod("get_sky_curve")]
        public float GetSkyCurve()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sky_energy");

        [GodotMethod("set_sky_energy")]
        public void SetSkyEnergy(float energy)
        {
            NativeCalls.godot_icall_1_10(method_bind_6, Object.GetPtr(this), energy);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sky_energy");

        [GodotMethod("get_sky_energy")]
        public float GetSkyEnergy()
        {
            return NativeCalls.godot_icall_0_9(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_ground_bottom_color");

        [GodotMethod("set_ground_bottom_color")]
        public void SetGroundBottomColor(Color color)
        {
            NativeCalls.godot_icall_1_202(method_bind_8, Object.GetPtr(this), ref color);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_ground_bottom_color");

        [GodotMethod("get_ground_bottom_color")]
        public Color GetGroundBottomColor()
        {
            object ret = NativeCalls.godot_icall_0_203(method_bind_9, Object.GetPtr(this));
            return (Color)ret;
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_ground_horizon_color");

        [GodotMethod("set_ground_horizon_color")]
        public void SetGroundHorizonColor(Color color)
        {
            NativeCalls.godot_icall_1_202(method_bind_10, Object.GetPtr(this), ref color);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_ground_horizon_color");

        [GodotMethod("get_ground_horizon_color")]
        public Color GetGroundHorizonColor()
        {
            object ret = NativeCalls.godot_icall_0_203(method_bind_11, Object.GetPtr(this));
            return (Color)ret;
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_ground_curve");

        [GodotMethod("set_ground_curve")]
        public void SetGroundCurve(float curve)
        {
            NativeCalls.godot_icall_1_10(method_bind_12, Object.GetPtr(this), curve);
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_ground_curve");

        [GodotMethod("get_ground_curve")]
        public float GetGroundCurve()
        {
            return NativeCalls.godot_icall_0_9(method_bind_13, Object.GetPtr(this));
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_ground_energy");

        [GodotMethod("set_ground_energy")]
        public void SetGroundEnergy(float energy)
        {
            NativeCalls.godot_icall_1_10(method_bind_14, Object.GetPtr(this), energy);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_ground_energy");

        [GodotMethod("get_ground_energy")]
        public float GetGroundEnergy()
        {
            return NativeCalls.godot_icall_0_9(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sun_color");

        [GodotMethod("set_sun_color")]
        public void SetSunColor(Color color)
        {
            NativeCalls.godot_icall_1_202(method_bind_16, Object.GetPtr(this), ref color);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sun_color");

        [GodotMethod("get_sun_color")]
        public Color GetSunColor()
        {
            object ret = NativeCalls.godot_icall_0_203(method_bind_17, Object.GetPtr(this));
            return (Color)ret;
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sun_latitude");

        [GodotMethod("set_sun_latitude")]
        public void SetSunLatitude(float degrees)
        {
            NativeCalls.godot_icall_1_10(method_bind_18, Object.GetPtr(this), degrees);
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sun_latitude");

        [GodotMethod("get_sun_latitude")]
        public float GetSunLatitude()
        {
            return NativeCalls.godot_icall_0_9(method_bind_19, Object.GetPtr(this));
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sun_longitude");

        [GodotMethod("set_sun_longitude")]
        public void SetSunLongitude(float degrees)
        {
            NativeCalls.godot_icall_1_10(method_bind_20, Object.GetPtr(this), degrees);
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sun_longitude");

        [GodotMethod("get_sun_longitude")]
        public float GetSunLongitude()
        {
            return NativeCalls.godot_icall_0_9(method_bind_21, Object.GetPtr(this));
        }

        private IntPtr method_bind_22 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sun_angle_min");

        [GodotMethod("set_sun_angle_min")]
        public void SetSunAngleMin(float degrees)
        {
            NativeCalls.godot_icall_1_10(method_bind_22, Object.GetPtr(this), degrees);
        }

        private IntPtr method_bind_23 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sun_angle_min");

        [GodotMethod("get_sun_angle_min")]
        public float GetSunAngleMin()
        {
            return NativeCalls.godot_icall_0_9(method_bind_23, Object.GetPtr(this));
        }

        private IntPtr method_bind_24 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sun_angle_max");

        [GodotMethod("set_sun_angle_max")]
        public void SetSunAngleMax(float degrees)
        {
            NativeCalls.godot_icall_1_10(method_bind_24, Object.GetPtr(this), degrees);
        }

        private IntPtr method_bind_25 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sun_angle_max");

        [GodotMethod("get_sun_angle_max")]
        public float GetSunAngleMax()
        {
            return NativeCalls.godot_icall_0_9(method_bind_25, Object.GetPtr(this));
        }

        private IntPtr method_bind_26 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sun_curve");

        [GodotMethod("set_sun_curve")]
        public void SetSunCurve(float curve)
        {
            NativeCalls.godot_icall_1_10(method_bind_26, Object.GetPtr(this), curve);
        }

        private IntPtr method_bind_27 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sun_curve");

        [GodotMethod("get_sun_curve")]
        public float GetSunCurve()
        {
            return NativeCalls.godot_icall_0_9(method_bind_27, Object.GetPtr(this));
        }

        private IntPtr method_bind_28 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_sun_energy");

        [GodotMethod("set_sun_energy")]
        public void SetSunEnergy(float energy)
        {
            NativeCalls.godot_icall_1_10(method_bind_28, Object.GetPtr(this), energy);
        }

        private IntPtr method_bind_29 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_sun_energy");

        [GodotMethod("get_sun_energy")]
        public float GetSunEnergy()
        {
            return NativeCalls.godot_icall_0_9(method_bind_29, Object.GetPtr(this));
        }

        private IntPtr method_bind_30 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_texture_size");

        [GodotMethod("set_texture_size")]
        public void SetTextureSize(ProceduralSky.TextureSizeEnum size)
        {
            NativeCalls.godot_icall_1_719(method_bind_30, Object.GetPtr(this), size);
        }

        private IntPtr method_bind_31 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_texture_size");

        [GodotMethod("get_texture_size")]
        public ProceduralSky.TextureSizeEnum GetTextureSize()
        {
            return NativeCalls.godot_icall_0_720(method_bind_31, Object.GetPtr(this));
        }
    }
}
