using System;

namespace Godot
{
    /// <summary>
    /// General purpose progress bar. Shows fill percentage from right to left.
    /// </summary>
    public class ProgressBar : Range
    {
        /// <summary>
        /// </summary>
        public bool PercentVisible
        {
            get
            {
                return IsPercentVisible();
            }
            set
            {
                SetPercentVisible(value);
            }
        }


        private const string nativeName = "ProgressBar";

        public ProgressBar() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ProgressBar_Ctor(this);
        }

        internal ProgressBar(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_percent_visible");

        [GodotMethod("set_percent_visible")]
        public void SetPercentVisible(bool visible)
        {
            NativeCalls.godot_icall_1_11(method_bind_0, Object.GetPtr(this), visible);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_percent_visible");

        [GodotMethod("is_percent_visible")]
        public bool IsPercentVisible()
        {
            return NativeCalls.godot_icall_0_3(method_bind_1, Object.GetPtr(this));
        }
    }
}
