using System;

namespace Godot
{
    /// <summary>
    /// General purpose proximity-detection node.
    /// </summary>
    public class ProximityGroup : Spatial
    {
        public enum DispatchModeEnum
        {
            Proxy = 0,
            Signal = 1
        }


        /// <summary>
        /// </summary>
        public string GroupName
        {
            get
            {
                return GetGroupName();
            }
            set
            {
                SetGroupName(value);
            }
        }

        /// <summary>
        /// </summary>
        public ProximityGroup.DispatchModeEnum DispatchMode
        {
            get
            {
                return GetDispatchMode();
            }
            set
            {
                SetDispatchMode(value);
            }
        }

        /// <summary>
        /// </summary>
        public Vector3 GridRadius
        {
            get
            {
                return GetGridRadius();
            }
            set
            {
                SetGridRadius(value);
            }
        }


        private const string nativeName = "ProximityGroup";

        public ProximityGroup() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ProximityGroup_Ctor(this);
        }

        internal ProximityGroup(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_group_name");

        [GodotMethod("set_group_name")]
        public void SetGroupName(string name)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), name);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_group_name");

        [GodotMethod("get_group_name")]
        public string GetGroupName()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_dispatch_mode");

        [GodotMethod("set_dispatch_mode")]
        public void SetDispatchMode(ProximityGroup.DispatchModeEnum mode)
        {
            NativeCalls.godot_icall_1_721(method_bind_2, Object.GetPtr(this), mode);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_dispatch_mode");

        [GodotMethod("get_dispatch_mode")]
        public ProximityGroup.DispatchModeEnum GetDispatchMode()
        {
            return NativeCalls.godot_icall_0_722(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_grid_radius");

        [GodotMethod("set_grid_radius")]
        public void SetGridRadius(Vector3 radius)
        {
            NativeCalls.godot_icall_1_104(method_bind_4, Object.GetPtr(this), ref radius);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_grid_radius");

        [GodotMethod("get_grid_radius")]
        public Vector3 GetGridRadius()
        {
            object ret = NativeCalls.godot_icall_0_4(method_bind_5, Object.GetPtr(this));
            return (Vector3)ret;
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "broadcast");

        /// <summary>
        /// </summary>
        [GodotMethod("broadcast")]
        public void Broadcast(string name, object parameters)
        {
            NativeCalls.godot_icall_2_337(method_bind_6, Object.GetPtr(this), name, parameters);
        }
    }
}
