using System;

namespace Godot
{
    public class ProxyTexture : Texture
    {
        /// <summary>
        /// </summary>
        public Texture Base
        {
            get
            {
                return GetBase();
            }
            set
            {
                SetBase(value);
            }
        }


        private const string nativeName = "ProxyTexture";

        public ProxyTexture() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ProxyTexture_Ctor(this);
        }

        internal ProxyTexture(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base");

        [GodotMethod("set_base")]
        public void SetBase(Texture @base)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(@base));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base");

        [GodotMethod("get_base")]
        public Texture GetBase()
        {
            return NativeCalls.godot_icall_0_119(method_bind_1, Object.GetPtr(this));
        }
    }
}
