using System;

namespace Godot
{
    /// <summary>
    /// Class representing a square mesh with size (2,2,0). Consider using a [PlaneMesh] if you require a differently sized plane.
    /// </summary>
    public class QuadMesh : PrimitiveMesh
    {
        /// <summary>
        /// </summary>
        public Vector2 Size
        {
            get
            {
                return GetSize();
            }
            set
            {
                SetSize(value);
            }
        }


        private const string nativeName = "QuadMesh";

        public QuadMesh() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_QuadMesh_Ctor(this);
        }

        internal QuadMesh(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_size");

        [GodotMethod("set_size")]
        public void SetSize(Vector2 size)
        {
            NativeCalls.godot_icall_1_45(method_bind_0, Object.GetPtr(this), ref size);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_size");

        [GodotMethod("get_size")]
        public Vector2 GetSize()
        {
            object ret = NativeCalls.godot_icall_0_14(method_bind_1, Object.GetPtr(this));
            return (Vector2)ret;
        }
    }
}
