using System;

namespace Godot
{
    public class ReflectionProbe : VisualInstance
    {
        public enum UpdateModeEnum
        {
            Once = 0,
            Always = 1
        }


        /// <summary>
        /// </summary>
        public ReflectionProbe.UpdateModeEnum UpdateMode
        {
            get
            {
                return GetUpdateMode();
            }
            set
            {
                SetUpdateMode(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Intensity
        {
            get
            {
                return GetIntensity();
            }
            set
            {
                SetIntensity(value);
            }
        }

        /// <summary>
        /// </summary>
        public float MaxDistance
        {
            get
            {
                return GetMaxDistance();
            }
            set
            {
                SetMaxDistance(value);
            }
        }

        /// <summary>
        /// </summary>
        public Vector3 Extents
        {
            get
            {
                return GetExtents();
            }
            set
            {
                SetExtents(value);
            }
        }

        /// <summary>
        /// </summary>
        public Vector3 OriginOffset
        {
            get
            {
                return GetOriginOffset();
            }
            set
            {
                SetOriginOffset(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool BoxProjection
        {
            get
            {
                return IsBoxProjectionEnabled();
            }
            set
            {
                SetEnableBoxProjection(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool EnableShadows
        {
            get
            {
                return AreShadowsEnabled();
            }
            set
            {
                SetEnableShadows(value);
            }
        }

        /// <summary>
        /// </summary>
        public int CullMask
        {
            get
            {
                return GetCullMask();
            }
            set
            {
                SetCullMask(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool InteriorEnable
        {
            get
            {
                return IsSetAsInterior();
            }
            set
            {
                SetAsInterior(value);
            }
        }

        /// <summary>
        /// </summary>
        public Color InteriorAmbientColor
        {
            get
            {
                return GetInteriorAmbient();
            }
            set
            {
                SetInteriorAmbient(value);
            }
        }

        /// <summary>
        /// </summary>
        public float InteriorAmbientEnergy
        {
            get
            {
                return GetInteriorAmbientEnergy();
            }
            set
            {
                SetInteriorAmbientEnergy(value);
            }
        }

        /// <summary>
        /// </summary>
        public float InteriorAmbientContrib
        {
            get
            {
                return GetInteriorAmbientProbeContribution();
            }
            set
            {
                SetInteriorAmbientProbeContribution(value);
            }
        }


        private const string nativeName = "ReflectionProbe";

        public ReflectionProbe() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ReflectionProbe_Ctor(this);
        }

        internal ReflectionProbe(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_intensity");

        [GodotMethod("set_intensity")]
        public void SetIntensity(float intensity)
        {
            NativeCalls.godot_icall_1_10(method_bind_0, Object.GetPtr(this), intensity);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_intensity");

        [GodotMethod("get_intensity")]
        public float GetIntensity()
        {
            return NativeCalls.godot_icall_0_9(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_interior_ambient");

        [GodotMethod("set_interior_ambient")]
        public void SetInteriorAmbient(Color ambient)
        {
            NativeCalls.godot_icall_1_202(method_bind_2, Object.GetPtr(this), ref ambient);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_interior_ambient");

        [GodotMethod("get_interior_ambient")]
        public Color GetInteriorAmbient()
        {
            object ret = NativeCalls.godot_icall_0_203(method_bind_3, Object.GetPtr(this));
            return (Color)ret;
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_interior_ambient_energy");

        [GodotMethod("set_interior_ambient_energy")]
        public void SetInteriorAmbientEnergy(float ambientEnergy)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), ambientEnergy);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_interior_ambient_energy");

        [GodotMethod("get_interior_ambient_energy")]
        public float GetInteriorAmbientEnergy()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_interior_ambient_probe_contribution");

        [GodotMethod("set_interior_ambient_probe_contribution")]
        public void SetInteriorAmbientProbeContribution(float ambientProbeContribution)
        {
            NativeCalls.godot_icall_1_10(method_bind_6, Object.GetPtr(this), ambientProbeContribution);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_interior_ambient_probe_contribution");

        [GodotMethod("get_interior_ambient_probe_contribution")]
        public float GetInteriorAmbientProbeContribution()
        {
            return NativeCalls.godot_icall_0_9(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_max_distance");

        [GodotMethod("set_max_distance")]
        public void SetMaxDistance(float maxDistance)
        {
            NativeCalls.godot_icall_1_10(method_bind_8, Object.GetPtr(this), maxDistance);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_max_distance");

        [GodotMethod("get_max_distance")]
        public float GetMaxDistance()
        {
            return NativeCalls.godot_icall_0_9(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_extents");

        [GodotMethod("set_extents")]
        public void SetExtents(Vector3 extents)
        {
            NativeCalls.godot_icall_1_104(method_bind_10, Object.GetPtr(this), ref extents);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_extents");

        [GodotMethod("get_extents")]
        public Vector3 GetExtents()
        {
            object ret = NativeCalls.godot_icall_0_4(method_bind_11, Object.GetPtr(this));
            return (Vector3)ret;
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_origin_offset");

        [GodotMethod("set_origin_offset")]
        public void SetOriginOffset(Vector3 originOffset)
        {
            NativeCalls.godot_icall_1_104(method_bind_12, Object.GetPtr(this), ref originOffset);
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_origin_offset");

        [GodotMethod("get_origin_offset")]
        public Vector3 GetOriginOffset()
        {
            object ret = NativeCalls.godot_icall_0_4(method_bind_13, Object.GetPtr(this));
            return (Vector3)ret;
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_as_interior");

        [GodotMethod("set_as_interior")]
        public void SetAsInterior(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_14, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_set_as_interior");

        [GodotMethod("is_set_as_interior")]
        public bool IsSetAsInterior()
        {
            return NativeCalls.godot_icall_0_3(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_enable_box_projection");

        [GodotMethod("set_enable_box_projection")]
        public void SetEnableBoxProjection(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_16, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_box_projection_enabled");

        [GodotMethod("is_box_projection_enabled")]
        public bool IsBoxProjectionEnabled()
        {
            return NativeCalls.godot_icall_0_3(method_bind_17, Object.GetPtr(this));
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_enable_shadows");

        [GodotMethod("set_enable_shadows")]
        public void SetEnableShadows(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_18, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "are_shadows_enabled");

        [GodotMethod("are_shadows_enabled")]
        public bool AreShadowsEnabled()
        {
            return NativeCalls.godot_icall_0_3(method_bind_19, Object.GetPtr(this));
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_cull_mask");

        [GodotMethod("set_cull_mask")]
        public void SetCullMask(int layers)
        {
            NativeCalls.godot_icall_1_0(method_bind_20, Object.GetPtr(this), layers);
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_cull_mask");

        [GodotMethod("get_cull_mask")]
        public int GetCullMask()
        {
            return NativeCalls.godot_icall_0_1(method_bind_21, Object.GetPtr(this));
        }

        private IntPtr method_bind_22 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_update_mode");

        [GodotMethod("set_update_mode")]
        public void SetUpdateMode(ReflectionProbe.UpdateModeEnum mode)
        {
            NativeCalls.godot_icall_1_723(method_bind_22, Object.GetPtr(this), mode);
        }

        private IntPtr method_bind_23 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_update_mode");

        [GodotMethod("get_update_mode")]
        public ReflectionProbe.UpdateModeEnum GetUpdateMode()
        {
            return NativeCalls.godot_icall_0_724(method_bind_23, Object.GetPtr(this));
        }
    }
}
