using System;

namespace Godot
{
    /// <summary>
    /// Scrollbars are a [Range] based [Control], that display a draggable area (the size of the page). Horizontal ([HScrollBar]) and Vertical ([VScrollBar]) versions are available.
    /// </summary>
    public class ScrollBar : Range
    {
        /// <summary>
        /// </summary>
        public float CustomStep
        {
            get
            {
                return GetCustomStep();
            }
            set
            {
                SetCustomStep(value);
            }
        }


        private const string nativeName = "ScrollBar";

        internal ScrollBar() {}

        internal ScrollBar(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_custom_step");

        [GodotMethod("set_custom_step")]
        public void SetCustomStep(float step)
        {
            NativeCalls.godot_icall_1_10(method_bind_0, Object.GetPtr(this), step);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_custom_step");

        [GodotMethod("get_custom_step")]
        public float GetCustomStep()
        {
            return NativeCalls.godot_icall_0_9(method_bind_1, Object.GetPtr(this));
        }
    }
}
