using System;

namespace Godot
{
    /// <summary>
    /// To be changed, ignore.
    /// </summary>
    public class Shader : Resource
    {
        public enum Mode
        {
            Spatial = 0,
            CanvasItem = 1,
            Particles = 2
        }


        /// <summary>
        /// </summary>
        public string Code
        {
            get
            {
                return GetCode();
            }
            set
            {
                SetCode(value);
            }
        }


        private const string nativeName = "Shader";

        public Shader() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_Shader_Ctor(this);
        }

        internal Shader(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_mode");

        /// <summary>
        /// </summary>
        [GodotMethod("get_mode")]
        public Shader.Mode GetMode()
        {
            return NativeCalls.godot_icall_0_758(method_bind_0, Object.GetPtr(this));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_code");

        [GodotMethod("set_code")]
        public void SetCode(string code)
        {
            NativeCalls.godot_icall_1_43(method_bind_1, Object.GetPtr(this), code);
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_code");

        [GodotMethod("get_code")]
        public string GetCode()
        {
            return NativeCalls.godot_icall_0_2(method_bind_2, Object.GetPtr(this));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_default_texture_param");

        /// <summary>
        /// </summary>
        [GodotMethod("set_default_texture_param")]
        public void SetDefaultTextureParam(string param, Texture texture)
        {
            NativeCalls.godot_icall_2_89(method_bind_3, Object.GetPtr(this), param, Object.GetPtr(texture));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_default_texture_param");

        /// <summary>
        /// </summary>
        [GodotMethod("get_default_texture_param")]
        public Texture GetDefaultTextureParam(string param)
        {
            return NativeCalls.godot_icall_1_759(method_bind_4, Object.GetPtr(this), param);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "has_param");

        /// <summary>
        /// </summary>
        [GodotMethod("has_param")]
        public bool HasParam(string name)
        {
            return NativeCalls.godot_icall_1_70(method_bind_5, Object.GetPtr(this), name);
        }
    }
}
