using System;

namespace Godot
{
    public class ShaderMaterial : Material
    {
        /// <summary>
        /// </summary>
        public Shader Shader
        {
            get
            {
                return GetShader();
            }
            set
            {
                SetShader(value);
            }
        }


        private const string nativeName = "ShaderMaterial";

        public ShaderMaterial() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ShaderMaterial_Ctor(this);
        }

        internal ShaderMaterial(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_shader");

        [GodotMethod("set_shader")]
        public void SetShader(Shader shader)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(shader));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_shader");

        [GodotMethod("get_shader")]
        public Shader GetShader()
        {
            return NativeCalls.godot_icall_0_760(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_shader_param");

        /// <summary>
        /// </summary>
        [GodotMethod("set_shader_param")]
        public void SetShaderParam(string param, object value)
        {
            NativeCalls.godot_icall_2_337(method_bind_2, Object.GetPtr(this), param, value);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_shader_param");

        /// <summary>
        /// </summary>
        [GodotMethod("get_shader_param")]
        public object GetShaderParam(string param)
        {
            return NativeCalls.godot_icall_1_338(method_bind_3, Object.GetPtr(this), param);
        }
    }
}
