using System;

namespace Godot
{
    /// <summary>
    /// Base class for GUI Sliders.
    /// </summary>
    public class Slider : Range
    {
        /// <summary>
        /// </summary>
        public bool Editable
        {
            get
            {
                return IsEditable();
            }
            set
            {
                SetEditable(value);
            }
        }

        /// <summary>
        /// </summary>
        public int TickCount
        {
            get
            {
                return GetTicks();
            }
            set
            {
                SetTicks(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool TicksOnBorders
        {
            get
            {
                return GetTicksOnBorders();
            }
            set
            {
                SetTicksOnBorders(value);
            }
        }

        /// <summary>
        /// </summary>
        public Control.FocusModeEnum FocusMode
        {
            get
            {
                return GetFocusMode();
            }
            set
            {
                SetFocusMode(value);
            }
        }


        private const string nativeName = "Slider";

        internal Slider() {}

        internal Slider(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_ticks");

        [GodotMethod("set_ticks")]
        public void SetTicks(int count)
        {
            NativeCalls.godot_icall_1_0(method_bind_0, Object.GetPtr(this), count);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_ticks");

        [GodotMethod("get_ticks")]
        public int GetTicks()
        {
            return NativeCalls.godot_icall_0_1(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_ticks_on_borders");

        [GodotMethod("get_ticks_on_borders")]
        public bool GetTicksOnBorders()
        {
            return NativeCalls.godot_icall_0_3(method_bind_2, Object.GetPtr(this));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_ticks_on_borders");

        [GodotMethod("set_ticks_on_borders")]
        public void SetTicksOnBorders(bool ticksOnBorder)
        {
            NativeCalls.godot_icall_1_11(method_bind_3, Object.GetPtr(this), ticksOnBorder);
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_editable");

        [GodotMethod("set_editable")]
        public void SetEditable(bool editable)
        {
            NativeCalls.godot_icall_1_11(method_bind_4, Object.GetPtr(this), editable);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_editable");

        [GodotMethod("is_editable")]
        public bool IsEditable()
        {
            return NativeCalls.godot_icall_0_3(method_bind_5, Object.GetPtr(this));
        }
    }
}
