using System;

namespace Godot
{
    public class SpatialVelocityTracker : Reference
    {
        /// <summary>
        /// </summary>
        public bool TrackPhysicsStep
        {
            get
            {
                return IsTrackingPhysicsStep();
            }
            set
            {
                SetTrackPhysicsStep(value);
            }
        }


        private const string nativeName = "SpatialVelocityTracker";

        public SpatialVelocityTracker() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_SpatialVelocityTracker_Ctor(this);
        }

        internal SpatialVelocityTracker(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_track_physics_step");

        [GodotMethod("set_track_physics_step")]
        public void SetTrackPhysicsStep(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_0, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_tracking_physics_step");

        [GodotMethod("is_tracking_physics_step")]
        public bool IsTrackingPhysicsStep()
        {
            return NativeCalls.godot_icall_0_3(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "update_position");

        /// <summary>
        /// </summary>
        [GodotMethod("update_position")]
        public void UpdatePosition(Vector3 position)
        {
            NativeCalls.godot_icall_1_104(method_bind_2, Object.GetPtr(this), ref position);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_tracked_linear_velocity");

        /// <summary>
        /// </summary>
        [GodotMethod("get_tracked_linear_velocity")]
        public Vector3 GetTrackedLinearVelocity()
        {
            object ret = NativeCalls.godot_icall_0_4(method_bind_3, Object.GetPtr(this));
            return (Vector3)ret;
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "reset");

        /// <summary>
        /// </summary>
        [GodotMethod("reset")]
        public void Reset(Vector3 position)
        {
            NativeCalls.godot_icall_1_104(method_bind_4, Object.GetPtr(this), ref position);
        }
    }
}
