using System;

namespace Godot
{
    /// <summary>
    /// SpinBox is a numerical input text field. It allows entering integers and floats.
    /// </summary>
    public class SpinBox : Range
    {
        /// <summary>
        /// </summary>
        public bool Editable
        {
            get
            {
                return IsEditable();
            }
            set
            {
                SetEditable(value);
            }
        }

        /// <summary>
        /// </summary>
        public string Prefix
        {
            get
            {
                return GetPrefix();
            }
            set
            {
                SetPrefix(value);
            }
        }

        /// <summary>
        /// </summary>
        public string Suffix
        {
            get
            {
                return GetSuffix();
            }
            set
            {
                SetSuffix(value);
            }
        }


        private const string nativeName = "SpinBox";

        public SpinBox() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_SpinBox_Ctor(this);
        }

        internal SpinBox(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_suffix");

        [GodotMethod("set_suffix")]
        public void SetSuffix(string suffix)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), suffix);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_suffix");

        [GodotMethod("get_suffix")]
        public string GetSuffix()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_prefix");

        [GodotMethod("set_prefix")]
        public void SetPrefix(string prefix)
        {
            NativeCalls.godot_icall_1_43(method_bind_2, Object.GetPtr(this), prefix);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_prefix");

        [GodotMethod("get_prefix")]
        public string GetPrefix()
        {
            return NativeCalls.godot_icall_0_2(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_editable");

        [GodotMethod("set_editable")]
        public void SetEditable(bool editable)
        {
            NativeCalls.godot_icall_1_11(method_bind_4, Object.GetPtr(this), editable);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_editable");

        [GodotMethod("is_editable")]
        public bool IsEditable()
        {
            return NativeCalls.godot_icall_0_3(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_line_edit");

        /// <summary>
        /// </summary>
        [GodotMethod("get_line_edit")]
        public LineEdit GetLineEdit()
        {
            return NativeCalls.godot_icall_0_800(method_bind_6, Object.GetPtr(this));
        }
    }
}
