using System;

namespace Godot
{
    /// <summary>
    /// A SpotLight light is a type of [Light] node that emits lights in a specific direction, in the shape of a cone. The light is attenuated through the distance and this attenuation can be configured by changing the energy, radius and attenuation parameters of [Light]. TODO: Image of a spotlight.
    /// </summary>
    public class SpotLight : Light
    {
        /// <summary>
        /// </summary>
        public float SpotRange
        {
            get
            {
                return GetParam((Light.Param)3);
            }
            set
            {
                SetParam((Light.Param)3, value);
            }
        }

        /// <summary>
        /// </summary>
        public float SpotAttenuation
        {
            get
            {
                return GetParam((Light.Param)4);
            }
            set
            {
                SetParam((Light.Param)4, value);
            }
        }

        /// <summary>
        /// </summary>
        public float SpotAngle
        {
            get
            {
                return GetParam((Light.Param)5);
            }
            set
            {
                SetParam((Light.Param)5, value);
            }
        }

        /// <summary>
        /// </summary>
        public float SpotAngleAttenuation
        {
            get
            {
                return GetParam((Light.Param)6);
            }
            set
            {
                SetParam((Light.Param)6, value);
            }
        }


        private const string nativeName = "SpotLight";

        public SpotLight() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_SpotLight_Ctor(this);
        }

        internal SpotLight(bool memoryOwn) : base(memoryOwn) {}
    }
}
