using System;

namespace Godot
{
    public class StreamPeerBuffer : StreamPeer
    {
        /// <summary>
        /// </summary>
        public byte[] DataArray
        {
            get
            {
                return GetDataArray();
            }
            set
            {
                SetDataArray(value);
            }
        }


        private const string nativeName = "StreamPeerBuffer";

        public StreamPeerBuffer() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_StreamPeerBuffer_Ctor(this);
        }

        internal StreamPeerBuffer(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "seek");

        /// <summary>
        /// </summary>
        [GodotMethod("seek")]
        public void Seek(int position)
        {
            NativeCalls.godot_icall_1_0(method_bind_0, Object.GetPtr(this), position);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_size");

        /// <summary>
        /// </summary>
        [GodotMethod("get_size")]
        public int GetSize()
        {
            return NativeCalls.godot_icall_0_1(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_position");

        /// <summary>
        /// </summary>
        [GodotMethod("get_position")]
        public int GetPosition()
        {
            return NativeCalls.godot_icall_0_1(method_bind_2, Object.GetPtr(this));
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "resize");

        /// <summary>
        /// </summary>
        [GodotMethod("resize")]
        public void Resize(int size)
        {
            NativeCalls.godot_icall_1_0(method_bind_3, Object.GetPtr(this), size);
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_data_array");

        [GodotMethod("set_data_array")]
        public void SetDataArray(byte[] data)
        {
            NativeCalls.godot_icall_1_131(method_bind_4, Object.GetPtr(this), data);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_data_array");

        [GodotMethod("get_data_array")]
        public byte[] GetDataArray()
        {
            return NativeCalls.godot_icall_0_132(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "clear");

        /// <summary>
        /// </summary>
        [GodotMethod("clear")]
        public void Clear()
        {
            NativeCalls.godot_icall_0_12(method_bind_6, Object.GetPtr(this));
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "duplicate");

        /// <summary>
        /// </summary>
        [GodotMethod("duplicate")]
        public StreamPeerBuffer Duplicate()
        {
            return NativeCalls.godot_icall_0_813(method_bind_7, Object.GetPtr(this));
        }
    }
}
