using System;

namespace Godot
{
    public class StyleBoxLine : StyleBox
    {
        /// <summary>
        /// </summary>
        public Color Color
        {
            get
            {
                return GetColor();
            }
            set
            {
                SetColor(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Grow
        {
            get
            {
                return GetGrow();
            }
            set
            {
                SetGrow(value);
            }
        }

        /// <summary>
        /// </summary>
        public int Thickness
        {
            get
            {
                return GetThickness();
            }
            set
            {
                SetThickness(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Vertical
        {
            get
            {
                return IsVertical();
            }
            set
            {
                SetVertical(value);
            }
        }


        private const string nativeName = "StyleBoxLine";

        public StyleBoxLine() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_StyleBoxLine_Ctor(this);
        }

        internal StyleBoxLine(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_color");

        [GodotMethod("set_color")]
        public void SetColor(Color color)
        {
            NativeCalls.godot_icall_1_202(method_bind_0, Object.GetPtr(this), ref color);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_color");

        [GodotMethod("get_color")]
        public Color GetColor()
        {
            object ret = NativeCalls.godot_icall_0_203(method_bind_1, Object.GetPtr(this));
            return (Color)ret;
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_thickness");

        [GodotMethod("set_thickness")]
        public void SetThickness(int thickness)
        {
            NativeCalls.godot_icall_1_0(method_bind_2, Object.GetPtr(this), thickness);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_thickness");

        [GodotMethod("get_thickness")]
        public int GetThickness()
        {
            return NativeCalls.godot_icall_0_1(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_grow");

        [GodotMethod("set_grow")]
        public void SetGrow(float grow)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), grow);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_grow");

        [GodotMethod("get_grow")]
        public float GetGrow()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_vertical");

        [GodotMethod("set_vertical")]
        public void SetVertical(bool vertical)
        {
            NativeCalls.godot_icall_1_11(method_bind_6, Object.GetPtr(this), vertical);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_vertical");

        [GodotMethod("is_vertical")]
        public bool IsVertical()
        {
            return NativeCalls.godot_icall_0_3(method_bind_7, Object.GetPtr(this));
        }
    }
}
