using System;

namespace Godot
{
    /// <summary>
    /// This is a helper class to generate a flat [Button] (see [method Button.set_flat]), creating a ToolButton is equivalent to:
    /// [codeblock]
    /// var btn = Button.new()
    /// btn.set_flat(true)
    /// [/codeblock]
    /// </summary>
    public class ToolButton : Button
    {
        private const string nativeName = "ToolButton";

        public ToolButton() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ToolButton_Ctor(this);
        }

        internal ToolButton(bool memoryOwn) : base(memoryOwn) {}
    }
}
