using System;

namespace Godot
{
    public static class TranslationServer
    {
        private const string nativeName = "TranslationServer";
        internal static IntPtr ptr = NativeCalls.godot_icall_TranslationServer_get_singleton();

        private static IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_locale");

        /// <summary>
        /// </summary>
        [GodotMethod("set_locale")]
        public static void SetLocale(string locale)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, ptr, locale);
        }

        private static IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_locale");

        /// <summary>
        /// </summary>
        [GodotMethod("get_locale")]
        public static string GetLocale()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, ptr);
        }

        private static IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_locale_name");

        /// <summary>
        /// </summary>
        [GodotMethod("get_locale_name")]
        public static string GetLocaleName(string locale)
        {
            return NativeCalls.godot_icall_1_73(method_bind_2, ptr, locale);
        }

        private static IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "translate");

        /// <summary>
        /// </summary>
        [GodotMethod("translate")]
        public static string Translate(string message)
        {
            return NativeCalls.godot_icall_1_73(method_bind_3, ptr, message);
        }

        private static IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "add_translation");

        /// <summary>
        /// </summary>
        [GodotMethod("add_translation")]
        public static void AddTranslation(Translation translation)
        {
            NativeCalls.godot_icall_1_24(method_bind_4, ptr, Object.GetPtr(translation));
        }

        private static IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "remove_translation");

        /// <summary>
        /// </summary>
        [GodotMethod("remove_translation")]
        public static void RemoveTranslation(Translation translation)
        {
            NativeCalls.godot_icall_1_24(method_bind_5, ptr, Object.GetPtr(translation));
        }

        private static IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "clear");

        /// <summary>
        /// </summary>
        [GodotMethod("clear")]
        public static void Clear()
        {
            NativeCalls.godot_icall_0_12(method_bind_6, ptr);
        }
    }
}
