using System;

namespace Godot
{
    public class VehicleBody : RigidBody
    {
        /// <summary>
        /// </summary>
        public float EngineForce
        {
            get
            {
                return GetEngineForce();
            }
            set
            {
                SetEngineForce(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Brake
        {
            get
            {
                return GetBrake();
            }
            set
            {
                SetBrake(value);
            }
        }

        /// <summary>
        /// </summary>
        public float Steering
        {
            get
            {
                return GetSteering();
            }
            set
            {
                SetSteering(value);
            }
        }


        private const string nativeName = "VehicleBody";

        public VehicleBody() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VehicleBody_Ctor(this);
        }

        internal VehicleBody(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_engine_force");

        [GodotMethod("set_engine_force")]
        public void SetEngineForce(float engineForce)
        {
            NativeCalls.godot_icall_1_10(method_bind_0, Object.GetPtr(this), engineForce);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_engine_force");

        [GodotMethod("get_engine_force")]
        public float GetEngineForce()
        {
            return NativeCalls.godot_icall_0_9(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_brake");

        [GodotMethod("set_brake")]
        public void SetBrake(float brake)
        {
            NativeCalls.godot_icall_1_10(method_bind_2, Object.GetPtr(this), brake);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_brake");

        [GodotMethod("get_brake")]
        public float GetBrake()
        {
            return NativeCalls.godot_icall_0_9(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_steering");

        [GodotMethod("set_steering")]
        public void SetSteering(float steering)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), steering);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_steering");

        [GodotMethod("get_steering")]
        public float GetSteering()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }
    }
}
