using System;

namespace Godot
{
    public class VehicleWheel : Spatial
    {
        /// <summary>
        /// </summary>
        public bool UseAsTraction
        {
            get
            {
                return IsUsedAsTraction();
            }
            set
            {
                SetUseAsTraction(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool UseAsSteering
        {
            get
            {
                return IsUsedAsSteering();
            }
            set
            {
                SetUseAsSteering(value);
            }
        }

        /// <summary>
        /// </summary>
        public float WheelRollInfluence
        {
            get
            {
                return GetRollInfluence();
            }
            set
            {
                SetRollInfluence(value);
            }
        }

        /// <summary>
        /// </summary>
        public float WheelRadius
        {
            get
            {
                return GetRadius();
            }
            set
            {
                SetRadius(value);
            }
        }

        /// <summary>
        /// </summary>
        public float WheelRestLength
        {
            get
            {
                return GetSuspensionRestLength();
            }
            set
            {
                SetSuspensionRestLength(value);
            }
        }

        /// <summary>
        /// </summary>
        public float WheelFrictionSlip
        {
            get
            {
                return GetFrictionSlip();
            }
            set
            {
                SetFrictionSlip(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SuspensionTravel
        {
            get
            {
                return GetSuspensionTravel();
            }
            set
            {
                SetSuspensionTravel(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SuspensionStiffness
        {
            get
            {
                return GetSuspensionStiffness();
            }
            set
            {
                SetSuspensionStiffness(value);
            }
        }

        /// <summary>
        /// </summary>
        public float SuspensionMaxForce
        {
            get
            {
                return GetSuspensionMaxForce();
            }
            set
            {
                SetSuspensionMaxForce(value);
            }
        }

        /// <summary>
        /// </summary>
        public float DampingCompression
        {
            get
            {
                return GetDampingCompression();
            }
            set
            {
                SetDampingCompression(value);
            }
        }

        /// <summary>
        /// </summary>
        public float DampingRelaxation
        {
            get
            {
                return GetDampingRelaxation();
            }
            set
            {
                SetDampingRelaxation(value);
            }
        }


        private const string nativeName = "VehicleWheel";

        public VehicleWheel() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VehicleWheel_Ctor(this);
        }

        internal VehicleWheel(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_radius");

        [GodotMethod("set_radius")]
        public void SetRadius(float length)
        {
            NativeCalls.godot_icall_1_10(method_bind_0, Object.GetPtr(this), length);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_radius");

        [GodotMethod("get_radius")]
        public float GetRadius()
        {
            return NativeCalls.godot_icall_0_9(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_suspension_rest_length");

        [GodotMethod("set_suspension_rest_length")]
        public void SetSuspensionRestLength(float length)
        {
            NativeCalls.godot_icall_1_10(method_bind_2, Object.GetPtr(this), length);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_suspension_rest_length");

        [GodotMethod("get_suspension_rest_length")]
        public float GetSuspensionRestLength()
        {
            return NativeCalls.godot_icall_0_9(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_suspension_travel");

        [GodotMethod("set_suspension_travel")]
        public void SetSuspensionTravel(float length)
        {
            NativeCalls.godot_icall_1_10(method_bind_4, Object.GetPtr(this), length);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_suspension_travel");

        [GodotMethod("get_suspension_travel")]
        public float GetSuspensionTravel()
        {
            return NativeCalls.godot_icall_0_9(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_suspension_stiffness");

        [GodotMethod("set_suspension_stiffness")]
        public void SetSuspensionStiffness(float length)
        {
            NativeCalls.godot_icall_1_10(method_bind_6, Object.GetPtr(this), length);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_suspension_stiffness");

        [GodotMethod("get_suspension_stiffness")]
        public float GetSuspensionStiffness()
        {
            return NativeCalls.godot_icall_0_9(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_suspension_max_force");

        [GodotMethod("set_suspension_max_force")]
        public void SetSuspensionMaxForce(float length)
        {
            NativeCalls.godot_icall_1_10(method_bind_8, Object.GetPtr(this), length);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_suspension_max_force");

        [GodotMethod("get_suspension_max_force")]
        public float GetSuspensionMaxForce()
        {
            return NativeCalls.godot_icall_0_9(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_damping_compression");

        [GodotMethod("set_damping_compression")]
        public void SetDampingCompression(float length)
        {
            NativeCalls.godot_icall_1_10(method_bind_10, Object.GetPtr(this), length);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_damping_compression");

        [GodotMethod("get_damping_compression")]
        public float GetDampingCompression()
        {
            return NativeCalls.godot_icall_0_9(method_bind_11, Object.GetPtr(this));
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_damping_relaxation");

        [GodotMethod("set_damping_relaxation")]
        public void SetDampingRelaxation(float length)
        {
            NativeCalls.godot_icall_1_10(method_bind_12, Object.GetPtr(this), length);
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_damping_relaxation");

        [GodotMethod("get_damping_relaxation")]
        public float GetDampingRelaxation()
        {
            return NativeCalls.godot_icall_0_9(method_bind_13, Object.GetPtr(this));
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_use_as_traction");

        [GodotMethod("set_use_as_traction")]
        public void SetUseAsTraction(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_14, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_used_as_traction");

        [GodotMethod("is_used_as_traction")]
        public bool IsUsedAsTraction()
        {
            return NativeCalls.godot_icall_0_3(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_use_as_steering");

        [GodotMethod("set_use_as_steering")]
        public void SetUseAsSteering(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_16, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_used_as_steering");

        [GodotMethod("is_used_as_steering")]
        public bool IsUsedAsSteering()
        {
            return NativeCalls.godot_icall_0_3(method_bind_17, Object.GetPtr(this));
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_friction_slip");

        [GodotMethod("set_friction_slip")]
        public void SetFrictionSlip(float length)
        {
            NativeCalls.godot_icall_1_10(method_bind_18, Object.GetPtr(this), length);
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_friction_slip");

        [GodotMethod("get_friction_slip")]
        public float GetFrictionSlip()
        {
            return NativeCalls.godot_icall_0_9(method_bind_19, Object.GetPtr(this));
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_in_contact");

        /// <summary>
        /// </summary>
        [GodotMethod("is_in_contact")]
        public bool IsInContact()
        {
            return NativeCalls.godot_icall_0_3(method_bind_20, Object.GetPtr(this));
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_roll_influence");

        [GodotMethod("set_roll_influence")]
        public void SetRollInfluence(float rollInfluence)
        {
            NativeCalls.godot_icall_1_10(method_bind_21, Object.GetPtr(this), rollInfluence);
        }

        private IntPtr method_bind_22 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_roll_influence");

        [GodotMethod("get_roll_influence")]
        public float GetRollInfluence()
        {
            return NativeCalls.godot_icall_0_9(method_bind_22, Object.GetPtr(this));
        }

        private IntPtr method_bind_23 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_skidinfo");

        /// <summary>
        /// </summary>
        [GodotMethod("get_skidinfo")]
        public float GetSkidinfo()
        {
            return NativeCalls.godot_icall_0_9(method_bind_23, Object.GetPtr(this));
        }
    }
}
