using System;

namespace Godot
{
    public class VideoStreamWebm : VideoStream
    {
        public string File
        {
            get
            {
                return GetFile();
            }
            set
            {
                SetFile(value);
            }
        }

        private const string nativeName = "VideoStreamWebm";

        public VideoStreamWebm() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VideoStreamWebm_Ctor(this);
        }

        internal VideoStreamWebm(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_file");

        /// <summary>
        /// </summary>
        [GodotMethod("set_file")]
        public void SetFile(string file)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), file);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_file");

        /// <summary>
        /// </summary>
        [GodotMethod("get_file")]
        public string GetFile()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }
    }
}
