using System;

namespace Godot
{
    public class ViewportContainer : Container
    {
        /// <summary>
        /// </summary>
        public bool Stretch
        {
            get
            {
                return IsStretchEnabled();
            }
            set
            {
                SetStretch(value);
            }
        }

        /// <summary>
        /// </summary>
        public int StretchShrink
        {
            get
            {
                return GetStretchShrink();
            }
            set
            {
                SetStretchShrink(value);
            }
        }


        private const string nativeName = "ViewportContainer";

        public ViewportContainer() : this(false)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ViewportContainer_Ctor(this);
        }

        internal ViewportContainer(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_stretch");

        [GodotMethod("set_stretch")]
        public void SetStretch(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_0, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "is_stretch_enabled");

        [GodotMethod("is_stretch_enabled")]
        public bool IsStretchEnabled()
        {
            return NativeCalls.godot_icall_0_3(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_stretch_shrink");

        [GodotMethod("set_stretch_shrink")]
        public void SetStretchShrink(int amount)
        {
            NativeCalls.godot_icall_1_0(method_bind_2, Object.GetPtr(this), amount);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_stretch_shrink");

        [GodotMethod("get_stretch_shrink")]
        public int GetStretchShrink()
        {
            return NativeCalls.godot_icall_0_1(method_bind_3, Object.GetPtr(this));
        }
    }
}
