using System;

namespace Godot
{
    public class ViewportTexture : Texture
    {
        /// <summary>
        /// </summary>
        public NodePath ViewportPath
        {
            get
            {
                return GetViewportPathInScene();
            }
            set
            {
                SetViewportPathInScene(value);
            }
        }


        private const string nativeName = "ViewportTexture";

        public ViewportTexture() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_ViewportTexture_Ctor(this);
        }

        internal ViewportTexture(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_viewport_path_in_scene");

        [GodotMethod("set_viewport_path_in_scene")]
        public void SetViewportPathInScene(NodePath path)
        {
            NativeCalls.godot_icall_1_78(method_bind_0, Object.GetPtr(this), NodePath.GetPtr(path));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_viewport_path_in_scene");

        [GodotMethod("get_viewport_path_in_scene")]
        public NodePath GetViewportPathInScene()
        {
            IntPtr ret = NativeCalls.godot_icall_0_79(method_bind_1, Object.GetPtr(this));
            return new NodePath(ret);
        }
    }
}
