using System;

namespace Godot
{
    /// <summary>
    /// A Visual Script node representing a constant from base types, such as [Vector3.AXIS_X].
    /// </summary>
    public class VisualScriptBasicTypeConstant : VisualScriptNode
    {
        /// <summary>
        /// The type to get the constant from.
        /// </summary>
        public Variant.Type BasicType
        {
            get
            {
                return GetBasicType();
            }
            set
            {
                SetBasicType(value);
            }
        }

        /// <summary>
        /// The name of the constant to return.
        /// </summary>
        public string Constant
        {
            get
            {
                return GetBasicTypeConstant();
            }
            set
            {
                SetBasicTypeConstant(value);
            }
        }


        private const string nativeName = "VisualScriptBasicTypeConstant";

        public VisualScriptBasicTypeConstant() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptBasicTypeConstant_Ctor(this);
        }

        internal VisualScriptBasicTypeConstant(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_basic_type");

        [GodotMethod("set_basic_type")]
        public void SetBasicType(Variant.Type name)
        {
            NativeCalls.godot_icall_1_943(method_bind_0, Object.GetPtr(this), name);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_basic_type");

        [GodotMethod("get_basic_type")]
        public Variant.Type GetBasicType()
        {
            return NativeCalls.godot_icall_0_944(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_basic_type_constant");

        [GodotMethod("set_basic_type_constant")]
        public void SetBasicTypeConstant(string name)
        {
            NativeCalls.godot_icall_1_43(method_bind_2, Object.GetPtr(this), name);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_basic_type_constant");

        [GodotMethod("get_basic_type_constant")]
        public string GetBasicTypeConstant()
        {
            return NativeCalls.godot_icall_0_2(method_bind_3, Object.GetPtr(this));
        }
    }
}
