using System;

namespace Godot
{
    /// <summary>
    /// A Visual Script node that checks a [bool] input port. If [code]true[/code] it will exit via the “true” sequence port. If [code]false[/code] it will exit via the "false" sequence port. After exiting either, it exits via the “done” port. Sequence ports may be left disconnected.
    /// [b]Input Ports:[/b]
    /// - Sequence: [code]if (cond) is[/code]
    /// - Data (boolean): [code]cond[/code]
    /// [b]Output Ports:[/b]
    /// - Sequence: [code]true[/code]
    /// - Sequence: [code]false[/code]
    /// - Sequence: [code]done[/code]
    /// </summary>
    public class VisualScriptCondition : VisualScriptNode
    {
        private const string nativeName = "VisualScriptCondition";

        public VisualScriptCondition() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptCondition_Ctor(this);
        }

        internal VisualScriptCondition(bool memoryOwn) : base(memoryOwn) {}
    }
}
