using System;

namespace Godot
{
    /// <summary>
    /// This node returns a constant's value.
    /// [b]Input Ports:[/b]
    /// none
    /// [b]Output Ports:[/b]
    /// - Data (variant): [code]get[/code]
    /// </summary>
    public class VisualScriptConstant : VisualScriptNode
    {
        /// <summary>
        /// The constant's type.
        /// </summary>
        public Variant.Type Type
        {
            get
            {
                return GetConstantType();
            }
            set
            {
                SetConstantType(value);
            }
        }

        /// <summary>
        /// The constant's value.
        /// </summary>
        public object Value
        {
            get
            {
                return GetConstantValue();
            }
            set
            {
                SetConstantValue(value);
            }
        }


        private const string nativeName = "VisualScriptConstant";

        public VisualScriptConstant() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptConstant_Ctor(this);
        }

        internal VisualScriptConstant(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_constant_type");

        [GodotMethod("set_constant_type")]
        public void SetConstantType(Variant.Type type)
        {
            NativeCalls.godot_icall_1_943(method_bind_0, Object.GetPtr(this), type);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_constant_type");

        [GodotMethod("get_constant_type")]
        public Variant.Type GetConstantType()
        {
            return NativeCalls.godot_icall_0_944(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_constant_value");

        [GodotMethod("set_constant_value")]
        public void SetConstantValue(object value)
        {
            NativeCalls.godot_icall_1_463(method_bind_2, Object.GetPtr(this), value);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_constant_value");

        [GodotMethod("get_constant_value")]
        public object GetConstantValue()
        {
            return NativeCalls.godot_icall_0_461(method_bind_3, Object.GetPtr(this));
        }
    }
}
