using System;

namespace Godot
{
    public static class VisualScriptEditor
    {
        private const string nativeName = "_VisualScriptEditor";
        internal static IntPtr ptr = NativeCalls.godot_icall__VisualScriptEditor_get_singleton();

        private static IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "add_custom_node");

        /// <summary>
        /// Add a custom Visual Script node to the editor. It'll be placed under "Custom Nodes" with the [code]category[/code] as the parameter.
        /// </summary>
        [GodotMethod("add_custom_node")]
        public static void AddCustomNode(string name, string category, Script script)
        {
            NativeCalls.godot_icall_3_851(method_bind_0, ptr, name, category, Object.GetPtr(script));
        }

        private static IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "remove_custom_node");

        /// <summary>
        /// Remove a custom Visual Script node from the editor. Custom nodes already placed on scripts won't be removed.
        /// </summary>
        [GodotMethod("remove_custom_node")]
        public static void RemoveCustomNode(string name, string category)
        {
            NativeCalls.godot_icall_2_69(method_bind_1, ptr, name, category);
        }
    }
}
