using System;

namespace Godot
{
    /// <summary>
    /// A Visual Script node returning a singleton from [@GlobalScope]
    /// </summary>
    public class VisualScriptEngineSingleton : VisualScriptNode
    {
        /// <summary>
        /// The singleton's name.
        /// </summary>
        public string Constant
        {
            get
            {
                return GetSingleton();
            }
            set
            {
                SetSingleton(value);
            }
        }


        private const string nativeName = "VisualScriptEngineSingleton";

        public VisualScriptEngineSingleton() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptEngineSingleton_Ctor(this);
        }

        internal VisualScriptEngineSingleton(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_singleton");

        [GodotMethod("set_singleton")]
        public void SetSingleton(string name)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), name);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_singleton");

        [GodotMethod("get_singleton")]
        public string GetSingleton()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }
    }
}
