using System;
using System.Collections.Generic;

namespace Godot
{
    public class VisualScriptFunctionCall : VisualScriptNode
    {
        public enum RPCCallMode
        {
            Disabled = 0,
            Reliable = 1,
            Unreliable = 2,
            ReliableToId = 3,
            UnreliableToId = 4
        }

        public enum CallModeEnum
        {
            Self = 0,
            NodePath = 1,
            Instance = 2,
            BasicType = 3,
            Singleton = 4
        }


        /// <summary>
        /// </summary>
        public VisualScriptFunctionCall.CallModeEnum CallMode
        {
            get
            {
                return GetCallMode();
            }
            set
            {
                SetCallMode(value);
            }
        }

        /// <summary>
        /// </summary>
        public string BaseType
        {
            get
            {
                return GetBaseType();
            }
            set
            {
                SetBaseType(value);
            }
        }

        /// <summary>
        /// </summary>
        public string BaseScript
        {
            get
            {
                return GetBaseScript();
            }
            set
            {
                SetBaseScript(value);
            }
        }

        /// <summary>
        /// </summary>
        public string Singleton
        {
            get
            {
                return GetSingleton();
            }
            set
            {
                SetSingleton(value);
            }
        }

        /// <summary>
        /// </summary>
        public Variant.Type BasicType
        {
            get
            {
                return GetBasicType();
            }
            set
            {
                SetBasicType(value);
            }
        }

        /// <summary>
        /// </summary>
        public NodePath NodePath
        {
            get
            {
                return GetBasePath();
            }
            set
            {
                SetBasePath(value);
            }
        }

        public Dictionary<object, object> ArgumentCache
        {
            get
            {
                return _GetArgumentCache();
            }
            set
            {
                _SetArgumentCache(value);
            }
        }

        /// <summary>
        /// </summary>
        public string Function
        {
            get
            {
                return GetFunction();
            }
            set
            {
                SetFunction(value);
            }
        }

        /// <summary>
        /// </summary>
        public int UseDefaultArgs
        {
            get
            {
                return GetUseDefaultArgs();
            }
            set
            {
                SetUseDefaultArgs(value);
            }
        }

        /// <summary>
        /// </summary>
        public bool Validate
        {
            get
            {
                return GetValidate();
            }
            set
            {
                SetValidate(value);
            }
        }

        /// <summary>
        /// </summary>
        public VisualScriptFunctionCall.RPCCallMode RpcCallMode
        {
            get
            {
                return GetRpcCallMode();
            }
            set
            {
                SetRpcCallMode(value);
            }
        }


        private const string nativeName = "VisualScriptFunctionCall";

        public VisualScriptFunctionCall() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptFunctionCall_Ctor(this);
        }

        internal VisualScriptFunctionCall(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_type");

        [GodotMethod("set_base_type")]
        public void SetBaseType(string baseType)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), baseType);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_type");

        [GodotMethod("get_base_type")]
        public string GetBaseType()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_script");

        [GodotMethod("set_base_script")]
        public void SetBaseScript(string baseScript)
        {
            NativeCalls.godot_icall_1_43(method_bind_2, Object.GetPtr(this), baseScript);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_script");

        [GodotMethod("get_base_script")]
        public string GetBaseScript()
        {
            return NativeCalls.godot_icall_0_2(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_basic_type");

        [GodotMethod("set_basic_type")]
        public void SetBasicType(Variant.Type basicType)
        {
            NativeCalls.godot_icall_1_943(method_bind_4, Object.GetPtr(this), basicType);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_basic_type");

        [GodotMethod("get_basic_type")]
        public Variant.Type GetBasicType()
        {
            return NativeCalls.godot_icall_0_944(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_singleton");

        [GodotMethod("set_singleton")]
        public void SetSingleton(string singleton)
        {
            NativeCalls.godot_icall_1_43(method_bind_6, Object.GetPtr(this), singleton);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_singleton");

        [GodotMethod("get_singleton")]
        public string GetSingleton()
        {
            return NativeCalls.godot_icall_0_2(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_function");

        [GodotMethod("set_function")]
        public void SetFunction(string function)
        {
            NativeCalls.godot_icall_1_43(method_bind_8, Object.GetPtr(this), function);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_function");

        [GodotMethod("get_function")]
        public string GetFunction()
        {
            return NativeCalls.godot_icall_0_2(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_call_mode");

        [GodotMethod("set_call_mode")]
        public void SetCallMode(VisualScriptFunctionCall.CallModeEnum mode)
        {
            NativeCalls.godot_icall_1_947(method_bind_10, Object.GetPtr(this), mode);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_call_mode");

        [GodotMethod("get_call_mode")]
        public VisualScriptFunctionCall.CallModeEnum GetCallMode()
        {
            return NativeCalls.godot_icall_0_948(method_bind_11, Object.GetPtr(this));
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_path");

        [GodotMethod("set_base_path")]
        public void SetBasePath(NodePath basePath)
        {
            NativeCalls.godot_icall_1_78(method_bind_12, Object.GetPtr(this), NodePath.GetPtr(basePath));
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_path");

        [GodotMethod("get_base_path")]
        public NodePath GetBasePath()
        {
            IntPtr ret = NativeCalls.godot_icall_0_79(method_bind_13, Object.GetPtr(this));
            return new NodePath(ret);
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_use_default_args");

        [GodotMethod("set_use_default_args")]
        public void SetUseDefaultArgs(int amount)
        {
            NativeCalls.godot_icall_1_0(method_bind_14, Object.GetPtr(this), amount);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_use_default_args");

        [GodotMethod("get_use_default_args")]
        public int GetUseDefaultArgs()
        {
            return NativeCalls.godot_icall_0_1(method_bind_15, Object.GetPtr(this));
        }

        private IntPtr method_bind_16 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_set_argument_cache");

        internal void _SetArgumentCache(Dictionary<object, object> argumentCache)
        {
            NativeCalls.godot_icall_1_168(method_bind_16, Object.GetPtr(this), argumentCache);
        }

        private IntPtr method_bind_17 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_get_argument_cache");

        internal Dictionary<object, object> _GetArgumentCache()
        {
            return NativeCalls.godot_icall_0_169(method_bind_17, Object.GetPtr(this));
        }

        private IntPtr method_bind_18 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_rpc_call_mode");

        [GodotMethod("set_rpc_call_mode")]
        public void SetRpcCallMode(VisualScriptFunctionCall.RPCCallMode mode)
        {
            NativeCalls.godot_icall_1_949(method_bind_18, Object.GetPtr(this), mode);
        }

        private IntPtr method_bind_19 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_rpc_call_mode");

        [GodotMethod("get_rpc_call_mode")]
        public VisualScriptFunctionCall.RPCCallMode GetRpcCallMode()
        {
            return NativeCalls.godot_icall_0_950(method_bind_19, Object.GetPtr(this));
        }

        private IntPtr method_bind_20 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_validate");

        [GodotMethod("set_validate")]
        public void SetValidate(bool enable)
        {
            NativeCalls.godot_icall_1_11(method_bind_20, Object.GetPtr(this), enable);
        }

        private IntPtr method_bind_21 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_validate");

        [GodotMethod("get_validate")]
        public bool GetValidate()
        {
            return NativeCalls.godot_icall_0_3(method_bind_21, Object.GetPtr(this));
        }
    }
}
