using System;

namespace Godot
{
    public class VisualScriptInputAction : VisualScriptNode
    {
        public enum ModeEnum
        {
            Pressed = 0,
            Released = 1,
            JustPressed = 2,
            JustReleased = 3
        }


        /// <summary>
        /// </summary>
        public string Action
        {
            get
            {
                return GetActionName();
            }
            set
            {
                SetActionName(value);
            }
        }

        /// <summary>
        /// </summary>
        public VisualScriptInputAction.ModeEnum Mode
        {
            get
            {
                return GetActionMode();
            }
            set
            {
                SetActionMode(value);
            }
        }


        private const string nativeName = "VisualScriptInputAction";

        public VisualScriptInputAction() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptInputAction_Ctor(this);
        }

        internal VisualScriptInputAction(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_action_name");

        [GodotMethod("set_action_name")]
        public void SetActionName(string name)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), name);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_action_name");

        [GodotMethod("get_action_name")]
        public string GetActionName()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_action_mode");

        [GodotMethod("set_action_mode")]
        public void SetActionMode(VisualScriptInputAction.ModeEnum mode)
        {
            NativeCalls.godot_icall_1_953(method_bind_2, Object.GetPtr(this), mode);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_action_mode");

        [GodotMethod("get_action_mode")]
        public VisualScriptInputAction.ModeEnum GetActionMode()
        {
            return NativeCalls.godot_icall_0_954(method_bind_3, Object.GetPtr(this));
        }
    }
}
