using System;

namespace Godot
{
    /// <summary>
    /// This node steps through each item in a given input. Input can be any sequence data type, such as an [Array] or [String]. When each item has been processed, execution passed out the [code]exit[/code] Sequence port.
    /// [b]Input Ports:[/b]
    /// - Sequence: [code]for (elem) in (input)[/code]
    /// - Data (variant): [code]input[/code]
    /// [b]Output Ports:[/b]
    /// - Sequence: [code]each[/code]
    /// - Sequence: [code]exit[/code]
    /// - Data (variant): [code]elem[/code]
    /// </summary>
    public class VisualScriptIterator : VisualScriptNode
    {
        private const string nativeName = "VisualScriptIterator";

        public VisualScriptIterator() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptIterator_Ctor(this);
        }

        internal VisualScriptIterator(bool memoryOwn) : base(memoryOwn) {}
    }
}
