using System;

namespace Godot
{
    /// <summary>
    /// Provides common math constants, such as Pi or Euler's constant, on an output Data port.
    /// [b]Input Ports:[/b]
    /// none
    /// [b]Output Ports:[/b]
    /// - Data (variant): [code]get[/code]
    /// </summary>
    public class VisualScriptMathConstant : VisualScriptNode
    {
        public enum MathConstant
        {
            One = 0,
            Pi = 1,
            HalfPi = 2,
            Tau = 3,
            E = 4,
            Sqrt2 = 5,
            Inf = 6,
            Nan = 7,
            Max = 8
        }


        /// <summary>
        /// The math constant.
        /// </summary>
        public VisualScriptMathConstant.MathConstant Constant
        {
            get
            {
                return GetMathConstant();
            }
            set
            {
                SetMathConstant(value);
            }
        }


        private const string nativeName = "VisualScriptMathConstant";

        public VisualScriptMathConstant() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptMathConstant_Ctor(this);
        }

        internal VisualScriptMathConstant(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_math_constant");

        [GodotMethod("set_math_constant")]
        public void SetMathConstant(VisualScriptMathConstant.MathConstant which)
        {
            NativeCalls.godot_icall_1_955(method_bind_0, Object.GetPtr(this), which);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_math_constant");

        [GodotMethod("get_math_constant")]
        public VisualScriptMathConstant.MathConstant GetMathConstant()
        {
            return NativeCalls.godot_icall_0_956(method_bind_1, Object.GetPtr(this));
        }
    }
}
