using System;

namespace Godot
{
    /// <summary>
    /// [b]Input Ports:[/b]
    /// - Data (variant): [code]A[/code]
    /// - Data (variant): [code]B[/code]
    /// [b]Output Ports:[/b]
    /// - Data (variant): [code]result[/code]
    /// </summary>
    public class VisualScriptOperator : VisualScriptNode
    {
        /// <summary>
        /// </summary>
        public Variant.Operator Operator
        {
            get
            {
                return GetOperator();
            }
            set
            {
                SetOperator(value);
            }
        }

        /// <summary>
        /// </summary>
        public Variant.Type Type
        {
            get
            {
                return GetTyped();
            }
            set
            {
                SetTyped(value);
            }
        }


        private const string nativeName = "VisualScriptOperator";

        public VisualScriptOperator() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptOperator_Ctor(this);
        }

        internal VisualScriptOperator(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_operator");

        [GodotMethod("set_operator")]
        public void SetOperator(Variant.Operator op)
        {
            NativeCalls.godot_icall_1_958(method_bind_0, Object.GetPtr(this), op);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_operator");

        [GodotMethod("get_operator")]
        public Variant.Operator GetOperator()
        {
            return NativeCalls.godot_icall_0_959(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_typed");

        [GodotMethod("set_typed")]
        public void SetTyped(Variant.Type type)
        {
            NativeCalls.godot_icall_1_943(method_bind_2, Object.GetPtr(this), type);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_typed");

        [GodotMethod("get_typed")]
        public Variant.Type GetTyped()
        {
            return NativeCalls.godot_icall_0_944(method_bind_3, Object.GetPtr(this));
        }
    }
}
