using System;

namespace Godot
{
    /// <summary>
    /// Creates a new [Resource] or loads one from the filesystem.
    /// [b]Input Ports:[/b]
    /// none
    /// [b]Output Ports:[/b]
    /// - Data (object): [code]res[/code]
    /// </summary>
    public class VisualScriptPreload : VisualScriptNode
    {
        /// <summary>
        /// The [Resource] to load.
        /// </summary>
        public Resource Resource
        {
            get
            {
                return GetPreload();
            }
            set
            {
                SetPreload(value);
            }
        }


        private const string nativeName = "VisualScriptPreload";

        public VisualScriptPreload() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptPreload_Ctor(this);
        }

        internal VisualScriptPreload(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_preload");

        [GodotMethod("set_preload")]
        public void SetPreload(Resource resource)
        {
            NativeCalls.godot_icall_1_24(method_bind_0, Object.GetPtr(this), Object.GetPtr(resource));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_preload");

        [GodotMethod("get_preload")]
        public Resource GetPreload()
        {
            return NativeCalls.godot_icall_0_731(method_bind_1, Object.GetPtr(this));
        }
    }
}
