using System;

namespace Godot
{
    public class VisualScriptPropertyGet : VisualScriptNode
    {
        public enum CallMode
        {
            Self = 0,
            NodePath = 1,
            Instance = 2
        }


        /// <summary>
        /// </summary>
        public VisualScriptPropertyGet.CallMode SetMode
        {
            get
            {
                return GetCallMode();
            }
            set
            {
                SetCallMode(value);
            }
        }

        /// <summary>
        /// </summary>
        public string BaseType
        {
            get
            {
                return GetBaseType();
            }
            set
            {
                SetBaseType(value);
            }
        }

        /// <summary>
        /// </summary>
        public string BaseScript
        {
            get
            {
                return GetBaseScript();
            }
            set
            {
                SetBaseScript(value);
            }
        }

        public Variant.Type TypeCache
        {
            get
            {
                return _GetTypeCache();
            }
            set
            {
                _SetTypeCache(value);
            }
        }

        /// <summary>
        /// </summary>
        public Variant.Type BasicType
        {
            get
            {
                return GetBasicType();
            }
            set
            {
                SetBasicType(value);
            }
        }

        /// <summary>
        /// </summary>
        public NodePath NodePath
        {
            get
            {
                return GetBasePath();
            }
            set
            {
                SetBasePath(value);
            }
        }

        /// <summary>
        /// </summary>
        public string Property
        {
            get
            {
                return GetProperty();
            }
            set
            {
                SetProperty(value);
            }
        }

        /// <summary>
        /// </summary>
        public string Index
        {
            get
            {
                return GetIndex();
            }
            set
            {
                SetIndex(value);
            }
        }


        private const string nativeName = "VisualScriptPropertyGet";

        public VisualScriptPropertyGet() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptPropertyGet_Ctor(this);
        }

        internal VisualScriptPropertyGet(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_type");

        [GodotMethod("set_base_type")]
        public void SetBaseType(string baseType)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), baseType);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_type");

        [GodotMethod("get_base_type")]
        public string GetBaseType()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_script");

        [GodotMethod("set_base_script")]
        public void SetBaseScript(string baseScript)
        {
            NativeCalls.godot_icall_1_43(method_bind_2, Object.GetPtr(this), baseScript);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_script");

        [GodotMethod("get_base_script")]
        public string GetBaseScript()
        {
            return NativeCalls.godot_icall_0_2(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_basic_type");

        [GodotMethod("set_basic_type")]
        public void SetBasicType(Variant.Type basicType)
        {
            NativeCalls.godot_icall_1_943(method_bind_4, Object.GetPtr(this), basicType);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_basic_type");

        [GodotMethod("get_basic_type")]
        public Variant.Type GetBasicType()
        {
            return NativeCalls.godot_icall_0_944(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_set_type_cache");

        internal void _SetTypeCache(Variant.Type typeCache)
        {
            NativeCalls.godot_icall_1_943(method_bind_6, Object.GetPtr(this), typeCache);
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "_get_type_cache");

        internal Variant.Type _GetTypeCache()
        {
            return NativeCalls.godot_icall_0_944(method_bind_7, Object.GetPtr(this));
        }

        private IntPtr method_bind_8 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_property");

        [GodotMethod("set_property")]
        public void SetProperty(string property)
        {
            NativeCalls.godot_icall_1_43(method_bind_8, Object.GetPtr(this), property);
        }

        private IntPtr method_bind_9 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_property");

        [GodotMethod("get_property")]
        public string GetProperty()
        {
            return NativeCalls.godot_icall_0_2(method_bind_9, Object.GetPtr(this));
        }

        private IntPtr method_bind_10 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_call_mode");

        [GodotMethod("set_call_mode")]
        public void SetCallMode(VisualScriptPropertyGet.CallMode mode)
        {
            NativeCalls.godot_icall_1_960(method_bind_10, Object.GetPtr(this), mode);
        }

        private IntPtr method_bind_11 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_call_mode");

        [GodotMethod("get_call_mode")]
        public VisualScriptPropertyGet.CallMode GetCallMode()
        {
            return NativeCalls.godot_icall_0_961(method_bind_11, Object.GetPtr(this));
        }

        private IntPtr method_bind_12 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_path");

        [GodotMethod("set_base_path")]
        public void SetBasePath(NodePath basePath)
        {
            NativeCalls.godot_icall_1_78(method_bind_12, Object.GetPtr(this), NodePath.GetPtr(basePath));
        }

        private IntPtr method_bind_13 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_path");

        [GodotMethod("get_base_path")]
        public NodePath GetBasePath()
        {
            IntPtr ret = NativeCalls.godot_icall_0_79(method_bind_13, Object.GetPtr(this));
            return new NodePath(ret);
        }

        private IntPtr method_bind_14 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_index");

        [GodotMethod("set_index")]
        public void SetIndex(string index)
        {
            NativeCalls.godot_icall_1_43(method_bind_14, Object.GetPtr(this), index);
        }

        private IntPtr method_bind_15 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_index");

        [GodotMethod("get_index")]
        public string GetIndex()
        {
            return NativeCalls.godot_icall_0_2(method_bind_15, Object.GetPtr(this));
        }
    }
}
