using System;

namespace Godot
{
    /// <summary>
    /// A direct reference to a node.
    /// [b]Input Ports:[/b]
    /// none
    /// [b]Output Ports:[/b]
    /// - Data: [code]node[/code] (obj)
    /// </summary>
    public class VisualScriptSceneNode : VisualScriptNode
    {
        /// <summary>
        /// The node's path in the scene tree.
        /// </summary>
        public NodePath NodePath
        {
            get
            {
                return GetNodePath();
            }
            set
            {
                SetNodePath(value);
            }
        }


        private const string nativeName = "VisualScriptSceneNode";

        public VisualScriptSceneNode() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptSceneNode_Ctor(this);
        }

        internal VisualScriptSceneNode(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_node_path");

        [GodotMethod("set_node_path")]
        public void SetNodePath(NodePath path)
        {
            NativeCalls.godot_icall_1_78(method_bind_0, Object.GetPtr(this), NodePath.GetPtr(path));
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_node_path");

        [GodotMethod("get_node_path")]
        public NodePath GetNodePath()
        {
            IntPtr ret = NativeCalls.godot_icall_0_79(method_bind_1, Object.GetPtr(this));
            return new NodePath(ret);
        }
    }
}
