using System;

namespace Godot
{
    /// <summary>
    /// Chooses between two input values based on a Boolean condition.
    /// [b]Input Ports:[/b]
    /// - Data (boolean): [code]cond[/code]
    /// - Data (variant): [code]a[/code]
    /// - Data (variant): [code]b[/code]
    /// [b]Output Ports:[/b]
    /// - Data (variant): [code]out[/code]
    /// </summary>
    public class VisualScriptSelect : VisualScriptNode
    {
        /// <summary>
        /// The input variables' type.
        /// </summary>
        public Variant.Type Type
        {
            get
            {
                return GetTyped();
            }
            set
            {
                SetTyped(value);
            }
        }


        private const string nativeName = "VisualScriptSelect";

        public VisualScriptSelect() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptSelect_Ctor(this);
        }

        internal VisualScriptSelect(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_typed");

        [GodotMethod("set_typed")]
        public void SetTyped(Variant.Type type)
        {
            NativeCalls.godot_icall_1_943(method_bind_0, Object.GetPtr(this), type);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_typed");

        [GodotMethod("get_typed")]
        public Variant.Type GetTyped()
        {
            return NativeCalls.godot_icall_0_944(method_bind_1, Object.GetPtr(this));
        }
    }
}
