using System;

namespace Godot
{
    /// <summary>
    /// Provides a reference to the node running the visual script.
    /// [b]Input Ports:[/b]
    /// none
    /// [b]Output Ports:[/b]
    /// - Data (object): [code]instance[/code]
    /// </summary>
    public class VisualScriptSelf : VisualScriptNode
    {
        private const string nativeName = "VisualScriptSelf";

        public VisualScriptSelf() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptSelf_Ctor(this);
        }

        internal VisualScriptSelf(bool memoryOwn) : base(memoryOwn) {}
    }
}
