using System;

namespace Godot
{
    /// <summary>
    /// Branches the flow based on an input's value. Use "Case Count" in the Inspector to set the number of branches and each comparison's optional type.
    /// [b]Input Ports:[/b]
    /// - Sequence: [code]'input' is[/code]
    /// - Data (variant): [code]=[/code]
    /// - Data (variant): [code]=[/code] (optional)
    /// - Data (variant): [code]input[/code]
    /// [b]Output Ports:[/b]
    /// - Sequence
    /// - Sequence (optional)
    /// - Sequence: [code]done[/code]
    /// </summary>
    public class VisualScriptSwitch : VisualScriptNode
    {
        private const string nativeName = "VisualScriptSwitch";

        public VisualScriptSwitch() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptSwitch_Ctor(this);
        }

        internal VisualScriptSwitch(bool memoryOwn) : base(memoryOwn) {}
    }
}
