using System;

namespace Godot
{
    public class VisualScriptTypeCast : VisualScriptNode
    {
        /// <summary>
        /// </summary>
        public string BaseType
        {
            get
            {
                return GetBaseType();
            }
            set
            {
                SetBaseType(value);
            }
        }

        /// <summary>
        /// </summary>
        public string BaseScript
        {
            get
            {
                return GetBaseScript();
            }
            set
            {
                SetBaseScript(value);
            }
        }


        private const string nativeName = "VisualScriptTypeCast";

        public VisualScriptTypeCast() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptTypeCast_Ctor(this);
        }

        internal VisualScriptTypeCast(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_type");

        [GodotMethod("set_base_type")]
        public void SetBaseType(string type)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), type);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_type");

        [GodotMethod("get_base_type")]
        public string GetBaseType()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_script");

        [GodotMethod("set_base_script")]
        public void SetBaseScript(string path)
        {
            NativeCalls.godot_icall_1_43(method_bind_2, Object.GetPtr(this), path);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_script");

        [GodotMethod("get_base_script")]
        public string GetBaseScript()
        {
            return NativeCalls.godot_icall_0_2(method_bind_3, Object.GetPtr(this));
        }
    }
}
