using System;

namespace Godot
{
    /// <summary>
    /// Returns a variable's value. "Var Name" must be supplied, with an optional type.
    /// [b]Input Ports:[/b]
    /// none
    /// [b]Output Ports:[/b]
    /// - Data (variant): [code]value[/code]
    /// </summary>
    public class VisualScriptVariableGet : VisualScriptNode
    {
        /// <summary>
        /// The variable's name.
        /// </summary>
        public string VarName
        {
            get
            {
                return GetVariable();
            }
            set
            {
                SetVariable(value);
            }
        }


        private const string nativeName = "VisualScriptVariableGet";

        public VisualScriptVariableGet() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptVariableGet_Ctor(this);
        }

        internal VisualScriptVariableGet(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_variable");

        [GodotMethod("set_variable")]
        public void SetVariable(string name)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), name);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_variable");

        [GodotMethod("get_variable")]
        public string GetVariable()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }
    }
}
