using System;

namespace Godot
{
    /// <summary>
    /// Loops while a condition is [code]true[/code]. Execution continues out the [code]exit[/code] Sequence port when the loop terminates.
    /// [b]Input Ports:[/b]
    /// - Sequence: [code]while(cond)[/code]
    /// - Data (bool): [code]cond[/code]
    /// [b]Output Ports:[/b]
    /// - Sequence: [code]repeat[/code]
    /// - Sequence: [code]exit[/code]
    /// </summary>
    public class VisualScriptWhile : VisualScriptNode
    {
        private const string nativeName = "VisualScriptWhile";

        public VisualScriptWhile() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptWhile_Ctor(this);
        }

        internal VisualScriptWhile(bool memoryOwn) : base(memoryOwn) {}
    }
}
