using System;

namespace Godot
{
    public class VisualScriptYield : VisualScriptNode
    {
        public enum YieldMode
        {
            Frame = 1,
            PhysicsFrame = 2,
            Wait = 3
        }


        /// <summary>
        /// </summary>
        public VisualScriptYield.YieldMode Mode
        {
            get
            {
                return GetYieldMode();
            }
            set
            {
                SetYieldMode(value);
            }
        }

        /// <summary>
        /// </summary>
        public float WaitTime
        {
            get
            {
                return GetWaitTime();
            }
            set
            {
                SetWaitTime(value);
            }
        }


        private const string nativeName = "VisualScriptYield";

        public VisualScriptYield() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptYield_Ctor(this);
        }

        internal VisualScriptYield(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_yield_mode");

        [GodotMethod("set_yield_mode")]
        public void SetYieldMode(VisualScriptYield.YieldMode mode)
        {
            NativeCalls.godot_icall_1_966(method_bind_0, Object.GetPtr(this), mode);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_yield_mode");

        [GodotMethod("get_yield_mode")]
        public VisualScriptYield.YieldMode GetYieldMode()
        {
            return NativeCalls.godot_icall_0_967(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_wait_time");

        [GodotMethod("set_wait_time")]
        public void SetWaitTime(float sec)
        {
            NativeCalls.godot_icall_1_10(method_bind_2, Object.GetPtr(this), sec);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_wait_time");

        [GodotMethod("get_wait_time")]
        public float GetWaitTime()
        {
            return NativeCalls.godot_icall_0_9(method_bind_3, Object.GetPtr(this));
        }
    }
}
