using System;

namespace Godot
{
    public class VisualScriptYieldSignal : VisualScriptNode
    {
        public enum CallModeEnum
        {
            Self = 0,
            NodePath = 1,
            Instance = 2
        }


        /// <summary>
        /// </summary>
        public VisualScriptYieldSignal.CallModeEnum CallMode
        {
            get
            {
                return GetCallMode();
            }
            set
            {
                SetCallMode(value);
            }
        }

        /// <summary>
        /// </summary>
        public string BaseType
        {
            get
            {
                return GetBaseType();
            }
            set
            {
                SetBaseType(value);
            }
        }

        /// <summary>
        /// </summary>
        public NodePath NodePath
        {
            get
            {
                return GetBasePath();
            }
            set
            {
                SetBasePath(value);
            }
        }

        /// <summary>
        /// </summary>
        public string Signal
        {
            get
            {
                return GetSignal();
            }
            set
            {
                SetSignal(value);
            }
        }


        private const string nativeName = "VisualScriptYieldSignal";

        public VisualScriptYieldSignal() : this(true)
        {
            if (ptr == IntPtr.Zero)
                ptr = NativeCalls.godot_icall_VisualScriptYieldSignal_Ctor(this);
        }

        internal VisualScriptYieldSignal(bool memoryOwn) : base(memoryOwn) {}

        private IntPtr method_bind_0 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_type");

        [GodotMethod("set_base_type")]
        public void SetBaseType(string baseType)
        {
            NativeCalls.godot_icall_1_43(method_bind_0, Object.GetPtr(this), baseType);
        }

        private IntPtr method_bind_1 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_type");

        [GodotMethod("get_base_type")]
        public string GetBaseType()
        {
            return NativeCalls.godot_icall_0_2(method_bind_1, Object.GetPtr(this));
        }

        private IntPtr method_bind_2 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_signal");

        [GodotMethod("set_signal")]
        public void SetSignal(string signal)
        {
            NativeCalls.godot_icall_1_43(method_bind_2, Object.GetPtr(this), signal);
        }

        private IntPtr method_bind_3 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_signal");

        [GodotMethod("get_signal")]
        public string GetSignal()
        {
            return NativeCalls.godot_icall_0_2(method_bind_3, Object.GetPtr(this));
        }

        private IntPtr method_bind_4 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_call_mode");

        [GodotMethod("set_call_mode")]
        public void SetCallMode(VisualScriptYieldSignal.CallModeEnum mode)
        {
            NativeCalls.godot_icall_1_968(method_bind_4, Object.GetPtr(this), mode);
        }

        private IntPtr method_bind_5 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_call_mode");

        [GodotMethod("get_call_mode")]
        public VisualScriptYieldSignal.CallModeEnum GetCallMode()
        {
            return NativeCalls.godot_icall_0_969(method_bind_5, Object.GetPtr(this));
        }

        private IntPtr method_bind_6 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "set_base_path");

        [GodotMethod("set_base_path")]
        public void SetBasePath(NodePath basePath)
        {
            NativeCalls.godot_icall_1_78(method_bind_6, Object.GetPtr(this), NodePath.GetPtr(basePath));
        }

        private IntPtr method_bind_7 = NativeCalls.godot_icall_ClassDB_get_method(nativeName, "get_base_path");

        [GodotMethod("get_base_path")]
        public NodePath GetBasePath()
        {
            IntPtr ret = NativeCalls.godot_icall_0_79(method_bind_7, Object.GetPtr(this));
            return new NodePath(ret);
        }
    }
}
