using System;
using System.Runtime.CompilerServices;
using System.Collections.Generic;

namespace Godot
{
    internal static class NativeCalls
    {
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ClassDB_get_method(string type, string method);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_Object_Dtor(object obj, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_Object_connect_signal_awaiter(IntPtr source, string signal, IntPtr target, SignalAwaiter awaiter);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_NodePath_Ctor(string path);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_NodePath_Dtor(IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_NodePath_operator_String(IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RID_Ctor(IntPtr from);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_RID_Dtor(IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static byte[] godot_icall_String_md5_buffer(string str);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_String_md5_text(string str);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_String_rfind(string str, string what, int from);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_String_rfindn(string str, string what, int from);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static byte[] godot_icall_String_sha256_buffer(string str);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_String_sha256_text(string str);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_Godot_bytes2var(byte[] bytes);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_Godot_convert(object what, int type);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_Godot_hash(object var);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Object godot_icall_Godot_instance_from_id(int instance_id);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_Godot_print(object[] what);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_Godot_printerr(object[] what);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_Godot_printraw(object[] what);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_Godot_prints(object[] what);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_Godot_printt(object[] what);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_Godot_seed(int seed);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_Godot_str(object[] what);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_Godot_str2var(string str);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_Godot_type_exists(string type);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static byte[] godot_icall_Godot_var2bytes(object what);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_Godot_var2str(object var);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static WeakRef godot_icall_Godot_weakref(IntPtr obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ARVRAnchor_Ctor(ARVRAnchor obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ARVRCamera_Ctor(ARVRCamera obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ARVRController_Ctor(ARVRController obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ARVRInterfaceGDNative_Ctor(ARVRInterfaceGDNative obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ARVROrigin_Ctor(ARVROrigin obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ARVRPositionalTracker_Ctor(ARVRPositionalTracker obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ARVRServer_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AStar_Ctor(AStar obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AcceptDialog_Ctor(AcceptDialog obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AnimatedSprite_Ctor(AnimatedSprite obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AnimatedSprite3D_Ctor(AnimatedSprite3D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Animation_Ctor(Animation obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AnimationPlayer_Ctor(AnimationPlayer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AnimationTreePlayer_Ctor(AnimationTreePlayer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Area_Ctor(Area obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Area2D_Ctor(Area2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ArrayMesh_Ctor(ArrayMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AtlasTexture_Ctor(AtlasTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioBusLayout_Ctor(AudioBusLayout obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectAmplify_Ctor(AudioEffectAmplify obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectBandLimitFilter_Ctor(AudioEffectBandLimitFilter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectBandPassFilter_Ctor(AudioEffectBandPassFilter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectChorus_Ctor(AudioEffectChorus obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectCompressor_Ctor(AudioEffectCompressor obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectDelay_Ctor(AudioEffectDelay obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectDistortion_Ctor(AudioEffectDistortion obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectEQ_Ctor(AudioEffectEQ obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectEQ10_Ctor(AudioEffectEQ10 obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectEQ21_Ctor(AudioEffectEQ21 obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectEQ6_Ctor(AudioEffectEQ6 obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectFilter_Ctor(AudioEffectFilter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectHighPassFilter_Ctor(AudioEffectHighPassFilter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectHighShelfFilter_Ctor(AudioEffectHighShelfFilter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectLimiter_Ctor(AudioEffectLimiter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectLowPassFilter_Ctor(AudioEffectLowPassFilter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectLowShelfFilter_Ctor(AudioEffectLowShelfFilter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectNotchFilter_Ctor(AudioEffectNotchFilter obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectPanner_Ctor(AudioEffectPanner obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectPhaser_Ctor(AudioEffectPhaser obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectPitchShift_Ctor(AudioEffectPitchShift obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectReverb_Ctor(AudioEffectReverb obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioEffectStereoEnhance_Ctor(AudioEffectStereoEnhance obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioServer_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioStreamOGGVorbis_Ctor(AudioStreamOGGVorbis obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioStreamPlayer_Ctor(AudioStreamPlayer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioStreamPlayer2D_Ctor(AudioStreamPlayer2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioStreamPlayer3D_Ctor(AudioStreamPlayer3D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioStreamRandomPitch_Ctor(AudioStreamRandomPitch obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_AudioStreamSample_Ctor(AudioStreamSample obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_BackBufferCopy_Ctor(BackBufferCopy obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_BakedLightmap_Ctor(BakedLightmap obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_BakedLightmapData_Ctor(BakedLightmapData obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_BitMap_Ctor(BitMap obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_BitmapFont_Ctor(BitmapFont obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_BoneAttachment_Ctor(BoneAttachment obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_BoxShape_Ctor(BoxShape obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Button_Ctor(Button obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ButtonGroup_Ctor(ButtonGroup obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CSharpScript_Ctor(CSharpScript obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Camera_Ctor(Camera obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Camera2D_Ctor(Camera2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CanvasItemMaterial_Ctor(CanvasItemMaterial obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CanvasLayer_Ctor(CanvasLayer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CanvasModulate_Ctor(CanvasModulate obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CapsuleMesh_Ctor(CapsuleMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CapsuleShape_Ctor(CapsuleShape obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CapsuleShape2D_Ctor(CapsuleShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CenterContainer_Ctor(CenterContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CheckBox_Ctor(CheckBox obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CheckButton_Ctor(CheckButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CircleShape2D_Ctor(CircleShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CollisionPolygon_Ctor(CollisionPolygon obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CollisionPolygon2D_Ctor(CollisionPolygon2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CollisionShape_Ctor(CollisionShape obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CollisionShape2D_Ctor(CollisionShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ColorPicker_Ctor(ColorPicker obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ColorPickerButton_Ctor(ColorPickerButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ColorRect_Ctor(ColorRect obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ConcavePolygonShape_Ctor(ConcavePolygonShape obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ConcavePolygonShape2D_Ctor(ConcavePolygonShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ConeTwistJoint_Ctor(ConeTwistJoint obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ConfigFile_Ctor(ConfigFile obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ConfirmationDialog_Ctor(ConfirmationDialog obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Container_Ctor(Container obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Control_Ctor(Control obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ConvexPolygonShape_Ctor(ConvexPolygonShape obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ConvexPolygonShape2D_Ctor(ConvexPolygonShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CubeMap_Ctor(CubeMap obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CubeMesh_Ctor(CubeMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Curve_Ctor(Curve obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Curve2D_Ctor(Curve2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Curve3D_Ctor(Curve3D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CurveTexture_Ctor(CurveTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_CylinderMesh_Ctor(CylinderMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_DampedSpringJoint2D_Ctor(DampedSpringJoint2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_DirectionalLight_Ctor(DirectionalLight obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_DynamicFont_Ctor(DynamicFont obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_DynamicFontData_Ctor(DynamicFontData obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_EncodedObjectAsID_Ctor(EncodedObjectAsID obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Environment_Ctor(Environment obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_FileDialog_Ctor(FileDialog obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_FuncRef_Ctor(FuncRef obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GDNative_Ctor(GDNative obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GDNativeLibrary_Ctor(GDNativeLibrary obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GDScript_Ctor(GDScript obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GIProbe_Ctor(GIProbe obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GIProbeData_Ctor(GIProbeData obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Generic6DOFJoint_Ctor(Generic6DOFJoint obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Gradient_Ctor(Gradient obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GradientTexture_Ctor(GradientTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GraphEdit_Ctor(GraphEdit obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GraphNode_Ctor(GraphNode obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GridContainer_Ctor(GridContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GridMap_Ctor(GridMap obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_GrooveJoint2D_Ctor(GrooveJoint2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_HBoxContainer_Ctor(HBoxContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_HScrollBar_Ctor(HScrollBar obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_HSeparator_Ctor(HSeparator obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_HSlider_Ctor(HSlider obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_HSplitContainer_Ctor(HSplitContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_HTTPClient_Ctor(HTTPClient obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_HTTPRequest_Ctor(HTTPRequest obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_HingeJoint_Ctor(HingeJoint obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_IP_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Image_Ctor(Image obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ImageTexture_Ctor(ImageTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ImmediateGeometry_Ctor(ImmediateGeometry obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Input_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventAction_Ctor(InputEventAction obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventJoypadButton_Ctor(InputEventJoypadButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventJoypadMotion_Ctor(InputEventJoypadMotion obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventKey_Ctor(InputEventKey obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventMagnifyGesture_Ctor(InputEventMagnifyGesture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventMouseButton_Ctor(InputEventMouseButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventMouseMotion_Ctor(InputEventMouseMotion obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventPanGesture_Ctor(InputEventPanGesture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventScreenDrag_Ctor(InputEventScreenDrag obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputEventScreenTouch_Ctor(InputEventScreenTouch obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InputMap_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_InterpolatedCamera_Ctor(InterpolatedCamera obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ItemList_Ctor(ItemList obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_JSONParseResult_Ctor(JSONParseResult obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_JavaScript_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_KinematicBody_Ctor(KinematicBody obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_KinematicBody2D_Ctor(KinematicBody2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_KinematicCollision_Ctor(KinematicCollision obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_KinematicCollision2D_Ctor(KinematicCollision2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Label_Ctor(Label obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_LargeTexture_Ctor(LargeTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Light2D_Ctor(Light2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_LightOccluder2D_Ctor(LightOccluder2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Line2D_Ctor(Line2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_LineEdit_Ctor(LineEdit obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_LineShape2D_Ctor(LineShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_LinkButton_Ctor(LinkButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Listener_Ctor(Listener obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MainLoop_Ctor(MainLoop obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MarginContainer_Ctor(MarginContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MenuButton_Ctor(MenuButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MeshDataTool_Ctor(MeshDataTool obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MeshInstance_Ctor(MeshInstance obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MeshLibrary_Ctor(MeshLibrary obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MobileVRInterface_Ctor(MobileVRInterface obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MultiMesh_Ctor(MultiMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_MultiMeshInstance_Ctor(MultiMeshInstance obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_NativeScript_Ctor(NativeScript obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Navigation_Ctor(Navigation obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Navigation2D_Ctor(Navigation2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_NavigationMesh_Ctor(NavigationMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_NavigationMeshInstance_Ctor(NavigationMeshInstance obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_NavigationPolygon_Ctor(NavigationPolygon obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_NavigationPolygonInstance_Ctor(NavigationPolygonInstance obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_NetworkedMultiplayerENet_Ctor(NetworkedMultiplayerENet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_NinePatchRect_Ctor(NinePatchRect obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Node_Ctor(Node obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Node2D_Ctor(Node2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Object_Ctor(Object obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_OccluderPolygon2D_Ctor(OccluderPolygon2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_OmniLight_Ctor(OmniLight obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_OptionButton_Ctor(OptionButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PCKPacker_Ctor(PCKPacker obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PHashTranslation_Ctor(PHashTranslation obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PackedDataContainer_Ctor(PackedDataContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PackedScene_Ctor(PackedScene obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PacketPeerStream_Ctor(PacketPeerStream obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PacketPeerUDP_Ctor(PacketPeerUDP obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Panel_Ctor(Panel obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PanelContainer_Ctor(PanelContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PanoramaSky_Ctor(PanoramaSky obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ParallaxBackground_Ctor(ParallaxBackground obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ParallaxLayer_Ctor(ParallaxLayer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Particles_Ctor(Particles obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Particles2D_Ctor(Particles2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ParticlesMaterial_Ctor(ParticlesMaterial obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Path_Ctor(Path obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Path2D_Ctor(Path2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PathFollow_Ctor(PathFollow obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PathFollow2D_Ctor(PathFollow2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Performance_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Physics2DServer_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Physics2DShapeQueryParameters_Ctor(Physics2DShapeQueryParameters obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Physics2DTestMotionResult_Ctor(Physics2DTestMotionResult obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PhysicsServer_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PhysicsShapeQueryParameters_Ctor(PhysicsShapeQueryParameters obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PinJoint_Ctor(PinJoint obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PinJoint2D_Ctor(PinJoint2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PlaneMesh_Ctor(PlaneMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PlaneShape_Ctor(PlaneShape obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PluginScript_Ctor(PluginScript obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Polygon2D_Ctor(Polygon2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PolygonPathFinder_Ctor(PolygonPathFinder obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Popup_Ctor(Popup obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PopupDialog_Ctor(PopupDialog obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PopupMenu_Ctor(PopupMenu obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PopupPanel_Ctor(PopupPanel obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Position2D_Ctor(Position2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Position3D_Ctor(Position3D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_PrismMesh_Ctor(PrismMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ProceduralSky_Ctor(ProceduralSky obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ProgressBar_Ctor(ProgressBar obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ProjectSettings_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ProximityGroup_Ctor(ProximityGroup obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ProxyTexture_Ctor(ProxyTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_QuadMesh_Ctor(QuadMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RayCast_Ctor(RayCast obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RayCast2D_Ctor(RayCast2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RayShape_Ctor(RayShape obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RayShape2D_Ctor(RayShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RectangleShape2D_Ctor(RectangleShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Reference_Ctor(Reference obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ReferenceRect_Ctor(ReferenceRect obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ReflectionProbe_Ctor(ReflectionProbe obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RegEx_Ctor(RegEx obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RegExMatch_Ctor(RegExMatch obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RemoteTransform_Ctor(RemoteTransform obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RemoteTransform2D_Ctor(RemoteTransform2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Resource_Ctor(Resource obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ResourcePreloader_Ctor(ResourcePreloader obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RichTextLabel_Ctor(RichTextLabel obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RigidBody_Ctor(RigidBody obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_RigidBody2D_Ctor(RigidBody2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SceneTree_Ctor(SceneTree obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ScrollContainer_Ctor(ScrollContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SegmentShape2D_Ctor(SegmentShape2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Shader_Ctor(Shader obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ShaderMaterial_Ctor(ShaderMaterial obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ShortCut_Ctor(ShortCut obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Skeleton_Ctor(Skeleton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SliderJoint_Ctor(SliderJoint obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Spatial_Ctor(Spatial obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SpatialMaterial_Ctor(SpatialMaterial obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SpatialVelocityTracker_Ctor(SpatialVelocityTracker obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SphereMesh_Ctor(SphereMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SphereShape_Ctor(SphereShape obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SpinBox_Ctor(SpinBox obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SpotLight_Ctor(SpotLight obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Sprite_Ctor(Sprite obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Sprite3D_Ctor(Sprite3D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SpriteFrames_Ctor(SpriteFrames obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StaticBody_Ctor(StaticBody obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StaticBody2D_Ctor(StaticBody2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StreamPeerBuffer_Ctor(StreamPeerBuffer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StreamPeerSSL_Ctor(StreamPeerSSL obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StreamPeerTCP_Ctor(StreamPeerTCP obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StreamTexture_Ctor(StreamTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StyleBoxEmpty_Ctor(StyleBoxEmpty obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StyleBoxFlat_Ctor(StyleBoxFlat obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StyleBoxLine_Ctor(StyleBoxLine obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_StyleBoxTexture_Ctor(StyleBoxTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_SurfaceTool_Ctor(SurfaceTool obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TCP_Server_Ctor(TCP_Server obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TabContainer_Ctor(TabContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Tabs_Ctor(Tabs obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TextEdit_Ctor(TextEdit obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TextureButton_Ctor(TextureButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TextureProgress_Ctor(TextureProgress obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TextureRect_Ctor(TextureRect obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Theme_Ctor(Theme obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TileMap_Ctor(TileMap obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TileSet_Ctor(TileSet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Timer_Ctor(Timer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ToolButton_Ctor(ToolButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TouchScreenButton_Ctor(TouchScreenButton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Translation_Ctor(Translation obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TranslationServer_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Tree_Ctor(Tree obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_TriangleMesh_Ctor(TriangleMesh obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Tween_Ctor(Tween obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_UndoRedo_Ctor(UndoRedo obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VBoxContainer_Ctor(VBoxContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VScrollBar_Ctor(VScrollBar obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VSeparator_Ctor(VSeparator obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VSlider_Ctor(VSlider obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VSplitContainer_Ctor(VSplitContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VehicleBody_Ctor(VehicleBody obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VehicleWheel_Ctor(VehicleWheel obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VideoPlayer_Ctor(VideoPlayer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VideoStreamTheora_Ctor(VideoStreamTheora obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VideoStreamWebm_Ctor(VideoStreamWebm obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Viewport_Ctor(Viewport obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ViewportContainer_Ctor(ViewportContainer obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_ViewportTexture_Ctor(ViewportTexture obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisibilityEnabler_Ctor(VisibilityEnabler obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisibilityEnabler2D_Ctor(VisibilityEnabler2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisibilityNotifier_Ctor(VisibilityNotifier obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisibilityNotifier2D_Ctor(VisibilityNotifier2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScript_Ctor(VisualScript obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptBasicTypeConstant_Ctor(VisualScriptBasicTypeConstant obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptBuiltinFunc_Ctor(VisualScriptBuiltinFunc obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptClassConstant_Ctor(VisualScriptClassConstant obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptComment_Ctor(VisualScriptComment obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptCondition_Ctor(VisualScriptCondition obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptConstant_Ctor(VisualScriptConstant obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptConstructor_Ctor(VisualScriptConstructor obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptCustomNode_Ctor(VisualScriptCustomNode obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptDeconstruct_Ctor(VisualScriptDeconstruct obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptEmitSignal_Ctor(VisualScriptEmitSignal obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptEngineSingleton_Ctor(VisualScriptEngineSingleton obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptExpression_Ctor(VisualScriptExpression obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptFunction_Ctor(VisualScriptFunction obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptFunctionCall_Ctor(VisualScriptFunctionCall obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptFunctionState_Ctor(VisualScriptFunctionState obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptGlobalConstant_Ctor(VisualScriptGlobalConstant obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptIndexGet_Ctor(VisualScriptIndexGet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptIndexSet_Ctor(VisualScriptIndexSet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptInputAction_Ctor(VisualScriptInputAction obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptIterator_Ctor(VisualScriptIterator obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptLocalVar_Ctor(VisualScriptLocalVar obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptLocalVarSet_Ctor(VisualScriptLocalVarSet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptMathConstant_Ctor(VisualScriptMathConstant obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptOperator_Ctor(VisualScriptOperator obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptPreload_Ctor(VisualScriptPreload obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptPropertyGet_Ctor(VisualScriptPropertyGet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptPropertySet_Ctor(VisualScriptPropertySet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptResourcePath_Ctor(VisualScriptResourcePath obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptReturn_Ctor(VisualScriptReturn obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptSceneNode_Ctor(VisualScriptSceneNode obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptSceneTree_Ctor(VisualScriptSceneTree obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptSelect_Ctor(VisualScriptSelect obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptSelf_Ctor(VisualScriptSelf obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptSequence_Ctor(VisualScriptSequence obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptSubCall_Ctor(VisualScriptSubCall obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptSwitch_Ctor(VisualScriptSwitch obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptTypeCast_Ctor(VisualScriptTypeCast obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptVariableGet_Ctor(VisualScriptVariableGet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptVariableSet_Ctor(VisualScriptVariableSet obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptWhile_Ctor(VisualScriptWhile obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptYield_Ctor(VisualScriptYield obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualScriptYieldSignal_Ctor(VisualScriptYieldSignal obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_VisualServer_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_WeakRef_Ctor(WeakRef obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_WindowDialog_Ctor(WindowDialog obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_World_Ctor(World obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_World2D_Ctor(World2D obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_WorldEnvironment_Ctor(WorldEnvironment obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_XMLParser_Ctor(XMLParser obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_YSort_Ctor(YSort obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__ClassDB_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Directory_Ctor(Directory obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__Engine_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_File_Ctor(File obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__Geometry_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__GodotSharp_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__JSON_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__Marshalls_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Mutex_Ctor(Mutex obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__OS_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__ResourceLoader_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__ResourceSaver_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Semaphore_Ctor(Semaphore obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_Thread_Ctor(Thread obj);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall__VisualScriptEditor_get_singleton();
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_0(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_0_1(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_0_2(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_0_3(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_4(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_5(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_6(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_7(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ARVRPositionalTracker.TrackerHand godot_icall_0_8(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_0_9(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_10(IntPtr method, IntPtr ptr, float arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_11(IntPtr method, IntPtr ptr, bool arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_0_12(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ARVRInterface.Tracking_status godot_icall_0_13(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_14(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ARVRServer.TrackerType godot_icall_0_15(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_16(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_17(IntPtr method, IntPtr ptr, bool arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_18(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_19(IntPtr method, IntPtr ptr, ARVRServer.RotationMode arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ARVRInterface godot_icall_1_20(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_0_21(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ARVRInterface godot_icall_1_22(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ARVRPositionalTracker godot_icall_1_23(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_24(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_25(IntPtr method, IntPtr ptr, int arg1, ref Vector3 arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_26(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_27(IntPtr method, IntPtr ptr, int arg1, ref Vector3 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_28(IntPtr method, IntPtr ptr, int arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_29(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int[] godot_icall_1_30(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_31(IntPtr method, IntPtr ptr, int arg1, int arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_32(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_33(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_34(IntPtr method, IntPtr ptr, ref Vector3 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_35(IntPtr method, IntPtr ptr, ref Vector3 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_2_36(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int[] godot_icall_2_37(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Button godot_icall_0_38(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Label godot_icall_0_39(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Button godot_icall_3_40(IntPtr method, IntPtr ptr, string arg1, bool arg2, string arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Button godot_icall_1_41(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_42(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_43(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpriteFrames godot_icall_0_44(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_45(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_46(IntPtr method, IntPtr ptr, Animation.TrackType arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Animation.TrackType godot_icall_1_47(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_1_48(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_49(IntPtr method, IntPtr ptr, int arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_50(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_51(IntPtr method, IntPtr ptr, int arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_5_52(IntPtr method, IntPtr ptr, int arg1, float arg2, ref Vector3 arg3, ref Quat arg4, ref Vector3 arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_53(IntPtr method, IntPtr ptr, int arg1, float arg2, object arg3, float arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_54(IntPtr method, IntPtr ptr, int arg1, int arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_55(IntPtr method, IntPtr ptr, int arg1, int arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_56(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_57(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_3_58(IntPtr method, IntPtr ptr, int arg1, float arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_59(IntPtr method, IntPtr ptr, int arg1, Animation.InterpolationType arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Animation.InterpolationType godot_icall_1_60(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_2_61(IntPtr method, IntPtr ptr, int arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_62(IntPtr method, IntPtr ptr, int arg1, Animation.UpdateMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Animation.UpdateMode godot_icall_1_63(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int[] godot_icall_3_64(IntPtr method, IntPtr ptr, int arg1, float arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_2_65(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_2_66(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_67(IntPtr method, IntPtr ptr, int arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_2_68(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_69(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_70(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Animation godot_icall_1_71(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string[] godot_icall_0_72(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_73(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_74(IntPtr method, IntPtr ptr, string arg1, string arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_75(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_76(IntPtr method, IntPtr ptr, string arg1, float arg2, float arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_77(IntPtr method, IntPtr ptr, string arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_78(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_0_79(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_80(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_81(IntPtr method, IntPtr ptr, AnimationPlayer.AnimationProcessMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AnimationPlayer.AnimationProcessMode godot_icall_0_82(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_83(IntPtr method, IntPtr ptr, float arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_84(IntPtr method, IntPtr ptr, AnimationTreePlayer.NodeType arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_2_85(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AnimationTreePlayer.NodeType godot_icall_1_86(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_87(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_2_88(IntPtr method, IntPtr ptr, string arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_89(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_90(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_91(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_92(IntPtr method, IntPtr ptr, string arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_93(IntPtr method, IntPtr ptr, string arg1, ref Vector2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_94(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_95(IntPtr method, IntPtr ptr, string arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_96(IntPtr method, IntPtr ptr, string arg1, int arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_97(IntPtr method, IntPtr ptr, string arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_98(IntPtr method, IntPtr ptr, string arg1, string arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_3_99(IntPtr method, IntPtr ptr, string arg1, string arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_100(IntPtr method, IntPtr ptr, AnimationTreePlayer.AnimationProcessMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AnimationTreePlayer.AnimationProcessMode godot_icall_0_101(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_102(IntPtr method, IntPtr ptr, Area.SpaceOverrideEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Area.SpaceOverrideEnum godot_icall_0_103(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_104(IntPtr method, IntPtr ptr, ref Vector3 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_105(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_106(IntPtr method, IntPtr ptr, Area2D.SpaceOverrideEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Area2D.SpaceOverrideEnum godot_icall_0_107(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_108(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_109(IntPtr method, IntPtr ptr, Mesh.BlendShapeMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Mesh.BlendShapeMode godot_icall_0_110(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_111(IntPtr method, IntPtr ptr, Mesh.PrimitiveType arg1, object[] arg2, object[] arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_112(IntPtr method, IntPtr ptr, int arg1, int arg2, byte[] arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Mesh.PrimitiveType godot_icall_1_113(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Material godot_icall_1_114(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_115(IntPtr method, IntPtr ptr, int arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_1_116(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_117(IntPtr method, IntPtr ptr, ref AABB arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_118(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Texture godot_icall_0_119(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_120(IntPtr method, IntPtr ptr, ref Rect2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_121(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_122(IntPtr method, IntPtr ptr, AudioEffectDistortion.ModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioEffectDistortion.ModeEnum godot_icall_0_123(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_124(IntPtr method, IntPtr ptr, AudioEffectFilter.FilterDB arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioEffectFilter.FilterDB godot_icall_0_125(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_126(IntPtr method, IntPtr ptr, int arg1, IntPtr arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioEffect godot_icall_2_127(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_128(IntPtr method, IntPtr ptr, int arg1, int arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioServer.SpeakerMode godot_icall_0_129(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioBusLayout godot_icall_0_130(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_131(IntPtr method, IntPtr ptr, byte[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static byte[] godot_icall_0_132(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioStream godot_icall_0_133(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_134(IntPtr method, IntPtr ptr, AudioStreamPlayer.MixTargetEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioStreamPlayer.MixTargetEnum godot_icall_0_135(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_136(IntPtr method, IntPtr ptr, AudioStreamPlayer3D.AttenuationModelEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioStreamPlayer3D.AttenuationModelEnum godot_icall_0_137(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_138(IntPtr method, IntPtr ptr, AudioStreamPlayer3D.OutOfRangeModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioStreamPlayer3D.OutOfRangeModeEnum godot_icall_0_139(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_140(IntPtr method, IntPtr ptr, AudioStreamPlayer3D.DopplerTrackingEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioStreamPlayer3D.DopplerTrackingEnum godot_icall_0_141(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_142(IntPtr method, IntPtr ptr, AudioStreamSample.FormatEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioStreamSample.FormatEnum godot_icall_0_143(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_144(IntPtr method, IntPtr ptr, AudioStreamSample.LoopModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static AudioStreamSample.LoopModeEnum godot_icall_0_145(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_146(IntPtr method, IntPtr ptr, BackBufferCopy.CopyModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BackBufferCopy.CopyModeEnum godot_icall_0_147(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BakedLightmapData godot_icall_0_148(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_149(IntPtr method, IntPtr ptr, BakedLightmap.BakeQualityEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BakedLightmap.BakeQualityEnum godot_icall_0_150(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_151(IntPtr method, IntPtr ptr, BakedLightmap.BakeModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BakedLightmap.BakeModeEnum godot_icall_0_152(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BakedLightmap.BakeError godot_icall_2_153(IntPtr method, IntPtr ptr, IntPtr arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_154(IntPtr method, IntPtr ptr, object[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_155(IntPtr method, IntPtr ptr, ref Transform arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_156(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Texture godot_icall_1_157(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_158(IntPtr method, IntPtr ptr, BaseButton.ActionModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BaseButton.ActionModeEnum godot_icall_0_159(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BaseButton.DrawMode godot_icall_0_160(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_161(IntPtr method, IntPtr ptr, Control.FocusModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Control.FocusModeEnum godot_icall_0_162(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ShortCut godot_icall_0_163(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ButtonGroup godot_icall_0_164(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_165(IntPtr method, IntPtr ptr, ref Vector2 arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_166(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_167(IntPtr method, IntPtr ptr, ref Rect2 arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_168(IntPtr method, IntPtr ptr, Dictionary<object, object> arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_0_169(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_1_170(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_171(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_172(IntPtr method, IntPtr ptr, int arg1, int arg2, ref Rect2 arg3, ref Vector2 arg4, float arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_173(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_174(IntPtr method, IntPtr ptr, int[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int[] godot_icall_0_175(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BitmapFont godot_icall_0_176(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BoxContainer.AlignMode godot_icall_0_177(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_178(IntPtr method, IntPtr ptr, BoxContainer.AlignMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_179(IntPtr method, IntPtr ptr, Button.TextAlign arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Button.TextAlign godot_icall_0_180(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BaseButton godot_icall_0_181(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Object godot_icall_1_182(IntPtr method, IntPtr ptr, object[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_183(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_184(IntPtr method, IntPtr ptr, ref Vector3 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_185(IntPtr method, IntPtr ptr, ref Vector3 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_186(IntPtr method, IntPtr ptr, float arg1, float arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Camera.ProjectionEnum godot_icall_0_187(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_188(IntPtr method, IntPtr ptr, Camera.ProjectionEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Environment godot_icall_0_189(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_190(IntPtr method, IntPtr ptr, Camera.KeepAspectEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Camera.KeepAspectEnum godot_icall_0_191(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_192(IntPtr method, IntPtr ptr, Camera.DopplerTrackingEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Camera.DopplerTrackingEnum godot_icall_0_193(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_194(IntPtr method, IntPtr ptr, Camera2D.AnchorModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Camera2D.AnchorModeEnum godot_icall_0_195(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_196(IntPtr method, IntPtr ptr, Margin arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_197(IntPtr method, IntPtr ptr, Margin arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_198(IntPtr method, IntPtr ptr, Margin arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_199(IntPtr method, IntPtr ptr, Margin arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Node godot_icall_0_200(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_0_201(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_202(IntPtr method, IntPtr ptr, ref Color arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_203(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_204(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, ref Color arg3, float arg4, bool arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_205(IntPtr method, IntPtr ptr, Vector2[] arg1, ref Color arg2, float arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_206(IntPtr method, IntPtr ptr, Vector2[] arg1, Color[] arg2, float arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_207(IntPtr method, IntPtr ptr, ref Rect2 arg1, ref Color arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_208(IntPtr method, IntPtr ptr, ref Vector2 arg1, float arg2, ref Color arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_209(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, ref Color arg3, IntPtr arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_6_210(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, bool arg3, ref Color arg4, bool arg5, IntPtr arg6);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_7_211(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, ref Rect2 arg3, ref Color arg4, bool arg5, IntPtr arg6, bool arg7);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_212(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_6_213(IntPtr method, IntPtr ptr, Vector2[] arg1, Color[] arg2, Vector2[] arg3, IntPtr arg4, float arg5, IntPtr arg6);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_6_214(IntPtr method, IntPtr ptr, Vector2[] arg1, Color[] arg2, Vector2[] arg3, IntPtr arg4, IntPtr arg5, bool arg6);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_6_215(IntPtr method, IntPtr ptr, Vector2[] arg1, ref Color arg2, Vector2[] arg3, IntPtr arg4, IntPtr arg5, bool arg6);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_216(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, string arg3, ref Color arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_5_217(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, string arg3, string arg4, ref Color arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_218(IntPtr method, IntPtr ptr, ref Vector2 arg1, float arg2, ref Vector2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_219(IntPtr method, IntPtr ptr, ref Transform2D arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_220(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static World2D godot_icall_0_221(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Material godot_icall_0_222(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_223(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static InputEvent godot_icall_1_224(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_225(IntPtr method, IntPtr ptr, CanvasItemMaterial.BlendModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static CanvasItemMaterial.BlendModeEnum godot_icall_0_226(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_227(IntPtr method, IntPtr ptr, CanvasItemMaterial.LightModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static CanvasItemMaterial.LightModeEnum godot_icall_0_228(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_229(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_230(IntPtr method, IntPtr ptr, int arg1, ref Transform arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_231(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Object godot_icall_1_232(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Shape godot_icall_2_233(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_234(IntPtr method, IntPtr ptr, int arg1, ref Transform2D arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_235(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Shape2D godot_icall_2_236(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_237(IntPtr method, IntPtr ptr, Vector2[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector2[] godot_icall_0_238(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_239(IntPtr method, IntPtr ptr, CollisionPolygon2D.BuildModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static CollisionPolygon2D.BuildModeEnum godot_icall_0_240(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Shape godot_icall_0_241(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Shape2D godot_icall_0_242(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ColorPicker godot_icall_0_243(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PopupPanel godot_icall_0_244(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_245(IntPtr method, IntPtr ptr, Vector3[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_0_246(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_247(IntPtr method, IntPtr ptr, ConeTwistJoint.Param arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_248(IntPtr method, IntPtr ptr, ConeTwistJoint.Param arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_249(IntPtr method, IntPtr ptr, string arg1, string arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_250(IntPtr method, IntPtr ptr, string arg1, string arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_251(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string[] godot_icall_1_252(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_253(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_254(IntPtr method, IntPtr ptr, Control.LayoutPreset arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_255(IntPtr method, IntPtr ptr, Control.LayoutPreset arg1, Control.LayoutPresetMode arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_256(IntPtr method, IntPtr ptr, Margin arg1, float arg2, bool arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_257(IntPtr method, IntPtr ptr, Margin arg1, float arg2, float arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Control godot_icall_0_258(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Theme godot_icall_0_259(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_260(IntPtr method, IntPtr ptr, string arg1, ref Color arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Texture godot_icall_2_261(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static StyleBox godot_icall_2_262(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Font godot_icall_2_263(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_264(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_265(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_266(IntPtr method, IntPtr ptr, Control.GrowDirection arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Control.GrowDirection godot_icall_0_267(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_268(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_269(IntPtr method, IntPtr ptr, Control.CursorShape arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Control.CursorShape godot_icall_0_270(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Control.CursorShape godot_icall_1_271(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_272(IntPtr method, IntPtr ptr, Margin arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_1_273(IntPtr method, IntPtr ptr, Margin arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_274(IntPtr method, IntPtr ptr, object arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_275(IntPtr method, IntPtr ptr, Control.MouseFilterEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Control.MouseFilterEnum godot_icall_0_276(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_277(IntPtr method, IntPtr ptr, CubeMap.Side arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Image godot_icall_1_278(IntPtr method, IntPtr ptr, CubeMap.Side arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_279(IntPtr method, IntPtr ptr, CubeMap.Storage arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static CubeMap.Storage godot_icall_0_280(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_5_281(IntPtr method, IntPtr ptr, ref Vector2 arg1, float arg2, float arg3, Curve.TangentMode arg4, Curve.TangentMode arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_282(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_283(IntPtr method, IntPtr ptr, int arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_284(IntPtr method, IntPtr ptr, float arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Curve.TangentMode godot_icall_1_285(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_286(IntPtr method, IntPtr ptr, int arg1, Curve.TangentMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_287(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, ref Vector2 arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_288(IntPtr method, IntPtr ptr, int arg1, ref Vector2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_289(IntPtr method, IntPtr ptr, int arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_290(IntPtr method, IntPtr ptr, float arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_291(IntPtr method, IntPtr ptr, float arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector2[] godot_icall_2_292(IntPtr method, IntPtr ptr, int arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_293(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, ref Vector3 arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_294(IntPtr method, IntPtr ptr, int arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_295(IntPtr method, IntPtr ptr, float arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_296(IntPtr method, IntPtr ptr, float arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float[] godot_icall_0_297(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_2_298(IntPtr method, IntPtr ptr, int arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Curve godot_icall_0_299(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_300(IntPtr method, IntPtr ptr, DirectionalLight.ShadowMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static DirectionalLight.ShadowMode godot_icall_0_301(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_302(IntPtr method, IntPtr ptr, DirectionalLight.ShadowDepthRange arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static DirectionalLight.ShadowDepthRange godot_icall_0_303(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static DynamicFontData godot_icall_0_304(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static DynamicFontData godot_icall_1_305(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VBoxContainer godot_icall_0_310(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_0_325(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_337(IntPtr method, IntPtr ptr, string arg1, object arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_338(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_339(IntPtr method, IntPtr ptr, string arg1, object arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_340(IntPtr method, IntPtr ptr, string[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_346(IntPtr method, IntPtr ptr, Environment.BGMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Environment.BGMode godot_icall_0_347(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Sky godot_icall_0_348(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_349(IntPtr method, IntPtr ptr, Environment.ToneMapper arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Environment.ToneMapper godot_icall_0_350(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_351(IntPtr method, IntPtr ptr, Environment.SSAOBlur arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Environment.SSAOBlur godot_icall_0_352(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_353(IntPtr method, IntPtr ptr, Environment.SSAOQuality arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Environment.SSAOQuality godot_icall_0_354(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_355(IntPtr method, IntPtr ptr, Environment.DOFBlurQuality arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Environment.DOFBlurQuality godot_icall_0_356(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_357(IntPtr method, IntPtr ptr, Environment.GlowBlendModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Environment.GlowBlendModeEnum godot_icall_0_358(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_359(IntPtr method, IntPtr ptr, FileDialog.ModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static FileDialog.ModeEnum godot_icall_0_360(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_361(IntPtr method, IntPtr ptr, FileDialog.AccessEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static FileDialog.AccessEnum godot_icall_0_362(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_363(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, string arg3, ref Color arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_5_364(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, int arg3, int arg4, ref Color arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_365(IntPtr method, IntPtr ptr, object[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static GDNativeLibrary godot_icall_0_366(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_367(IntPtr method, IntPtr ptr, string arg1, string arg2, object[] arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ConfigFile godot_icall_0_368(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_369(IntPtr method, IntPtr ptr, object arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_370(IntPtr method, IntPtr ptr, bool arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static GIProbeData godot_icall_0_371(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_372(IntPtr method, IntPtr ptr, GIProbe.SubdivEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static GIProbe.SubdivEnum godot_icall_0_373(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_374(IntPtr method, IntPtr ptr, IntPtr arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_375(IntPtr method, IntPtr ptr, Generic6DOFJoint.Param arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_376(IntPtr method, IntPtr ptr, Generic6DOFJoint.Param arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_377(IntPtr method, IntPtr ptr, Generic6DOFJoint.Flag arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_378(IntPtr method, IntPtr ptr, Generic6DOFJoint.Flag arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_379(IntPtr method, IntPtr ptr, GeometryInstance.Flags arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_380(IntPtr method, IntPtr ptr, GeometryInstance.Flags arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_381(IntPtr method, IntPtr ptr, GeometryInstance.ShadowCastingSetting arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static GeometryInstance.ShadowCastingSetting godot_icall_0_382(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_383(IntPtr method, IntPtr ptr, float arg1, ref Color arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_384(IntPtr method, IntPtr ptr, int arg1, ref Color arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_385(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_386(IntPtr method, IntPtr ptr, float arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_387(IntPtr method, IntPtr ptr, float[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_388(IntPtr method, IntPtr ptr, Color[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Color[] godot_icall_0_389(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Gradient godot_icall_0_390(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_4_391(IntPtr method, IntPtr ptr, string arg1, int arg2, string arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_4_392(IntPtr method, IntPtr ptr, string arg1, int arg2, string arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_393(IntPtr method, IntPtr ptr, string arg1, int arg2, string arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_9_394(IntPtr method, IntPtr ptr, int arg1, bool arg2, int arg3, ref Color arg4, bool arg5, int arg6, ref Color arg7, IntPtr arg8, IntPtr arg9);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_395(IntPtr method, IntPtr ptr, GraphNode.OverlayEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static GraphNode.OverlayEnum godot_icall_0_396(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static MeshLibrary godot_icall_0_397(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_398(IntPtr method, IntPtr ptr, int arg1, int arg2, int arg3, int arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_3_399(IntPtr method, IntPtr ptr, int arg1, int arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_400(IntPtr method, IntPtr ptr, int arg1, int arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_401(IntPtr method, IntPtr ptr, bool arg1, bool arg2, int arg3, Vector3.Axis arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_1_402(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_403(IntPtr method, IntPtr ptr, bool arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_4_404(IntPtr method, IntPtr ptr, string arg1, int arg2, bool arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static StreamPeer godot_icall_0_405(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_4_406(IntPtr method, IntPtr ptr, HTTPClient.Method arg1, string arg2, string[] arg3, byte[] arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_4_407(IntPtr method, IntPtr ptr, HTTPClient.Method arg1, string arg2, string[] arg3, string arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static HTTPClient.Status godot_icall_0_408(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_409(IntPtr method, IntPtr ptr, Dictionary<object, object> arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_5_410(IntPtr method, IntPtr ptr, string arg1, string[] arg2, bool arg3, HTTPClient.Method arg4, string arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_411(IntPtr method, IntPtr ptr, HingeJoint.Param arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_412(IntPtr method, IntPtr ptr, HingeJoint.Param arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_413(IntPtr method, IntPtr ptr, HingeJoint.Flag arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_414(IntPtr method, IntPtr ptr, HingeJoint.Flag arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_2_415(IntPtr method, IntPtr ptr, string arg1, IP.Type arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_416(IntPtr method, IntPtr ptr, string arg1, IP.Type arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IP.ResolverStatus godot_icall_1_417(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Image.Format godot_icall_0_418(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_419(IntPtr method, IntPtr ptr, Image.Format arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_420(IntPtr method, IntPtr ptr, int arg1, int arg2, Image.Interpolation arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_421(IntPtr method, IntPtr ptr, int arg1, int arg2, bool arg3, Image.Format arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_422(IntPtr method, IntPtr ptr, int arg1, int arg2, bool arg3, Image.Format arg4, byte[] arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Image.AlphaMode godot_icall_0_423(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_424(IntPtr method, IntPtr ptr, Image.CompressMode arg1, Image.CompressSource arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_425(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, ref Vector2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_426(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, ref Rect2 arg3, ref Vector2 arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Image godot_icall_1_427(IntPtr method, IntPtr ptr, ref Rect2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_428(IntPtr method, IntPtr ptr, int arg1, int arg2, ref Color arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_429(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_1_430(IntPtr method, IntPtr ptr, byte[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_431(IntPtr method, IntPtr ptr, int arg1, int arg2, Image.Format arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_432(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_433(IntPtr method, IntPtr ptr, ImageTexture.StorageEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ImageTexture.StorageEnum godot_icall_0_434(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_435(IntPtr method, IntPtr ptr, Mesh.PrimitiveType arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_436(IntPtr method, IntPtr ptr, ref Plane arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_437(IntPtr method, IntPtr ptr, int arg1, int arg2, float arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_438(IntPtr method, IntPtr ptr, int arg1, bool arg2, string arg3, string arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_439(IntPtr method, IntPtr ptr, int arg1, float arg2, float arg3, float arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_440(IntPtr method, IntPtr ptr, Input.MouseMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Input.MouseMode godot_icall_0_441(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_442(IntPtr method, IntPtr ptr, IntPtr arg1, Input.CursorShape arg2, ref Vector2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_443(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static InputEvent godot_icall_2_444(IntPtr method, IntPtr ptr, ref Transform2D arg1, ref Vector2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_445(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_1_446(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_447(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_1_448(IntPtr method, IntPtr ptr, bool arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_449(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_450(IntPtr method, IntPtr ptr, IntPtr arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_451(IntPtr method, IntPtr ptr, int arg1, ref Rect2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_452(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_453(IntPtr method, IntPtr ptr, int arg1, object arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_454(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_455(IntPtr method, IntPtr ptr, ItemList.SelectModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ItemList.SelectModeEnum godot_icall_0_456(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_457(IntPtr method, IntPtr ptr, ItemList.IconModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ItemList.IconModeEnum godot_icall_0_458(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_459(IntPtr method, IntPtr ptr, ref Vector2 arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VScrollBar godot_icall_0_460(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_0_461(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_462(IntPtr method, IntPtr ptr, Error arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_463(IntPtr method, IntPtr ptr, object arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_464(IntPtr method, IntPtr ptr, string arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static KinematicCollision godot_icall_1_465(IntPtr method, IntPtr ptr, ref Vector3 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_5_466(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, float arg3, int arg4, float arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_467(IntPtr method, IntPtr ptr, ref Transform arg1, ref Vector3 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_468(IntPtr method, IntPtr ptr, PhysicsServer.BodyAxis arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_469(IntPtr method, IntPtr ptr, PhysicsServer.BodyAxis arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static KinematicCollision godot_icall_1_470(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static KinematicCollision2D godot_icall_1_471(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_5_472(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, float arg3, int arg4, float arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_473(IntPtr method, IntPtr ptr, ref Transform2D arg1, ref Vector2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static KinematicCollision2D godot_icall_1_474(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Object godot_icall_0_475(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_476(IntPtr method, IntPtr ptr, Label.AlignEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Label.AlignEnum godot_icall_0_477(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_478(IntPtr method, IntPtr ptr, Label.VAlign arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Label.VAlign godot_icall_0_479(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_480(IntPtr method, IntPtr ptr, ref Vector2 arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_481(IntPtr method, IntPtr ptr, Light.Param arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_482(IntPtr method, IntPtr ptr, Light.Param arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_483(IntPtr method, IntPtr ptr, Light.BakeMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Light.BakeMode godot_icall_0_484(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_485(IntPtr method, IntPtr ptr, Light2D.ModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Light2D.ModeEnum godot_icall_0_486(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_487(IntPtr method, IntPtr ptr, Light2D.ShadowFilterEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Light2D.ShadowFilterEnum godot_icall_0_488(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static OccluderPolygon2D godot_icall_0_489(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_490(IntPtr method, IntPtr ptr, Line2D.LineTextureMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Line2D.LineTextureMode godot_icall_0_491(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_492(IntPtr method, IntPtr ptr, Line2D.LineJointMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Line2D.LineJointMode godot_icall_0_493(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_494(IntPtr method, IntPtr ptr, Line2D.LineCapMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Line2D.LineCapMode godot_icall_0_495(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_496(IntPtr method, IntPtr ptr, LineEdit.AlignEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static LineEdit.AlignEnum godot_icall_0_497(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PopupMenu godot_icall_0_498(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_499(IntPtr method, IntPtr ptr, LinkButton.UnderlineMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static LinkButton.UnderlineMode godot_icall_0_500(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_501(IntPtr method, IntPtr ptr, float arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Mesh godot_icall_1_502(IntPtr method, IntPtr ptr, float arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TriangleMesh godot_icall_0_503(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_2_504(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_1_505(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_506(IntPtr method, IntPtr ptr, int arg1, ref Plane arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_507(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_508(IntPtr method, IntPtr ptr, int arg1, int[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_509(IntPtr method, IntPtr ptr, int arg1, float[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float[] godot_icall_1_510(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Mesh godot_icall_0_511(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_512(IntPtr method, IntPtr ptr, int arg1, object[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Mesh godot_icall_1_513(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NavigationMesh godot_icall_1_514(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_515(IntPtr method, IntPtr ptr, MultiMesh.ColorFormatEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static MultiMesh.ColorFormatEnum godot_icall_0_516(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_517(IntPtr method, IntPtr ptr, MultiMesh.TransformFormatEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static MultiMesh.TransformFormatEnum godot_icall_0_518(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static MultiMesh godot_icall_0_519(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_3_520(IntPtr method, IntPtr ptr, IntPtr arg1, ref Transform arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_3_521(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_522(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Object godot_icall_1_523(IntPtr method, IntPtr ptr, ref Vector3 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_3_524(IntPtr method, IntPtr ptr, IntPtr arg1, ref Transform2D arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector2[] godot_icall_3_525(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Object godot_icall_1_526(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NavigationMesh godot_icall_0_527(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_528(IntPtr method, IntPtr ptr, Vector2[] arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_529(IntPtr method, IntPtr ptr, int arg1, Vector2[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector2[] godot_icall_1_530(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NavigationPolygon godot_icall_0_531(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_4_532(IntPtr method, IntPtr ptr, int arg1, int arg2, int arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_4_533(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_534(IntPtr method, IntPtr ptr, NetworkedMultiplayerENet.CompressionModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NetworkedMultiplayerENet.CompressionModeEnum godot_icall_0_535(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_536(IntPtr method, IntPtr ptr, NetworkedMultiplayerPeer.TransferModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NetworkedMultiplayerPeer.TransferModeEnum godot_icall_0_537(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NetworkedMultiplayerPeer.ConnectionStatus godot_icall_0_538(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_539(IntPtr method, IntPtr ptr, NinePatchRect.AxisStretchMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NinePatchRect.AxisStretchMode godot_icall_0_540(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_541(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Node godot_icall_1_542(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_543(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Node godot_icall_1_544(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Node godot_icall_3_545(IntPtr method, IntPtr ptr, string arg1, bool arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_1_546(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_1_547(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_548(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_549(IntPtr method, IntPtr ptr, string arg1, object[] arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_550(IntPtr method, IntPtr ptr, Node.PauseModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Node.PauseModeEnum godot_icall_0_551(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SceneTree godot_icall_0_552(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Viewport godot_icall_0_553(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_554(IntPtr method, IntPtr ptr, string arg1, Node.RPCMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_555(IntPtr method, IntPtr ptr, string arg1, object[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_556(IntPtr method, IntPtr ptr, int arg1, string arg2, object[] arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_557(IntPtr method, IntPtr ptr, int arg1, string arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_558(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_559(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_560(IntPtr method, IntPtr ptr, IntPtr arg1, object arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_561(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Reference godot_icall_0_562(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_563(IntPtr method, IntPtr ptr, string arg1, object[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_564(IntPtr method, IntPtr ptr, string arg1, object[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_5_565(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2, string arg3, object[] arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_566(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2, string arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_3_567(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2, string arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_568(IntPtr method, IntPtr ptr, OccluderPolygon2D.CullModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static OccluderPolygon2D.CullModeEnum godot_icall_0_569(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_570(IntPtr method, IntPtr ptr, OmniLight.ShadowMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static OmniLight.ShadowMode godot_icall_0_571(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_572(IntPtr method, IntPtr ptr, OmniLight.ShadowDetail arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static OmniLight.ShadowDetail godot_icall_0_573(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_574(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_2_575(IntPtr method, IntPtr ptr, string arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_1_576(IntPtr method, IntPtr ptr, bool arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_1_577(IntPtr method, IntPtr ptr, object arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_1_578(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Node godot_icall_1_579(IntPtr method, IntPtr ptr, PackedScene.GenEditState arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SceneState godot_icall_0_580(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_581(IntPtr method, IntPtr ptr, int arg1, string arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_582(IntPtr method, IntPtr ptr, Particles.DrawOrderEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Particles.DrawOrderEnum godot_icall_0_583(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_584(IntPtr method, IntPtr ptr, Particles2D.DrawOrderEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Particles2D.DrawOrderEnum godot_icall_0_585(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_586(IntPtr method, IntPtr ptr, ParticlesMaterial.Parameter arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_587(IntPtr method, IntPtr ptr, ParticlesMaterial.Parameter arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_588(IntPtr method, IntPtr ptr, ParticlesMaterial.Parameter arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Texture godot_icall_1_589(IntPtr method, IntPtr ptr, ParticlesMaterial.Parameter arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_590(IntPtr method, IntPtr ptr, ParticlesMaterial.Flags arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_591(IntPtr method, IntPtr ptr, ParticlesMaterial.Flags arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_592(IntPtr method, IntPtr ptr, ParticlesMaterial.EmissionShapeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ParticlesMaterial.EmissionShapeEnum godot_icall_0_593(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static CurveTexture godot_icall_0_594(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static GradientTexture godot_icall_0_595(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Curve3D godot_icall_0_596(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Curve2D godot_icall_0_597(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_598(IntPtr method, IntPtr ptr, PathFollow.RotationModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PathFollow.RotationModeEnum godot_icall_0_599(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_600(IntPtr method, IntPtr ptr, Performance.Monitor arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Physics2DDirectSpaceState godot_icall_0_601(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_4_602(IntPtr method, IntPtr ptr, ref Vector2 arg1, int arg2, object[] arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_4_603(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, object[] arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_2_604(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_1_605(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_1_606(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_607(IntPtr method, IntPtr ptr, IntPtr arg1, object arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Physics2DServer.ShapeType godot_icall_1_608(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_609(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_610(IntPtr method, IntPtr ptr, IntPtr arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_611(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_612(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.SpaceParameter arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_613(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.SpaceParameter arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Physics2DDirectSpaceState godot_icall_1_614(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_615(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_1_616(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_617(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.AreaSpaceOverrideMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Physics2DServer.AreaSpaceOverrideMode godot_icall_1_618(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_619(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, ref Transform2D arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_620(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_621(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, ref Transform2D arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_622(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_623(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_2_624(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_625(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_626(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_627(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_628(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.AreaParameter arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_629(IntPtr method, IntPtr ptr, IntPtr arg1, ref Transform2D arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_630(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.AreaParameter arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_631(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_632(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, string arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_633(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.BodyMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Physics2DServer.BodyMode godot_icall_1_634(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_635(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_636(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_637(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.CCDMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Physics2DServer.CCDMode godot_icall_1_638(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_639(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.BodyParameter arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_640(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.BodyParameter arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_641(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.BodyState arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_642(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.BodyState arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_643(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, ref Vector2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_644(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_645(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, string arg3, object arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_5_646(IntPtr method, IntPtr ptr, IntPtr arg1, ref Transform2D arg2, ref Vector2 arg3, float arg4, IntPtr arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Physics2DDirectBodyState godot_icall_1_647(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_648(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.JointParam arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_649(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.JointParam arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_3_650(IntPtr method, IntPtr ptr, ref Vector2 arg1, IntPtr arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_5_651(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, ref Vector2 arg3, IntPtr arg4, IntPtr arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_4_652(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, IntPtr arg3, IntPtr arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_653(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.DampedStringParam arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_654(IntPtr method, IntPtr ptr, IntPtr arg1, Physics2DServer.DampedStringParam arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Physics2DServer.JointType godot_icall_1_655(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_656(IntPtr method, IntPtr ptr, Physics2DServer.ProcessInfo arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_657(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PhysicsDirectSpaceState godot_icall_0_658(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_4_659(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, object[] arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_2_660(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector3 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_1_661(IntPtr method, IntPtr ptr, PhysicsServer.ShapeType arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PhysicsServer.ShapeType godot_icall_1_662(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_663(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.SpaceParameter arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_664(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.SpaceParameter arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PhysicsDirectSpaceState godot_icall_1_665(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_666(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.AreaSpaceOverrideMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PhysicsServer.AreaSpaceOverrideMode godot_icall_1_667(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_668(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, ref Transform arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_669(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, ref Transform arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_670(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_671(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.AreaParameter arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_672(IntPtr method, IntPtr ptr, IntPtr arg1, ref Transform arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_673(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.AreaParameter arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_674(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_2_675(IntPtr method, IntPtr ptr, PhysicsServer.BodyMode arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_676(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.BodyMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PhysicsServer.BodyMode godot_icall_1_677(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_678(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.BodyParameter arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_679(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.BodyParameter arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_680(IntPtr method, IntPtr ptr, IntPtr arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_681(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_682(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.BodyState arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_683(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.BodyState arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_684(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector3 arg2, ref Vector3 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_685(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector3 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_686(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.BodyAxis arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_687(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.BodyAxis arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PhysicsDirectBodyState godot_icall_1_688(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_4_689(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector3 arg2, IntPtr arg3, ref Vector3 arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_690(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.PinJointParam arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_691(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.PinJointParam arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_692(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_4_693(IntPtr method, IntPtr ptr, IntPtr arg1, ref Transform arg2, IntPtr arg3, ref Transform arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_694(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.HingeJointParam arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_695(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.HingeJointParam arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_696(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.HingeJointFlag arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_697(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.HingeJointFlag arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_698(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.SliderJointParam arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_699(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.SliderJointParam arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_700(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.ConeTwistJointParam arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_2_701(IntPtr method, IntPtr ptr, IntPtr arg1, PhysicsServer.ConeTwistJointParam arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PhysicsServer.JointType godot_icall_1_702(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_703(IntPtr method, IntPtr ptr, IntPtr arg1, Vector3.Axis arg2, PhysicsServer.G6DOFJointAxisParam arg3, float arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_3_704(IntPtr method, IntPtr ptr, IntPtr arg1, Vector3.Axis arg2, PhysicsServer.G6DOFJointAxisParam arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_705(IntPtr method, IntPtr ptr, IntPtr arg1, Vector3.Axis arg2, PhysicsServer.G6DOFJointAxisFlag arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_3_706(IntPtr method, IntPtr ptr, IntPtr arg1, Vector3.Axis arg2, PhysicsServer.G6DOFJointAxisFlag arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_707(IntPtr method, IntPtr ptr, PhysicsServer.ProcessInfo arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_708(IntPtr method, IntPtr ptr, PinJoint.Param arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_709(IntPtr method, IntPtr ptr, PinJoint.Param arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_710(IntPtr method, IntPtr ptr, Vector2[] arg1, int[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector2[] godot_icall_2_711(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_712(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, int arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_713(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_714(IntPtr method, IntPtr ptr, string arg1, string arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_715(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, int arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_716(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_717(IntPtr method, IntPtr ptr, int arg1, IntPtr arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ShortCut godot_icall_1_718(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_719(IntPtr method, IntPtr ptr, ProceduralSky.TextureSizeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ProceduralSky.TextureSizeEnum godot_icall_0_720(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_721(IntPtr method, IntPtr ptr, ProximityGroup.DispatchModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ProximityGroup.DispatchModeEnum godot_icall_0_722(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_723(IntPtr method, IntPtr ptr, ReflectionProbe.UpdateModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ReflectionProbe.UpdateModeEnum godot_icall_0_724(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static RegExMatch godot_icall_3_725(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_3_726(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_5_727(IntPtr method, IntPtr ptr, string arg1, string arg2, bool arg3, int arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_728(IntPtr method, IntPtr ptr, object arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_729(IntPtr method, IntPtr ptr, object arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Resource godot_icall_1_730(IntPtr method, IntPtr ptr, bool arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Resource godot_icall_0_731(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Resource godot_icall_1_732(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_733(IntPtr method, IntPtr ptr, RichTextLabel.Align arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_734(IntPtr method, IntPtr ptr, RichTextLabel.ListType arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_735(IntPtr method, IntPtr ptr, int arg1, bool arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_736(IntPtr method, IntPtr ptr, RigidBody.ModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static RigidBody.ModeEnum godot_icall_0_737(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_738(IntPtr method, IntPtr ptr, RigidBody2D.ModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static RigidBody2D.ModeEnum godot_icall_0_739(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_740(IntPtr method, IntPtr ptr, RigidBody2D.CCDMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static RigidBody2D.CCDMode godot_icall_0_741(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_742(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_3_743(IntPtr method, IntPtr ptr, ref Vector2 arg1, float arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_2_744(IntPtr method, IntPtr ptr, int arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static PackedScene godot_icall_1_745(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string[] godot_icall_1_746(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SceneTreeTimer godot_icall_2_747(IntPtr method, IntPtr ptr, float arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_748(IntPtr method, IntPtr ptr, SceneTree.StretchMode arg1, SceneTree.StretchAspect arg2, ref Vector2 arg3, float arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_4_749(IntPtr method, IntPtr ptr, int arg1, string arg2, string arg3, object[] arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_750(IntPtr method, IntPtr ptr, int arg1, string arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_751(IntPtr method, IntPtr ptr, int arg1, string arg2, string arg3, object arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_752(IntPtr method, IntPtr ptr, string arg1, string arg2, object[] arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NetworkedMultiplayerPeer godot_icall_0_753(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Script godot_icall_0_754(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Shader.Mode godot_icall_0_758(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Texture godot_icall_1_759(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Shader godot_icall_0_760(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_3_761(IntPtr method, IntPtr ptr, ref Transform2D arg1, IntPtr arg2, ref Transform2D arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_5_762(IntPtr method, IntPtr ptr, ref Transform2D arg1, ref Vector2 arg2, IntPtr arg3, ref Transform2D arg4, ref Vector2 arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_763(IntPtr method, IntPtr ptr, ref Transform2D arg1, IntPtr arg2, ref Transform2D arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_5_764(IntPtr method, IntPtr ptr, ref Transform2D arg1, ref Vector2 arg2, IntPtr arg3, ref Transform2D arg4, ref Vector2 arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static InputEvent godot_icall_0_765(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_766(IntPtr method, IntPtr ptr, int arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_767(IntPtr method, IntPtr ptr, Sky.RadianceSizeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Sky.RadianceSizeEnum godot_icall_0_768(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_769(IntPtr method, IntPtr ptr, SliderJoint.Param arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_1_770(IntPtr method, IntPtr ptr, SliderJoint.Param arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Spatial godot_icall_0_771(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static World godot_icall_0_772(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialGizmo godot_icall_0_773(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_774(IntPtr method, IntPtr ptr, ref Vector3 arg1, float arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_775(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, ref Vector3 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_776(IntPtr method, IntPtr ptr, SpatialMaterial.DetailUV arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.DetailUV godot_icall_0_777(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_778(IntPtr method, IntPtr ptr, SpatialMaterial.BlendMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.BlendMode godot_icall_0_779(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_780(IntPtr method, IntPtr ptr, SpatialMaterial.DepthDrawMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.DepthDrawMode godot_icall_0_781(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_782(IntPtr method, IntPtr ptr, SpatialMaterial.CullMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.CullMode godot_icall_0_783(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_784(IntPtr method, IntPtr ptr, SpatialMaterial.DiffuseMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.DiffuseMode godot_icall_0_785(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_786(IntPtr method, IntPtr ptr, SpatialMaterial.SpecularMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.SpecularMode godot_icall_0_787(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_788(IntPtr method, IntPtr ptr, SpatialMaterial.Flags arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_789(IntPtr method, IntPtr ptr, SpatialMaterial.Flags arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_790(IntPtr method, IntPtr ptr, SpatialMaterial.Feature arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_791(IntPtr method, IntPtr ptr, SpatialMaterial.Feature arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_792(IntPtr method, IntPtr ptr, SpatialMaterial.TextureParam arg1, IntPtr arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Texture godot_icall_1_793(IntPtr method, IntPtr ptr, SpatialMaterial.TextureParam arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_794(IntPtr method, IntPtr ptr, SpatialMaterial.BillboardMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.BillboardMode godot_icall_0_795(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_796(IntPtr method, IntPtr ptr, SpatialMaterial.EmissionOperatorEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.EmissionOperatorEnum godot_icall_0_797(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_798(IntPtr method, IntPtr ptr, SpatialMaterial.TextureChannel arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpatialMaterial.TextureChannel godot_icall_0_799(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static LineEdit godot_icall_0_800(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_801(IntPtr method, IntPtr ptr, SplitContainer.DraggerVisibilityEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SplitContainer.DraggerVisibilityEnum godot_icall_0_802(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_803(IntPtr method, IntPtr ptr, Vector3.Axis arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3.Axis godot_icall_0_804(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_805(IntPtr method, IntPtr ptr, SpriteBase3D.DrawFlags arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_806(IntPtr method, IntPtr ptr, SpriteBase3D.DrawFlags arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_807(IntPtr method, IntPtr ptr, SpriteBase3D.AlphaCutMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static SpriteBase3D.AlphaCutMode godot_icall_0_808(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_809(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Texture godot_icall_2_810(IntPtr method, IntPtr ptr, string arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_811(IntPtr method, IntPtr ptr, string arg1, int arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_1_812(IntPtr method, IntPtr ptr, byte[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static StreamPeerBuffer godot_icall_0_813(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_814(IntPtr method, IntPtr ptr, IntPtr arg1, bool arg2, string arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static StreamPeerSSL.Status godot_icall_0_815(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static StreamPeerTCP.Status godot_icall_0_816(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_817(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Rect2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_818(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_819(IntPtr method, IntPtr ptr, int arg1, int arg2, int arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_820(IntPtr method, IntPtr ptr, Corner arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_821(IntPtr method, IntPtr ptr, Corner arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_822(IntPtr method, IntPtr ptr, float arg1, float arg2, float arg3, float arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_823(IntPtr method, IntPtr ptr, StyleBoxTexture.AxisStretchMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static StyleBoxTexture.AxisStretchMode godot_icall_0_824(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_825(IntPtr method, IntPtr ptr, Mesh.PrimitiveType arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_6_826(IntPtr method, IntPtr ptr, Vector3[] arg1, Vector2[] arg2, Color[] arg3, Vector2[] arg4, Vector3[] arg5, object[] arg6);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_827(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, ref Transform arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ArrayMesh godot_icall_2_828(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_2_829(IntPtr method, IntPtr ptr, int arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static StreamPeerTCP godot_icall_0_830(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Control godot_icall_1_831(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_832(IntPtr method, IntPtr ptr, TabContainer.TabAlignEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TabContainer.TabAlignEnum godot_icall_0_833(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Popup godot_icall_0_834(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_835(IntPtr method, IntPtr ptr, Tabs.TabAlignEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Tabs.TabAlignEnum godot_icall_0_836(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_837(IntPtr method, IntPtr ptr, Tabs.CloseButtonDisplayPolicy arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Tabs.CloseButtonDisplayPolicy godot_icall_0_838(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_839(IntPtr method, IntPtr ptr, int arg1, bool arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int[] godot_icall_4_840(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_841(IntPtr method, IntPtr ptr, string arg1, string arg2, ref Color arg3, bool arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_842(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, ref Color arg3, bool arg4, IntPtr arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_6_843(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, bool arg3, ref Color arg4, bool arg5, IntPtr arg6);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_7_844(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, ref Rect2 arg3, ref Color arg4, bool arg5, IntPtr arg6, bool arg7);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Image godot_icall_0_845(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_846(IntPtr method, IntPtr ptr, TextureButton.StretchModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static BitMap godot_icall_0_847(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TextureButton.StretchModeEnum godot_icall_0_848(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_849(IntPtr method, IntPtr ptr, TextureRect.StretchModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TextureRect.StretchModeEnum godot_icall_0_850(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_851(IntPtr method, IntPtr ptr, string arg1, string arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_852(IntPtr method, IntPtr ptr, string arg1, string arg2, ref Color arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Font godot_icall_0_853(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TileSet godot_icall_0_854(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_855(IntPtr method, IntPtr ptr, TileMap.ModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TileMap.ModeEnum godot_icall_0_856(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_857(IntPtr method, IntPtr ptr, TileMap.HalfOffset arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TileMap.HalfOffset godot_icall_0_858(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_859(IntPtr method, IntPtr ptr, TileMap.TileOrigin arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TileMap.TileOrigin godot_icall_0_860(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_7_861(IntPtr method, IntPtr ptr, int arg1, int arg2, int arg3, bool arg4, bool arg5, bool arg6, ref Vector2 arg7);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_862(IntPtr method, IntPtr ptr, ref Vector2 arg1, int arg2, bool arg3, bool arg4, bool arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_863(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_864(IntPtr method, IntPtr ptr, ref Vector2 arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_865(IntPtr method, IntPtr ptr, int arg1, TileSet.BitmaskMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TileSet.BitmaskMode godot_icall_1_866(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ShaderMaterial godot_icall_1_867(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_868(IntPtr method, IntPtr ptr, int arg1, int arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_869(IntPtr method, IntPtr ptr, int arg1, int arg2, ref Transform2D arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_870(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_871(IntPtr method, IntPtr ptr, int arg1, IntPtr arg2, ref Transform2D arg3, bool arg4, ref Vector2 arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static NavigationPolygon godot_icall_1_872(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static OccluderPolygon2D godot_icall_1_873(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_874(IntPtr method, IntPtr ptr, Timer.TimerProcessMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Timer.TimerProcessMode godot_icall_0_875(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_876(IntPtr method, IntPtr ptr, TouchScreenButton.VisibilityModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TouchScreenButton.VisibilityModeEnum godot_icall_0_877(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Object godot_icall_2_878(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TreeItem godot_icall_0_879(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TreeItem godot_icall_1_880(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_881(IntPtr method, IntPtr ptr, Tree.SelectModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Tree.SelectModeEnum godot_icall_0_882(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_883(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TreeItem godot_icall_1_884(IntPtr method, IntPtr ptr, ref Vector2 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_885(IntPtr method, IntPtr ptr, int arg1, TreeItem.TreeCellMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TreeItem.TreeCellMode godot_icall_1_886(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_887(IntPtr method, IntPtr ptr, int arg1, float arg2, float arg3, float arg4, bool arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_1_888(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_889(IntPtr method, IntPtr ptr, int arg1, IntPtr arg2, string arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_890(IntPtr method, IntPtr ptr, int arg1, ref Color arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_891(IntPtr method, IntPtr ptr, int arg1, IntPtr arg2, int arg3, bool arg4, string arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Texture godot_icall_2_892(IntPtr method, IntPtr ptr, int arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_893(IntPtr method, IntPtr ptr, int arg1, TreeItem.TextAlign arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TreeItem.TextAlign godot_icall_1_894(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_895(IntPtr method, IntPtr ptr, Tween.TweenProcessMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Tween.TweenProcessMode godot_icall_0_896(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_2_897(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_8_898(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, object arg3, object arg4, float arg5, Tween.TransitionType arg6, Tween.EaseType arg7, float arg8);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_8_899(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, object arg3, object arg4, float arg5, Tween.TransitionType arg6, Tween.EaseType arg7, float arg8);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_8_900(IntPtr method, IntPtr ptr, IntPtr arg1, float arg2, string arg3, object arg4, object arg5, object arg6, object arg7, object arg8);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_9_901(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, object arg3, IntPtr arg4, IntPtr arg5, float arg6, Tween.TransitionType arg7, Tween.EaseType arg8, float arg9);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_9_902(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, object arg3, IntPtr arg4, string arg5, float arg6, Tween.TransitionType arg7, Tween.EaseType arg8, float arg9);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_9_903(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, IntPtr arg3, IntPtr arg4, object arg5, float arg6, Tween.TransitionType arg7, Tween.EaseType arg8, float arg9);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_9_904(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, IntPtr arg3, string arg4, object arg5, float arg6, Tween.TransitionType arg7, Tween.EaseType arg8, float arg9);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_905(IntPtr method, IntPtr ptr, string arg1, UndoRedo.MergeMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_906(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, object[] arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_907(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VideoStream godot_icall_0_908(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_909(IntPtr method, IntPtr ptr, bool arg1, ref Vector2 arg2, ref Vector2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_910(IntPtr method, IntPtr ptr, Viewport.ClearMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Viewport.ClearMode godot_icall_0_911(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_912(IntPtr method, IntPtr ptr, Viewport.UpdateMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Viewport.UpdateMode godot_icall_0_913(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_914(IntPtr method, IntPtr ptr, Viewport.MSAA arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Viewport.MSAA godot_icall_0_915(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_916(IntPtr method, IntPtr ptr, Viewport.UsageEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Viewport.UsageEnum godot_icall_0_917(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_918(IntPtr method, IntPtr ptr, Viewport.DebugDrawEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Viewport.DebugDrawEnum godot_icall_0_919(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_920(IntPtr method, IntPtr ptr, Viewport.RenderInfo arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ViewportTexture godot_icall_0_921(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Camera godot_icall_0_922(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_923(IntPtr method, IntPtr ptr, int arg1, Viewport.ShadowAtlasQuadrantSubdiv arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Viewport.ShadowAtlasQuadrantSubdiv godot_icall_1_924(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_925(IntPtr method, IntPtr ptr, VisibilityEnabler.Enabler arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_926(IntPtr method, IntPtr ptr, VisibilityEnabler.Enabler arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_927(IntPtr method, IntPtr ptr, VisibilityEnabler2D.Enabler arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_928(IntPtr method, IntPtr ptr, VisibilityEnabler2D.Enabler arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_929(IntPtr method, IntPtr ptr, string arg1, int arg2, IntPtr arg3, ref Vector2 arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptNode godot_icall_2_930(IntPtr method, IntPtr ptr, string arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_931(IntPtr method, IntPtr ptr, string arg1, int arg2, ref Vector2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_932(IntPtr method, IntPtr ptr, string arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_933(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_4_934(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_935(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3, int arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_5_936(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3, int arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_937(IntPtr method, IntPtr ptr, string arg1, Dictionary<object, object> arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_1_938(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_939(IntPtr method, IntPtr ptr, string arg1, Variant.Type arg2, string arg3, int arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_940(IntPtr method, IntPtr ptr, string arg1, int arg2, Variant.Type arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Variant.Type godot_icall_2_941(IntPtr method, IntPtr ptr, string arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_942(IntPtr method, IntPtr ptr, string arg1, int arg2, string arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_943(IntPtr method, IntPtr ptr, Variant.Type arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Variant.Type godot_icall_0_944(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_945(IntPtr method, IntPtr ptr, VisualScriptBuiltinFunc.BuiltinFunc arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptBuiltinFunc.BuiltinFunc godot_icall_0_946(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_947(IntPtr method, IntPtr ptr, VisualScriptFunctionCall.CallModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptFunctionCall.CallModeEnum godot_icall_0_948(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_949(IntPtr method, IntPtr ptr, VisualScriptFunctionCall.RPCCallMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptFunctionCall.RPCCallMode godot_icall_0_950(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_951(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, object[] arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_952(IntPtr method, IntPtr ptr, object[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_953(IntPtr method, IntPtr ptr, VisualScriptInputAction.ModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptInputAction.ModeEnum godot_icall_0_954(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_955(IntPtr method, IntPtr ptr, VisualScriptMathConstant.MathConstant arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptMathConstant.MathConstant godot_icall_0_956(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScript godot_icall_0_957(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_958(IntPtr method, IntPtr ptr, Variant.Operator arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Variant.Operator godot_icall_0_959(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_960(IntPtr method, IntPtr ptr, VisualScriptPropertyGet.CallMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptPropertyGet.CallMode godot_icall_0_961(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_962(IntPtr method, IntPtr ptr, VisualScriptPropertySet.CallMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptPropertySet.CallMode godot_icall_0_963(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_964(IntPtr method, IntPtr ptr, VisualScriptPropertySet.AssignOpEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptPropertySet.AssignOpEnum godot_icall_0_965(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_966(IntPtr method, IntPtr ptr, VisualScriptYield.YieldMode arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptYield.YieldMode godot_icall_0_967(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_968(IntPtr method, IntPtr ptr, VisualScriptYieldSignal.CallModeEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualScriptYieldSignal.CallModeEnum godot_icall_0_969(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_2_970(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_971(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, int arg3, Image.Format arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_972(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, VisualServer.CubeMapSide arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Image godot_icall_2_973(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.CubeMapSide arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Image.Format godot_icall_1_974(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_975(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_976(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_977(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_978(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_1_979(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_980(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_2_981(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_982(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_983(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_984(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.PrimitiveType arg2, object[] arg3, object[] arg4, int arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_985(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.BlendShapeMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualServer.BlendShapeMode godot_icall_1_986(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_987(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static byte[] godot_icall_2_988(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_2_989(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static VisualServer.PrimitiveType godot_icall_2_990(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_991(IntPtr method, IntPtr ptr, IntPtr arg1, int arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_992(IntPtr method, IntPtr ptr, IntPtr arg1, ref AABB arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_1_993(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_994(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_995(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.ViewportUpdateMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_996(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.ViewportClearMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_997(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.ViewportMSAA arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_998(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.ViewportUsage arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_2_999(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.ViewportRenderInfo arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_1000(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.ViewportDebugDraw arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_1001(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, ref Vector2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_1002(IntPtr method, IntPtr ptr, IntPtr arg1, ref Color arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_1003(IntPtr method, IntPtr ptr, IntPtr arg1, bool arg2, ref Rect2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_6_1004(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, ref Vector2 arg3, ref Color arg4, float arg5, bool arg6);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_5_1005(IntPtr method, IntPtr ptr, IntPtr arg1, Vector2[] arg2, Color[] arg3, float arg4, bool arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_1006(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, ref Color arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_1007(IntPtr method, IntPtr ptr, IntPtr arg1, ref Vector2 arg2, float arg3, ref Color arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_7_1008(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, IntPtr arg3, bool arg4, ref Color arg5, bool arg6, IntPtr arg7);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_8_1009(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, IntPtr arg3, ref Rect2 arg4, ref Color arg5, bool arg6, IntPtr arg7, bool arg8);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_11_1010(IntPtr method, IntPtr ptr, IntPtr arg1, ref Rect2 arg2, ref Rect2 arg3, IntPtr arg4, ref Vector2 arg5, ref Vector2 arg6, VisualServer.NinePatchAxisMode arg7, VisualServer.NinePatchAxisMode arg8, bool arg9, ref Color arg10, IntPtr arg11);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_7_1011(IntPtr method, IntPtr ptr, IntPtr arg1, Vector2[] arg2, Color[] arg3, Vector2[] arg4, IntPtr arg5, float arg6, IntPtr arg7);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_7_1012(IntPtr method, IntPtr ptr, IntPtr arg1, Vector2[] arg2, Color[] arg3, Vector2[] arg4, IntPtr arg5, IntPtr arg6, bool arg7);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_8_1013(IntPtr method, IntPtr ptr, IntPtr arg1, int[] arg2, Vector2[] arg3, Color[] arg4, Vector2[] arg5, IntPtr arg6, int arg7, IntPtr arg8);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_1014(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, IntPtr arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_6_1015(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, IntPtr arg3, IntPtr arg4, int arg5, int arg6);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_1016(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.CanvasLightMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_1017(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.CanvasLightShadowFilter arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_1018(IntPtr method, IntPtr ptr, IntPtr arg1, Vector2[] arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_1019(IntPtr method, IntPtr ptr, IntPtr arg1, Vector2[] arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_2_1020(IntPtr method, IntPtr ptr, IntPtr arg1, VisualServer.CanvasOccluderPolygonCullMode arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_4_1021(IntPtr method, IntPtr ptr, IntPtr arg1, IntPtr arg2, IntPtr arg3, IntPtr arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_1022(IntPtr method, IntPtr ptr, VisualServer.RenderInfo arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static IntPtr godot_icall_3_1023(IntPtr method, IntPtr ptr, int arg1, int arg2, float arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_3_1024(IntPtr method, IntPtr ptr, IntPtr arg1, ref Color arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_1_1025(IntPtr method, IntPtr ptr, VisualServer.Features arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static TextureButton godot_icall_0_1026(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static XMLParser.NodeType godot_icall_0_1027(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_1_1028(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_2_1029(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_2_1030(IntPtr method, IntPtr ptr, string arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_2_1031(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_1032(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, object arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_3_1033(IntPtr method, IntPtr ptr, string arg1, string arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string[] godot_icall_2_1034(IntPtr method, IntPtr ptr, string arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_2_1035(IntPtr method, IntPtr ptr, bool arg1, bool arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static MainLoop godot_icall_0_1036(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Object godot_icall_1_1037(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_1038(IntPtr method, IntPtr ptr, string arg1, int arg2, byte[] arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_1039(IntPtr method, IntPtr ptr, string arg1, int arg2, string arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_1040(IntPtr method, IntPtr ptr, string arg1, int arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static byte[] godot_icall_1_1041(IntPtr method, IntPtr ptr, int arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_1_1042(IntPtr method, IntPtr ptr, ref Vector3 arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_4_1043(IntPtr method, IntPtr ptr, float arg1, float arg2, int arg3, Vector3.Axis arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object[] godot_icall_5_1044(IntPtr method, IntPtr ptr, float arg1, float arg2, int arg3, int arg4, Vector3.Axis arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static float godot_icall_4_1045(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, ref Vector2 arg3, float arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_4_1046(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, ref Vector2 arg3, ref Vector2 arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector2[] godot_icall_4_1047(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, ref Vector2 arg3, ref Vector2 arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_4_1048(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, ref Vector3 arg3, ref Vector3 arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_1049(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, ref Vector2 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_3_1050(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, ref Vector3 arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static object godot_icall_5_1051(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, ref Vector3 arg3, ref Vector3 arg4, ref Vector3 arg5);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_4_1052(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, ref Vector3 arg3, float arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_4_1053(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, float arg3, float arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_3_1054(IntPtr method, IntPtr ptr, ref Vector3 arg1, ref Vector3 arg2, object[] arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static bool godot_icall_4_1055(IntPtr method, IntPtr ptr, ref Vector2 arg1, ref Vector2 arg2, ref Vector2 arg3, ref Vector2 arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int[] godot_icall_1_1056(IntPtr method, IntPtr ptr, Vector2[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector2[] godot_icall_1_1057(IntPtr method, IntPtr ptr, Vector2[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Vector3[] godot_icall_2_1058(IntPtr method, IntPtr ptr, Vector3[] arg1, ref Plane arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Dictionary<object, object> godot_icall_1_1059(IntPtr method, IntPtr ptr, Vector2[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_3_1060(IntPtr method, IntPtr ptr, object arg1, string arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static JSONParseResult godot_icall_1_1061(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_1062(IntPtr method, IntPtr ptr, byte[] arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static byte[] godot_icall_1_1063(IntPtr method, IntPtr ptr, string arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static void godot_icall_1_1064(IntPtr method, IntPtr ptr, OS.ScreenOrientationEnum arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static OS.ScreenOrientationEnum godot_icall_0_1065(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_4_1066(IntPtr method, IntPtr ptr, string arg1, string[] arg2, bool arg3, object[] arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static int godot_icall_1_1067(IntPtr method, IntPtr ptr, Dictionary<object, object> arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string godot_icall_1_1068(IntPtr method, IntPtr ptr, OS.SystemDir arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_4_1069(IntPtr method, IntPtr ptr, string arg1, float arg2, string arg3, string arg4);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static OS.PowerState godot_icall_0_1070(IntPtr method, IntPtr ptr);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static ResourceInteractiveLoader godot_icall_2_1071(IntPtr method, IntPtr ptr, string arg1, string arg2);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Resource godot_icall_3_1072(IntPtr method, IntPtr ptr, string arg1, string arg2, bool arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_3_1073(IntPtr method, IntPtr ptr, string arg1, IntPtr arg2, int arg3);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static string[] godot_icall_1_1074(IntPtr method, IntPtr ptr, IntPtr arg1);
        [MethodImpl(MethodImplOptions.InternalCall)]
        internal extern static Error godot_icall_4_1075(IntPtr method, IntPtr ptr, IntPtr arg1, string arg2, object arg3, int arg4);
    }
}
